function bubbleSeries() {//jshint ignore:line
  var that = this;
  /**
   * Map data from JSON Tuple to Highchart
   * @override
   * @param {object} component - Reference to component
   * @param {string} type - type of the chart
   * @param {object} defaultValue - HighCharts values
   * @return {Array} seriesNames
   */
  that.createSeriesData = function(component, type, defaultValue) {
    var aggrigationType = component.chartaggregation() || "sum";
      component["bubblelegend_array"] = [];
      if (type == 'bubble') {
        var isCFApplied = false;
        var arrayCompare = function(arrA, arrB) {
          //check if lengths are different
          if (arrA.length !== arrB.length) {
            return false;
          }

          for (var i = 0; i < arrA.length; i++) {
            if (arrA[i] !== arrB[i]) {
              return false;
            }
          }

          return true;
        };

        var measureColorPair;
        if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
          measureColorPair = JSON.parse(component.measurecolorpair());
        }

        var seriesColor = component.dataseriescolor().split(',');
        //var count = 0;
       

        var measures = [];
        for (var i = 0; i < component.dataRes.dimensions.length; i++) {
          if (component.dataRes.dimensions[i].containsMeasures === true) {
            for (var j = 0; j < component.dataRes.dimensions[i].members.length; j++) {
              measures.push(component.dataRes.dimensions[i].members[j].text);
            }
          }
        }

        if (component.chartmeasurechange() !== undefined && component.chartmeasurechange() !== '' && component.chartmeasurechange() !== null && measures == component.measurechange()) {
          var xaxisname = component.chartmeasurechange().split('=');
          var measureKeys = xaxisname[xaxisname.length - 1].split(',');
          for (var i = 0; i < component.dataRes.dimensions.length; i++) {
            if (component.dataRes.dimensions[i].containsMeasures === true) {
              for (var j = 0; j < component.dataRes.dimensions[i].members.length; j++) {
                if (xaxisname[measureKeys.indexOf(component.dataRes.dimensions[i].members[j].key)] !== '') {
                  component.dataRes.dimensions[i].members[j].text = xaxisname[measureKeys.indexOf(component.dataRes.dimensions[i].members[j].key)];
                }
              }
            }
          }
        }

        var measureJson = JSON.parse(component.getMeasureJson());
        var selectedMeasureIndex = [];
     
       

     
        if (component.datautility() !== true) {
          if (component.keyfigureLength < 3) {
            noData = 1;//jshint ignore:line
          } else if (!component.isDimensionAvailable) {
            noData = 2;//jshint ignore:line
          } else {
            if (component.xaxismeasure() !== null && component.xaxismeasure() !== undefined && component.xaxismeasure() !== '' && measureJson[component.xaxismeasure()]) {
              selectedMeasureIndex[0] = measureJson[component.xaxismeasure()].index;
            } else {
              component.xaxismeasure(component.dataRes.dimensions[component.keyfigureIndex].members[0].key);
            }

            if (component.yaxismeasure() !== null && component.yaxismeasure() !== undefined && component.yaxismeasure() !== '' && measureJson[component.yaxismeasure()]) {
              selectedMeasureIndex[1] = measureJson[component.yaxismeasure()].index;
            } else {
              component.yaxismeasure(component.dataRes.dimensions[component.keyfigureIndex].members[1].key);
            }

            if (component.zaxismeasure() !== null && component.zaxismeasure() !== undefined && component.zaxismeasure() !== '' && measureJson[component.zaxismeasure()]) {
              selectedMeasureIndex[2] = measureJson[component.zaxismeasure()].index;
            } else {
              component.zaxismeasure(component.dataRes.dimensions[component.keyfigureIndex].members[2].key);
            }
          }
        
        }
        var rowSelected = [];
          for (var i = 0; i < component.dataRes.dimensions.length; i++) {
          if (component.dataRes.dimensions[i].axis == 'ROWS' && component.dataRes.dimensions[i].containsMeasures !== true) {
            rowSelected.push({index:i});          
            if(!component.showtotaldatabase() && component.datautility() !== true){
              break;
            }
          }
        }

        var sortedarray = [];
        var selectedDimension = component.dataRes["axis_columns"][0].indexOf(-1);
        var ddselectedDimension = 0;
          if(component.xaxismeasure() === component.yaxismeasure()){
             component.yaxismeasure("");
          }
           if(component.xaxismeasure() === component.zaxismeasure()){
              component.zaxismeasure("");
          }
           if(component.zaxismeasure() === component.yaxismeasure()){
              component.zaxismeasure("");
          }

          if (component.xaxismeasure() === null || component.xaxismeasure() === undefined || component.xaxismeasure() === '' || !measureJson[component.xaxismeasure()]) {
            noData = 3;//jshint ignore:line
          } else if (component.yaxismeasure() === null || component.yaxismeasure() === undefined || component.yaxismeasure() === '' || !measureJson[component.yaxismeasure()]) {
            noData = 4;//jshint ignore:line
          } else if (component.zaxismeasure() === null || component.zaxismeasure() === undefined || component.zaxismeasure() === '' || !measureJson[component.zaxismeasure()]) {
            noData = 5;//jshint ignore:line
          }else {
            var ruleInfo = {};
            if (component.ruletable() !== undefined && component.ruletable() !== '') {
              that.updateRuleInfo(component, 'bubble');
              ruleInfo = JSON.parse(component.ruletable());
            }

            $.each(ruleInfo, function() {
              isCFApplied = true;
            });

            var axisLabelArray = [];
            selectedMeasureIndex[0] = measureJson[component.xaxismeasure()].index;
            selectedMeasureIndex[1] = measureJson[component.yaxismeasure()].index;
            selectedMeasureIndex[2] = measureJson[component.zaxismeasure()].index;
            axisLabelArray.push(measureJson[component.xaxismeasure()].text);
            axisLabelArray.push(measureJson[component.yaxismeasure()].text);
            axisLabelArray.push(measureJson[component.zaxismeasure()].text);
            var tempselectedMeasureIndex = [];
            tempselectedMeasureIndex[0] = component.keyfigureIndex + ':' + selectedMeasureIndex[0];
            tempselectedMeasureIndex[1] = component.keyfigureIndex + ':' + selectedMeasureIndex[1];
            tempselectedMeasureIndex[2] = component.keyfigureIndex + ':' + selectedMeasureIndex[2];
            var columnSelected = [];
            columnSelected = columnSelected.concat(tempselectedMeasureIndex);
            component.columnSelected = columnSelected;
            var selectedRowIndexArray = [];
            $.each(rowSelected, function(key, value) {
              selectedRowIndexArray.push(value.index);
            });

            //var conditionalFormatingIndex = [];
           var rowSelLength = rowSelected.length;
            //------------------------------------------------------------------------===============================================
            var rowResultIndex = [];
             if(!component.showtotaldatabase()){
            for (var i = 0; i < component.dataRes.dimensions.length; i++) {
              if (component.dataRes.dimensions[i].axis == 'ROWS') {
                var memberlength = component.dataRes.dimensions[i].members.length;
                for (var j = 0; j < memberlength; j++) {
                  if (component.dataRes.dimensions[i].members[j].type == 'RESULT') {
                    var resultObject = {};
                    resultObject.resultIndex = i + '-' + j;
                    rowResultIndex.push(resultObject);
                  }
                }
              }
            }
          }

            selectedDimension = rowSelected[0].index;
            ddselectedDimension = rowSelected[rowSelLength - 1].index;
            component.categoriesIndex = {};
            component.categoriesIndex['Level1'] = component.dataRes.dimensions[selectedDimension].key;
            component.categoriesIndex['Level2'] = component.dataRes.dimensions[ddselectedDimension].key;
            var resultCountIndex = -1;
            var unitvalx;
            var unitvaly;
            var unitvalz;
            if (component.showunit()) {
              if (component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[0]].unitOfMeasure !== '' && component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[0]].unitOfMeasure !== undefined) {
                unitvalx = ' (in ' + component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[0]].unitOfMeasure + ')';
              }else {
                unitvalx = '';
              }

              if (component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[1]].unitOfMeasure !== '' && component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[1]].unitOfMeasure !== undefined) {
                unitvaly = ' (in ' + component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[1]].unitOfMeasure + ')';
              }else {
                unitvaly = '';
              }

              if (component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[2]].unitOfMeasure !== '' && component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[2]].unitOfMeasure !== undefined) {
                unitvalz = ' (in ' + component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[2]].unitOfMeasure + ')';
              }else {
                unitvalz = '';
              }
            }else {
              unitvalx = '';
              unitvaly = '';
              unitvalz = '';
            }

            component.xAxisLabel = axisLabelArray[0];
            component.yAxisLabel = axisLabelArray[1];
            component.zAxisLabel = axisLabelArray[2];
         
            if (component.swapaxes()) {
              var tempXLabel = component.xAxisLabel;
              component.xAxisLabel = component.yAxisLabel;
              component.yAxisLabel = tempXLabel;
            }
            var xScale = component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[0]].scalingFactor;
            var yScale = component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[1]].scalingFactor;
            var zScale = component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[2]].scalingFactor;

            xScale = xScale <= 0? 0 : xScale;//jshint ignore:line
            yScale = yScale <= 0? 0 : yScale;//jshint ignore:line
            zScale = zScale <= 0? 0 : zScale;//jshint ignore:line

            component.xAxisScalingFactor = Math.pow(10, xScale);
            component.yAxisScalingFactor = Math.pow(10, yScale);
            component.zAxisScalingFactor = Math.pow(10, zScale);

            component.xAxisunit = component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[0]].unitOfMeasure;
            component.yAxisunit = component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[1]].unitOfMeasure;
            component.zAxisunit = component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[2]].unitOfMeasure;

            if (isNaN(component.xAxisScalingFactor)) {
              component.xAxisScalingFactor = 1;
            }

            if (isNaN(component.yAxisScalingFactor)) {
              component.yAxisScalingFactor = 1;
            }

            if (isNaN(component.zAxisScalingFactor)) {
              component.zAxisScalingFactor = 1;
            }

            var looplength = component.dataRes.dimensions[rowSelected[0].index].members.length;
            for (var i = 0; i < looplength; i++) {
              if (component.dataRes.dimensions[rowSelected[0].index].members[i].type != 'RESULT' || component.showtotaldatabase()) {
                var seriesObj = {};
                if (component.trendlineenable !== undefined) {
                  seriesObj.regression = component.trendlineenable();
                }

                seriesObj.regressionSettings = {};
                /*
                 *Declaring trendline Array .
                 *We cannot define over here because the trendline works only if series{}.Data length is more than 1.
                 */
                seriesObj["dimension_key"] = component.dataRes.dimensions[rowSelected[0].index].members[i].key;
                seriesObj.name = component.dataRes.dimensions[rowSelected[0].index].members[i].text;

                seriesObj.data = [];
                sortedarray[i - (resultCountIndex != -1 && resultCountIndex < i ? 1 : 0)] = seriesObj;
                var MemberText = component.dataRes.dimensions[rowSelected[0].index].members[i].text;
                component.categoriesIndex[MemberText] = component.dataRes.dimensions[rowSelected[0].index].members[i].key;
              } else {
                if (component.dataRes.dimensions[rowSelected[0].index].members.length - 1 != i) {
                  resultCountIndex = i;
                }
              }
            }

            var isResultRow = function(rowIndexArray, rowResultIndex) {
              if(component.showtotaldatabase()){
               return false;
            }
              for (var i = 0; i < rowResultIndex.length; i++) {
                var indexArray = rowResultIndex[i].resultIndex.toString().split('-');
                if (rowIndexArray[indexArray[0]] == indexArray[1]) {
                  return true;
                }
              }

              return false;
            };

            var isResultTuples = function(tupleArray) {
              if(component.showtotaldatabase()){
               return false;
            }
              for (var i = 0; i < tupleArray.length; i++) {
                if (component.dataRes.dimensions[i].members[tupleArray[i]].type == 'RESULT') {
                  return true;
                }
              }

              return false;
            };
             var isResultTuplesOfTotal= function(tupleArray) {           
           for (var i = 0; i < tupleArray.length; i++) {
              if (component.dataRes.dimensions[i].members[tupleArray[i]].type == 'RESULT') {
                return true;
              }
            }
            return false;
           
          };
          var totalX = [];
          var totalY = [];
          var totalZ = [];
            var addedRow = [];
            //Separating conditonal formating array
           // try{
            for (var rowIndex = 0; rowIndex < component.dataRes["axis_rows"].length; rowIndex++) {
             if (!isResultRow(component.dataRes["axis_rows"][rowIndex], rowResultIndex)) {
                var seriesIndex = component.dataRes["axis_rows"][rowIndex][rowSelected[0].index];
                var rowCheck = [];
                var pointName = '';
                var pointKey = [];
                var pointIndex = [];
               // var isResultObject = false;
                for (var i = 0; i < rowSelLength; i++) {
                  rowCheck.push(component.dataRes["axis_rows"][rowIndex][rowSelected[i].index]);
                  if (i > 0) {
                    pointName = pointName + '/' + component.dataRes.dimensions[rowSelected[i].index].members[component.dataRes["axis_rows"][rowIndex][rowSelected[i].index]].text;
                  }

                  pointIndex.push(rowSelected[i].index + ':' + component.dataRes["axis_rows"][rowIndex][rowSelected[i].index]);
                  pointKey.push(component.dataRes.dimensions[rowSelected[i].index].members[component.dataRes["axis_rows"][rowIndex][rowSelected[i].index]].key);
                }

                var categoryPointName = component.dataRes.dimensions[rowSelected[rowSelected.length - 1].index].members[component.dataRes["axis_rows"][rowIndex][rowSelected[rowSelected.length - 1].index]].text;
                component.categoriesIndex[categoryPointName] = component.dataRes.dimensions[rowSelected[rowSelected.length - 1].index].members[component.dataRes["axis_rows"][rowIndex][rowSelected[rowSelected.length - 1].index]].key;
                pointName = pointName.substring(1);
                //pointIndex = pointIndex.substring(1);
                var isRowExist = false;
                var rowUpdateIndex = 0;
                for (var i = 0; i < addedRow.length; i++) {
                  if (arrayCompare(addedRow[i].rowCheck, rowCheck)) {
                    isRowExist = true;
                    rowUpdateIndex = addedRow[i].index;
                  }
                }

                var columnCount = component.dataRes.columnCount;
                var columnMaxIndex = (rowIndex + 1) * columnCount;
                var x = [];
                var y = [];
                var z = [];
                for (var columnIndex = rowIndex * columnCount; columnIndex < columnMaxIndex; columnIndex++) {
                  if (/*component.dataRes.data[columnIndex] === null ||*/ isResultTuples(component.dataRes.tuples[columnIndex])) {
                    continue;
                  }

                  if (component.dataRes.tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[0]) {
                    x.push(component.dataRes.data[columnIndex]);
                  }

                  if (component.dataRes.tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[1]) {
                    y.push(component.dataRes.data[columnIndex]);
                  }

                  if (component.dataRes.tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[2]) {
                    z.push(component.dataRes.data[columnIndex]);
                  }
                  if(component.showtotal()&& !isResultTuplesOfTotal(component.dataRes.tuples[columnIndex])){
                     if (component.dataRes.tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[0]) {
                       totalX.push(component.dataRes.data[columnIndex]);
                     }
                    if (component.dataRes.tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[1]) {
                       totalY.push(component.dataRes.data[columnIndex]);
                    }   
                    if (component.dataRes.tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[2]) {
                       totalZ.push(component.dataRes.data[columnIndex]);
                    }                   
                 }
                }

                if (!isRowExist) {
                  var rowCheckObject = {};
                  rowCheckObject.rowCheck = rowCheck;
                  rowCheckObject.index = sortedarray[seriesIndex - (resultCountIndex < seriesIndex && resultCountIndex != -1 ? 1 : 0)].data.length;
                  addedRow.push(rowCheckObject);
                  var rowObject = {};
                  rowObject.name = pointName;
                  rowObject.key = pointKey;
                  rowObject.rowIndex = pointIndex.join('-');
                  rowObject.x = x;
                  rowObject.y = y;
                  rowObject.z = z;
                  sortedarray[seriesIndex - (resultCountIndex < seriesIndex && resultCountIndex != -1 ? 1 : 0)].data.push(rowObject);
                } else {
                  var updateRowObject = {};
                  updateRowObject = sortedarray[seriesIndex - (resultCountIndex < seriesIndex && resultCountIndex != -1 ? 1 : 0)].data[rowUpdateIndex];
                  updateRowObject.name = pointName;
                  updateRowObject.key = pointKey;
                  updateRowObject.rowIndex = pointIndex.join('-');
                  updateRowObject.x = updateRowObject.x.concat(x);
                  updateRowObject.y = updateRowObject.y.concat(y);
                  updateRowObject.z = updateRowObject.z.concat(z);
                  sortedarray[seriesIndex - (resultCountIndex < seriesIndex && resultCountIndex != -1 ? 1 : 0)].data[rowUpdateIndex] = updateRowObject;
                }

                if (measureColorPair && measureColorPair[sortedarray[seriesIndex - (resultCountIndex < seriesIndex && resultCountIndex != -1 ? 1 : 0)].name] !== undefined) {
                  sortedarray[seriesIndex - (resultCountIndex < seriesIndex && resultCountIndex != -1 ? 1 : 0)].color = measureColorPair[sortedarray[seriesIndex - (resultCountIndex < seriesIndex && resultCountIndex != -1 ? 1 : 0)].name].color;
                } else {
                  sortedarray[seriesIndex - (resultCountIndex < seriesIndex && resultCountIndex != -1 ? 1 : 0)].color = seriesColor[seriesIndex - (resultCountIndex < seriesIndex && resultCountIndex != -1 ? 1 : 0)];
                }
              }
          
            }

            for (var i = 0; i < sortedarray.length; i++) {
              if (component.trendlineenable !== undefined) {
                if (component.trendlineenable()) {
                  if (sortedarray[i].data.length <= 1) {
                    sortedarray[i].regression = false;
                  } else {
                    sortedarray[i].regression = true;
                    if (!component.trendlineequation()) {
                      sortedarray[i].regressionSettings = {
                        type: 'linear',
                        color: sortedarray[i].color,
                        name: 'Linear Trendline-' + sortedarray[i].name
                      };
                    } else {
                      sortedarray[i].regressionSettings = {
                        type: 'linear',
                        color: sortedarray[i].color
                      };
                    }
                  }
                }
              }

              for (var j = 0; j < sortedarray[i].data.length; j++) {
                sortedarray[i].key = columnSelected.join('-');
                sortedarray[i].data[j].x = that.aggregateArray(sortedarray[i].data[j].x,aggrigationType);
                sortedarray[i].data[j].y = that.aggregateArray(sortedarray[i].data[j].y,aggrigationType);
                sortedarray[i].data[j].z = that.aggregateArray(sortedarray[i].data[j].z,aggrigationType);
             
                if (component.swapaxes()) {
                  var tempX = sortedarray[i].data[j].x;
                  sortedarray[i].data[j].x = sortedarray[i].data[j].y;
                  sortedarray[i].data[j].y = tempX;
                }

                component["bubblelegend_array"].push(sortedarray[i].data[j].z);
                if (component.trendlineenable !== undefined) {
                  if (component.trendlineenable() === true && sortedarray[i].regression === true) {
                    if (sortedarray[i].data[j].x === 0 || sortedarray[i].data[j].y === 0 || sortedarray[i].data[j].z === 0) {
                      sortedarray[i].regression = false; // break;
                    }
                  }
                }
              }
            }
             if(component.showtotal() === true) {
              var totalX = totalX.reduce(function(a, b) {
                return a + b;
              });
               var totalY = totalY.reduce(function(a, b) {
                return a + b;
              });
                var totalZ = totalZ.reduce(function(a, b) {
                return a + b;
              });
                if (measureColorPair && measureColorPair['Total Result'] !== undefined) {
                seriesColor[sortedarray.length] = measureColorPair['Total Result'].color;
              }   
              var rowObject = {};
                rowObject.name = "";
                rowObject.key = "Total Result";
                rowObject.rowIndex = 0;
                rowObject.x = totalX;
                rowObject.y = totalY;
                rowObject.z = totalZ;

                var seriesOBJ = {};
                seriesOBJ.key = columnSelected.join('-');
                seriesOBJ.name = "Total Result";
                seriesOBJ["dimension_key"] = "Total Result";
                seriesOBJ["dimension_index"] = sortedarray.length;
                seriesOBJ["data"]= [rowObject];
               seriesOBJ["color"] = seriesColor[sortedarray.length];
               sortedarray.push(seriesOBJ);
         }

            if (component.legendenable()) {
              component["bubblelegend_array"].sort(function(a, b) {
                return Number(a) - Number(b);
              });

              var halfLength = Math.floor(component["bubblelegend_array"].length / 2);
              if(!component._chartcontainertypenative){
                sortedarray[sortedarray.length] = {
                  xAxis: 1,
                  yAxis: 1,
                  data: [{
                    x: 0,
                    y: 3,
                    z: component["bubblelegend_array"][component["bubblelegend_array"].length - 1],
                    color: "rgba(0,64,128,0.5)"
                  }, {
                    x: 0,
                    y: 2,
                    z: component["bubblelegend_array"][halfLength],
                    color: "rgba(0,64,128,0.25)"
                  }, {
                    x: 0,
                    y: 1,
                    z: component["bubblelegend_array"][0],
                    color: "rgba(0,64,128,0.05)"
                  }],
                  dataLabels: {
                    allowOverlap: true,
                    enabled: true,
                    format: '{point.z}',
                    style:{
                      color: component.legenditemstylecolor(),
                      fontSize: component.legenditemfontsize() + 'px',
                      fontWeight: component.legenditemfontweight(),
                      textDecoration: component.legenditemfontweight(),
                      fontFamily: component.globalfont() === true ? component.fontfamily() :component.legenditemfontfamily()
                    },
                    x: 20
                  },
                  enableMouseTracking: false,
                  showInLegend: false
                };
              }

            }

            var seriesData = [{}];
            seriesData = sortedarray;
            if (isCFApplied) {
              that.createCFSeriesData(component, seriesData);
            }

            defaultValue.series = seriesData;
          }
       
      }
   
  };

  that.createCFSeriesData = function(component, originalArray) {
    var aggrigationType = component.chartaggregation() || "sum";
    try{

    function calculateValue(v1, v2, op) {//jshint ignore:line
      switch (op) {
        case '+':
          return v1 + v2;
        case '-':
          return v1 - v2;
        case '*':
          return v1 * v2;
        case '/':
          return v1 / v2;
      }
    }

    var arrayCompare = function(arrA, arrB) {
      //check if lengths are different
      if (arrA.length !== arrB.length) {
        return false;
      }

      for (var i = 0; i < arrA.length; i++) {
        if (arrA[i] !== arrB[i]) {
          return false;
        }
      }

      return true;
    };

  
    var measureJson = JSON.parse(component.getMeasureJson());
    var selectedMeasureIndex = [];
    var rowSelected = [];
    var sortedarray = [];
    var selectedDimension = component.fulljson()["axis_columns"][0].indexOf(-1);

  for (var i = 0; i < component.dataRes.dimensions.length; i++) {
          if (component.dataRes.dimensions[i].axis == 'ROWS' && component.dataRes.dimensions[i].containsMeasures !== true) {
            rowSelected.push({index:i});          
            if(!component.showtotaldatabase() && component.datautility() !== true){
              break;
            }
          }
  }
   
    var ruleInfo = {};
    var isCFApplied = false;
    var isMeasureConFormattingApplied = false;
    if (component.ruletable() !== undefined && component.ruletable() !== '') {
      //  that.updateRuleInfo(component,"bubble");
      ruleInfo = JSON.parse(component.ruletable());
    }

    $.each(ruleInfo, function(k, ruleJson) {
      isCFApplied = true;
      var ruleType = ruleJson['cfui-ruleType'];
      switch (ruleType) {
        case 'single_measure':
          isMeasureConFormattingApplied = true;
          break;
        case 'measure_calculation':
          isMeasureConFormattingApplied = true;
          break;
        case 'target_value':
          isMeasureConFormattingApplied = true;
          break;
        case 'dimension':
          break;
      }
    });

    var axisLabelArray = [];
    selectedMeasureIndex[0] = measureJson[component.xaxismeasure()].index;
    selectedMeasureIndex[1] = measureJson[component.yaxismeasure()].index;
    selectedMeasureIndex[2] = measureJson[component.zaxismeasure()].index;
    axisLabelArray.push(measureJson[component.xaxismeasure()].text);
    axisLabelArray.push(measureJson[component.yaxismeasure()].text);
    axisLabelArray.push(measureJson[component.zaxismeasure()].text);
    var tempselectedMeasureIndex = [];
    tempselectedMeasureIndex[0] = component.keyfigureIndex + ':' + selectedMeasureIndex[0];
    tempselectedMeasureIndex[1] = component.keyfigureIndex + ':' + selectedMeasureIndex[1];
    tempselectedMeasureIndex[2] = component.keyfigureIndex + ':' + selectedMeasureIndex[2];
    var columnSelected = [];
    columnSelected = columnSelected.concat(tempselectedMeasureIndex);
    component.columnSelected = columnSelected;
    var selectedRowIndexArray = [];
    $.each(rowSelected, function(key, value) {
      selectedRowIndexArray.push(value.index);
    });

    var rowSelLength = rowSelected.length;
    //------------------------------------------------------------------------===============================================
    var rowResultIndex = [];
    if(!component.showtotaldatabase()){
    for (var i = 0; i < component.fulljson().dimensions.length; i++) {
      if (component.fulljson().dimensions[i].axis == 'ROWS') {
        for (var j = 0; j < component.fulljson().dimensions[i].members.length; j++) {
          if (component.fulljson().dimensions[i].members[j].type == 'RESULT') {
            var resultObject = {};
            resultObject.resultIndex = i + '-' + j;
            rowResultIndex.push(resultObject);
          }
        }
      }
    }
  }

    selectedDimension = rowSelected[0].index;
    var resultCountIndex = -1;
    for (var i = 0; i < component.fulljson().dimensions[rowSelected[0].index].members.length; i++) {
      var seriesObj = {};
      if (component.fulljson().dimensions[rowSelected[0].index].members[i].type != 'RESULT' || component.showtotaldatabase()) {
        /*
         *Declaring trendline Array .
         *We cannot define over here because the trendline works only if series{}.Data length is more than 1.
         */
        seriesObj["dimension_key"] = component.fulljson().dimensions[rowSelected[0].index].members[i].key;
        seriesObj.name = component.fulljson().dimensions[rowSelected[0].index].members[i].text;

        seriesObj.xAxisScalingFactor = Math.pow(10, component.fulljson().dimensions[component.keyfigureIndex].members[selectedMeasureIndex[0]].scalingFactor);
        seriesObj.yAxisScalingFactor = Math.pow(10, component.fulljson().dimensions[component.keyfigureIndex].members[selectedMeasureIndex[1]].scalingFactor);
        seriesObj.zAxisScalingFactor = Math.pow(10, component.fulljson().dimensions[component.keyfigureIndex].members[selectedMeasureIndex[2]].scalingFactor);
        if (isMeasureConFormattingApplied) {
          for (var mIndex = 0; mIndex < component.fulljson().dimensions[component.keyfigureIndex].members.length; mIndex++) {
            var key = component.fulljson().dimensions[component.keyfigureIndex].members[mIndex].key;
            seriesObj[key + 'AxisScalingFactor'] = Math.pow(10, component.fulljson().dimensions[component.keyfigureIndex].members[mIndex].scalingFactor);
            if (isNaN(seriesObj[key + 'AxisScalingFactor'])) {
              seriesObj[key + 'AxisScalingFactor'] = 1;
            }
          }
        }

        if (isNaN(seriesObj.xAxisScalingFactor)) {
          seriesObj.xAxisScalingFactor = 1;
        }

        if (isNaN(seriesObj.yAxisScalingFactor)) {
          seriesObj.yAxisScalingFactor = 1;
        }

        if (isNaN(seriesObj.zAxisScalingFactor)) {
          seriesObj.zAxisScalingFactor = 1;
        }

        seriesObj.data = [];
        sortedarray[i - (resultCountIndex != -1 && resultCountIndex < i ? 1 : 0)] = seriesObj;
       // var MemberText = component.fulljson().dimensions[rowSelected[0].index].members[i].text;
      } else {
        if (component.dataRes.dimensions[rowSelected[0].index].members.length - 1 != i) {
          resultCountIndex = i;
        }
      }
    }

    var isResultRow = function(rowIndexArray, rowResultIndex) {
      if(component.showtotaldatabase()){
               return false;
            }
      for (var i = 0; i < rowResultIndex.length; i++) {
        var indexArray = rowResultIndex[i].resultIndex.toString().split('-');
        if (rowIndexArray[indexArray[0]] == indexArray[1]) {
          return true;
        }
      }

      return false;
    };

    var isResultTuples = function(tupleArray) {
      if(component.showtotaldatabase()){
               return false;
            }
      for (var i = 0; i < tupleArray.length; i++) {
        if (component.fulljson().dimensions[i].members[tupleArray[i]].type == 'RESULT') {
          return true;
        }
      }

      return false;
    };
    var isResultTuplesOfTotal= function(tupleArray) {           
           for (var i = 0; i < tupleArray.length; i++) {
              if (component.fulljson().dimensions[i].members[tupleArray[i]].type == 'RESULT') {
                return true;
              }
            }
            return false;
           
          };
      var totalX = [];
      var totalY = [];
      var totalZ = [];
    var addedRow = [];
    //Separating conditonal formating array
    for (var rowIndex = 0; rowIndex < component.fulljson()["axis_rows"].length; rowIndex++) {
      if (!isResultRow(component.fulljson()["axis_rows"][rowIndex], rowResultIndex)) {
        var seriesIndex = component.fulljson()["axis_rows"][rowIndex][rowSelected[0].index];
        var rowCheck = [];
        var pointName = '';
        var pointKey = [];
        var pointIndex = [];
       // var isResultObject = false;
        for (var i = 0; i < rowSelLength; i++) {
          rowCheck.push(component.fulljson()["axis_rows"][rowIndex][rowSelected[i].index]);
          if (i > 0) {
            pointName = pointName + '/' + component.fulljson().dimensions[rowSelected[i].index].members[component.fulljson()["axis_rows"][rowIndex][rowSelected[i].index]].text;
          }

          pointIndex.push(rowSelected[i].index + ':' + component.fulljson()["axis_rows"][rowIndex][rowSelected[i].index]);
          pointKey.push(component.fulljson().dimensions[rowSelected[i].index].members[component.fulljson()["axis_rows"][rowIndex][rowSelected[i].index]].key);
        }

        var categoryPointName = component.fulljson().dimensions[rowSelected[rowSelected.length - 1].index].members[component.fulljson()["axis_rows"][rowIndex][rowSelected[rowSelected.length - 1].index]].text;
        component.categoriesIndex[categoryPointName] = component.fulljson().dimensions[rowSelected[rowSelected.length - 1].index].members[component.fulljson()["axis_rows"][rowIndex][rowSelected[rowSelected.length - 1].index]].key;
        pointName = pointName.substring(1);
        //pointIndex = pointIndex.substring(1);
        var isRowExist = false;
        var rowUpdateIndex = 0;
        for (var i = 0; i < addedRow.length; i++) {
          if (arrayCompare(addedRow[i].rowCheck, rowCheck)) {
            isRowExist = true;
            rowUpdateIndex = addedRow[i].index;
          }
        }

        var columnCount = component.fulljson().columnCount;
        var columnMaxIndex = (rowIndex + 1) * columnCount;
        var x = [];
        var y = [];
        var z = [];
        var conditionArrayIndexObj = {};
        for (var columnIndex = rowIndex * columnCount; columnIndex < columnMaxIndex; columnIndex++) {
          if (/*component.fulljson().data[columnIndex] === null ||*/ isResultTuples(component.fulljson().tuples[columnIndex])) {
            continue;
          }

          if (component.fulljson().tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[0]) {
            x.push(component.fulljson().data[columnIndex]);
          }

          if (component.fulljson().tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[1]) {
            y.push(component.fulljson().data[columnIndex]);
          }

          if (component.fulljson().tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[2]) {
            z.push(component.fulljson().data[columnIndex]);
          }
           if(component.showtotal()&& !isResultTuplesOfTotal(component.fulljson().tuples[columnIndex])){
                   if (component.fulljson().tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[0]) {
                     totalX.push(component.fulljson().data[columnIndex]);
                   }
                  if (component.fulljson().tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[1]) {
                     totalY.push(component.fulljson().data[columnIndex]);
                  }  
                  if (component.fulljson().tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[2]) {
                     totalZ.push(component.fulljson().data[columnIndex]);
                  }                   
                }


          if (isMeasureConFormattingApplied) {
            var mIndex = component.fulljson().tuples[columnIndex][component.keyfigureIndex];
            if (conditionArrayIndexObj[component.fulljson().dimensions[component.keyfigureIndex].members[mIndex].key] === undefined) {
              conditionArrayIndexObj[component.fulljson().dimensions[component.keyfigureIndex].members[mIndex].key] = [];
            }

            conditionArrayIndexObj[component.fulljson().dimensions[component.keyfigureIndex].members[mIndex].key].push(component.fulljson().data[columnIndex]);
          }
        }

        if (!isRowExist) {
          var rowCheckObject = {};
          rowCheckObject.rowCheck = rowCheck;
          rowCheckObject.index = sortedarray[seriesIndex - (resultCountIndex < seriesIndex && resultCountIndex != -1 ? 1 : 0)].data.length;
          addedRow.push(rowCheckObject);
          var rowObject = {};
          rowObject.name = pointName;
          rowObject.key = pointKey;
          rowObject.rowIndex = pointIndex.join('-');
          rowObject.x = x;
          rowObject.y = y;
          rowObject.z = z;
          if (isMeasureConFormattingApplied) {
            for (var prop in conditionArrayIndexObj) {
              rowObject[prop] = conditionArrayIndexObj[prop];
            }
          }

          sortedarray[seriesIndex - (resultCountIndex < seriesIndex && resultCountIndex != -1 ? 1 : 0)].data.push(rowObject);
        } else {
          var updateRowObject = {};
          updateRowObject = sortedarray[seriesIndex - (resultCountIndex < seriesIndex && resultCountIndex != -1 ? 1 : 0)].data[rowUpdateIndex];
          updateRowObject.name = pointName;
          updateRowObject.key = pointKey;
          updateRowObject.rowIndex = pointIndex.join('-');
          updateRowObject.x = updateRowObject.x.concat(x);
          updateRowObject.y = updateRowObject.y.concat(y);
          updateRowObject.z = updateRowObject.z.concat(z);
          if (isMeasureConFormattingApplied) {
            for (var prop in conditionArrayIndexObj) {
              updateRowObject[prop] = updateRowObject[prop].concat(conditionArrayIndexObj[prop]);
            }
          }

          sortedarray[seriesIndex - (resultCountIndex < seriesIndex && resultCountIndex != -1 ? 1 : 0)].data[rowUpdateIndex] = updateRowObject;
        }
      }
    }
    if(component.showtotal() === true) {              
              var rowObject = {};
                rowObject.name = "";
                rowObject.key = "Total Result";
                rowObject.rowIndex = 0;
                rowObject.x = totalX;
                rowObject.y = totalY;
                rowObject.z = totalZ;
                var seriesOBJ = {};
                seriesOBJ.name = "Total Result";
                seriesOBJ["dimension_key"] = "Total Result";
                seriesOBJ["dimension_index"] = sortedarray.length;
                seriesOBJ["data"]= [rowObject];             
               sortedarray.push(seriesOBJ);
         }

    for (var i = 0; i < sortedarray.length; i++) {
      for (var j = 0; j < sortedarray[i].data.length; j++) {
        sortedarray[i].key = columnSelected.join('-');
        sortedarray[i].data[j].x = that.aggregateArray(sortedarray[i].data[j].x, aggrigationType);
        sortedarray[i].data[j].y = that.aggregateArray(sortedarray[i].data[j].y, aggrigationType);
        sortedarray[i].data[j].z = that.aggregateArray(sortedarray[i].data[j].z, aggrigationType);
        sortedarray[i].data[j].scalingX = sortedarray[i].data[j].x * sortedarray[i].xAxisScalingFactor;
        sortedarray[i].data[j].scalingY = sortedarray[i].data[j].y * sortedarray[i].yAxisScalingFactor;
        sortedarray[i].data[j].scalingZ = sortedarray[i].data[j].z * sortedarray[i].zAxisScalingFactor;
        if (isMeasureConFormattingApplied) {
          for (var mIndex = 0; mIndex < component.fulljson().dimensions[component.keyfigureIndex].members.length; mIndex++) {
            if (component.fulljson().dimensions[component.keyfigureIndex].members[mIndex].type != 'RESULT' || component.showtotaldatabase()) {
              var key = component.fulljson().dimensions[component.keyfigureIndex].members[mIndex].key;
              sortedarray[i].data[j][key] = that.aggregateArray(sortedarray[i].data[j][key],aggrigationType);
              // if (!component.scalingfactorenable()) {
              sortedarray[i].data[j][key] = sortedarray[i].data[j][key] * sortedarray[i][key + 'AxisScalingFactor'];
              //  }
            }
          }
        }

        // if (!component.scalingfactorenable()) {
        sortedarray[i].data[j].x = sortedarray[i].data[j].scalingX;//== NaN ?0:sortedarray[i].data[j].scalingX;
        sortedarray[i].data[j].y = sortedarray[i].data[j].scalingY;// == NaN ?0:sortedarray[i].data[j].scalingY;
        sortedarray[i].data[j].z = sortedarray[i].data[j].scalingZ;// == NaN ?0:sortedarray[i].data[j].scalingZ;
        // }

        if (isCFApplied) {
          var measureKeys = [
              component.xaxismeasure(),
              component.yaxismeasure(),
              component.zaxismeasure()
          ];
          $.each(ruleInfo, function(k, ruleJson) {
            var ruleType = ruleJson['cfui-ruleType'];
            switch (ruleType) {
              case 'single_measure':
                var staticVal1 = '';
                var point = 0;
                var smOp = ruleJson['cfui-operator'];
                if (measureKeys.indexOf(ruleJson['cfui-highlightedMeasure'].key) > -1) {
                  point = sortedarray[i].data[j][ruleJson['cfui-comparisionMeasure'].key];
                  if (ruleJson['cfui-comparisionValueType'] == 'static') {
                    if (smOp == 'bt') {
                      staticVal1 = [
                          ruleJson['cfui-static_comparisionValue1'],
                          ruleJson['cfui-static_comparisionValue2']
                      ];
                    } else {
                      staticVal1 = ruleJson['cfui-static_comparisionValue1'];
                    }
                  } else if (ruleJson['cfui-dynamicSelectionType'] == 'measure_selection') {
                    if (smOp == 'bt') {
                      staticVal1 = [
                          sortedarray[i].data[j][ruleJson['cfui-dynamic_comparisionValue1'].key],
                          sortedarray[i].data[j][ruleJson['cfui-dynamic_comparisionValue2'].key]
                      ];
                    } else {
                      staticVal1 = [sortedarray[i].data[j][ruleJson['cfui-dynamic_comparisionValue1'].key]];
                    }
                  } else if (ruleJson['cfui-dynamicSelectionType'] == 'cell_selection') {
                    if (smOp == 'bt') {
                      staticVal1 = [
                          VbiUtil.prototype.trendCellSelectionObjToDataValue(component.fulljson(), ruleJson['dynamiccellselection'].key).data,
                          VbiUtil.prototype.trendCellSelectionObjToDataValue(component.fulljson(), ruleJson['dynamiccellselection2'].key).data
                      ];
                    } else {
                      staticVal1 = VbiUtil.prototype.trendCellSelectionObjToDataValue(component.fulljson(), ruleJson['dynamiccellselection'].key).data;
                    }
                  }

                  if (that.checkValues(point, staticVal1, smOp)) {
                    sortedarray[i].data[j].color = ruleJson['inputcondformat'];
                    sortedarray[i].data[j].states = {hover: {color: ruleJson['inputcondformat']}};
                    sortedarray[i].data[j].marker = {
                      fillColor: ruleJson['inputcondformat'],
                      states: {hover: {fillColor: ruleJson['inputcondformat']}}
                    };
                  }
                }

                break;
              case 'measure_calculation':
                if (measureKeys.indexOf(ruleJson['cfui-highlightedMeasure'].key) > -1) {
                  var smOp = ruleJson['cfui-operator'];
                  point = sortedarray[i].data[j][ruleJson['cfui-comparisionMeasure'].key];
                  var StaticVal = calculateValue(sortedarray[i].data[j][ruleJson['cfui-calcMeasure1'].key], sortedarray[i].data[j][ruleJson['cfui-calcMeasure2'].key], ruleJson['cfui-calcOperator']);
                  if (that.checkValues(point, StaticVal, smOp)) {
                    sortedarray[i].data[j].color = ruleJson['inputcondformat'];
                    sortedarray[i].data[j].states = {hover: {color: ruleJson['inputcondformat']}};
                    sortedarray[i].data[j].marker = {
                      fillColor: ruleJson['inputcondformat'],
                      states: {hover: {fillColor: ruleJson['inputcondformat']}}
                    };
                  }
                }

                break;
              case 'target_value':
                if (measureKeys.indexOf(ruleJson['cfui-highlightedMeasure'].key) > -1) {
                  var targetValue;
                  if (ruleJson['cfui-targetValueType'] == 'static') {
                    targetValue = ruleJson['cfui-static_targetValue'];
                  } else if (ruleJson['cfui-dynamicSelectionType'] == 'measure_selection') {
                     targetValue = [sortedarray[i].data[j][ruleJson['cfui-dynamic_targetValue'].key]];
                  } else if (ruleJson['cfui-dynamicSelectionType'] == 'cell_selection') {
                     targetValue = VbiUtil.prototype.trendCellSelectionObjToDataValue(component.fulljson(), ruleJson['dynamiccellselection'].key).data;
                  }

                  var point = sortedarray[i].data[j][ruleJson['cfui-comparisionMeasure'].key];
                  var smOp = 'bt';
                  var targetRules = ruleJson['cfui-targetRules'];
                  for (var tIndex = 0; tIndex < targetRules.length; tIndex++) {
                    var rule = targetRules[tIndex];
                    var from = Number(targetValue) * (Number(rule.from) / 100);
                    var to = Number(targetValue) * (Number(rule.to) / 100);
                    var compValue = [
                        from,
                        to
                    ];
                    if (that.checkValues(point, compValue, smOp)) {
                      sortedarray[i].data[j].color = rule.color;
                      sortedarray[i].data[j].states = {hover: {color: rule.color}};
                      sortedarray[i].data[j].marker = {
                        fillColor: rule.color,
                        states: {hover: {fillColor: rule.color}}
                      };
                    }
                  }
                }

                break;
              case 'dimension':
                if (sortedarray[i].data[j].key.indexOf(ruleJson['cfui-member'].key) > -1) {
                  sortedarray[i].data[j].color = ruleJson['inputcondformat'];
                  sortedarray[i].data[j].states = {hover: {color: ruleJson['inputcondformat']}};
                  sortedarray[i].data[j].marker = {
                    fillColor: ruleJson['inputcondformat'],
                    states: {hover: {fillColor: ruleJson['inputcondformat']}}
                  };
                }

                break;
            }
          });
        }
      }
    }

    for (var oIndex = 0; oIndex < originalArray.length; oIndex++) {
      for (var filteredIndex = 0; filteredIndex < sortedarray.length; filteredIndex++) {
        if (originalArray[oIndex]["dimension_key"] == sortedarray[filteredIndex]["dimension_key"]) {
          for (var oDataIndex = 0; oDataIndex < originalArray[oIndex].data.length; oDataIndex++) {
            for (var filteredDataIndex = 0; filteredDataIndex < sortedarray[filteredIndex].data.length; filteredDataIndex++) {
              if (originalArray[oIndex].data[oDataIndex].key.join('/') == sortedarray[filteredIndex].data[filteredDataIndex].key.join('/')) {
                if (sortedarray[filteredIndex].data[filteredDataIndex].hasOwnProperty('color')) {
                  originalArray[oIndex].data[oDataIndex].color = sortedarray[filteredIndex].data[filteredDataIndex].color;
                  originalArray[oIndex].data[oDataIndex].states = {hover: {color: sortedarray[filteredIndex].data[filteredDataIndex].color}};
                  // originalArray[oIndex].data[oDataIndex].marker ={fillColor:sortedarray[filteredIndex].data[filteredDataIndex].color ,states:{hover:{ fillColor:finalDataArray[filteredIndex].data[filteredDataIndex].color}}}
                  originalArray[oIndex].data[oDataIndex].marker = {
                    states: {
                      hover: {
                        fillColor: sortedarray[filteredIndex].data[filteredDataIndex].color,
                        lineColor: sortedarray[filteredIndex].data[filteredDataIndex].color
                      }
                    }
                  };
                }

                break;
              }
            }
          }

          break;
        }
      }
    }}catch(e){
      
    }
  };

  that.createMeasuresData = function(component, type, defaultValue) {
    //var self = this;
    var seriesColor = component.dataseriescolor().split(',');
    var seriesData = [];
    var sortedarray = [];
    sortedarray[0] = {};
    sortedarray[0].name = 'Measures';
    sortedarray[0].color = seriesColor[0];
    sortedarray[0].data = [];
    seriesData.push({
      x: component.dataRes.data[0],
      y: component.dataRes.data[1],
      z: component.dataRes.data[2]
    });
    sortedarray[0].data = seriesData;
    defaultValue.legend.enabled = false;
    defaultValue.series = sortedarray;
  };
}
