/*jshint loopfunc: true */
function familyBar(args) {// jshint ignore:line
  var that = this;
  this.flag = 0;
  /*
     * *********************************************************************
     * -Template for defining definition in familySeries
     * -All function definition need to be within the scope of familyXYZ
     * -Each definition of property should be based on the validation of
     *  method validateImplementMethod(args, [[function name string]])
     *
     *  Example:
       *  if (validateImplementMethod(args, 'cds')) {
       *    <-- Actual Function definition goes here -->
       *    that.cds = function() {
       *
       *      // Your own implementation starts here either extend or
       *      // write complete new implementation
       *
       *      // var result = SeriesLibrary.prototype.cds.call(that);
       *      // some specific implementation
       *
       *    };
       *  }
     *
     * -If function definition is defined without validateImplementMethod
     *  then particular method is included by default in all components that
     *  include this file!
     * *********************************************************************
     */
  //  alert('[[Executed familyBar]]');
  if (validateImplementMethod(args, 'cds')) {// jshint ignore:line
    that.cds = function() {
      alert('function cds "hasOwnProperty" accessed');  // jshint ignore:line
    };
  }

  if (validateImplementMethod(args, 'createSeriesData')) {// jshint ignore:line
    /**
         * Map data from JSON Tuple to Highchart
         * @param {object} component - Reference to component
         * @param {string} type - type of the chart
         * @param {object} defaultValue - HighCharts values
         * @return {Array} seriesNames
         */
    that.createSeriesData = function(component, type, defaultValue, cfStatus) {
      var self = this;
      //var seriesColor = component.dataseriescolor().split(",");
      component.categoriesIndex = [];
      var measureMarkerPair;
      //var columnCount=0;
      //console.log("Series Data");
      //       alert('overridden');
      /*var DMchange = false;
            var dimName = component.getDimensionAndMeasure();
            if(component.oldDimname=== undefined || component.oldDimname == "")
              component.oldDimname = dimName.toString();
            if(component.oldDimname != dimName.toString())
              {
              DMchange = true;
              if(sap.zen.designmode)
              component.oldDimname = dimName.toString();
              }
*/
      var ruleInfo = '';
      if (cfStatus != 'ncf') {
        if (component.ruletable() !== undefined && component.ruletable() !== '' && component.ruletable() != '{}') {
          that.updateRuleInfo(component, 'bar');
          //alert("ruletable="+component.ruletable());
          ruleInfo = JSON.parse(component.ruletable());
        }
      }

      var noOfColumns = 0;
      //var noOfCellsInRow = 1;
      //var noOfRows = 0;
      var seriesNamesinAdditionalProp = [];
      var measureColorPair;
      var subTotalEnabled = component.showsubtotal();
      var colJsonIndex = {};
      //var updateColors=[];
      var seriesData = [];
      defaultValue.xAxis.categories = [];
      //var xAxisCategories = [];
      if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
        measureColorPair = JSON.parse(component.measurecolorpair());
      }

      if (component.hasOwnProperty('measuremarkerpair')) {

        if (!(component.measuremarkerpair() === undefined || component.measuremarkerpair() === '')) {
          measureMarkerPair = JSON.parse(component.measuremarkerpair());
        }
      }
      //alert("Component.dataRes==="+ JSON.stringify(component.dataRes));
      if (component.dataRes === undefined || component.dataRes === '') {
        return '';
      }

      for (var i = 0; i < component.dataRes.dimensions.length; i++) {
        if (component.dataRes.dimensions[i].axis == 'COLUMNS') {
          noOfColumns++;
          if (component.dataRes.dimensions[i].containsMeasures) {
            var tempMeasure = i;  //Checking measure position
          }
        }
      }

      var selectedColumndimIndexes = [];
      var selectedRowdimIndexes = [];
      var measureDimensionIndex = component.getMeasureIndex();
      var measureInRow = component.dataRes.dimensions[measureDimensionIndex].axis == 'ROWS' ? true : false;
      if (measureInRow) {
        selectedRowdimIndexes.push(measureDimensionIndex);
      } else {
        selectedColumndimIndexes.push(measureDimensionIndex);
      }

      var bardatacustomizationJson = {
        'COLUMNS': [],
        'ROWS': []
      };
      if (component.bardatacustomization() !== '') {
        bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
      }

      /*if (component.datautility() === true && (bardatacustomizationJson['COLUMNS'].length !== 0 || bardatacustomizationJson['ROWS'].length !== 0)) {
        if (bardatacustomizationJson['COLUMNS'].length !== 0) {
          //selectedColumndim=bardatacustomizationJson['COLUMNS'][0].text;
          //selectedColumndimIndexes=selectedColumndimIndexes.concat(bardatacustomizationJson['COLUMNS'][0].index.split("-"));
          $.each(bardatacustomizationJson['COLUMNS'], function(index, value) {
            selectedColumndimIndexes.push(_.parseInt(value.index));
          });
        }

        if (bardatacustomizationJson['ROWS'].length !== 0) {
          $.each(bardatacustomizationJson['ROWS'], function(index, value) {
            selectedRowdimIndexes.push(_.parseInt(value.index));
          });
        } else {
          this.createSmokeScreen(component.$(), 'Please select Dimension in Data Utility');
        }
      } else */if (component.datautility() === true && (bardatacustomizationJson['COLUMNS'].length === 0 && bardatacustomizationJson['ROWS'].length === 0)) {
        this.createSmokeScreen(component.$(), 'Please select Dimension in Data Utility');
      } else {
        for (var i = 0; i < noOfColumns; i++) {
          if (i != measureDimensionIndex) {
            selectedColumndimIndexes.push(i);
          }
        }

        for (var i = noOfColumns; i < component.dataRes.dimensions.length; i++) {
          if (i != measureDimensionIndex) {
            selectedRowdimIndexes.push(i);
          }
        }
      }
      /*var ruleMeasure = false;
            var ruleDimension = false;
            for(var i = 0;i< selectedColumndimIndexes.length;i++)
            {
              if(component.dataRes.dimensions[selectedColumndimIndexes[i]].containsMeasures === true)
                ruleMeasure = true;
              else
                ruleDimension = true;
              //finalCategoryNames//selectedColumndimIndexes
            }*/
      component.selectedColumndimIndexes = selectedColumndimIndexes;
      component.selectedRowdimIndexes = selectedRowdimIndexes;
      var defaultColor = [
        '#B586DA',
        '#FF6657',
        '#F3A730',
        '#946B66',
        '#B0AD53',
        '#7AC1DE',
        '#F1C337',
        '#566C6C',
        '#A1CC54',
        '#543F1E'
      ];
      var seriesColor = [];
      if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
        seriesColor = [];
      } else {
        seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
      }

      var tuplesInArow = component.dataRes.tuples.slice(0, component.dataRes.columnCount);
      // Getting tuples for all Columns in first row of crosstab.
      var colRowIndexJson = {};
      var colNamesJson = {};
      var seriesData = [];
      var scalingValues = [];
      var unitValues = [];
	  var hasResultIntupleCol = {};
	  var showtotaldatabase = component.showtotaldatabase();
	  var datautility = component.datautility();
      component.measureInOriginalSeries = {};
      component.categoryInOriginalSeries = {};
      component.columnInOriginalSeries = {};
      for (var i = 0; i < component.dataRes.dimensions[measureDimensionIndex].members.length; i++) {
        // Scaling
        if (typeof component.dataRes.dimensions[measureDimensionIndex].members[i].scalingFactor == 'undefined') {
          scalingValues.push('');
        } else {
          scalingValues.push(component.scalingfactorenable() === true ? Math.pow(10, component.dataRes.dimensions[measureDimensionIndex].members[i].scalingFactor || '') : '');
        }
        // Unit
        if (typeof component.dataRes.dimensions[measureDimensionIndex].members[i].unitOfMeasure == 'undefined') {
          unitValues.push('');
        } else {
          unitValues.push(component.showunit() === true ? component.dataRes.dimensions[measureDimensionIndex].members[i].unitOfMeasure || '' : '');
        }
      }

      for (var i = 0; i < tuplesInArow.length; i++) {
        var tempTuple = tuplesInArow[i].slice(0, noOfColumns);

        if (self.vbiCharts.eliminateResult(component.dataRes, tempTuple, undefined, component.showtotaldatabase()) === true) {
          var colKey = [];
          var colName = [];
          var ColumnKey = [];
          for (var j = 0; j < selectedColumndimIndexes.length; j++) {
            var tempCol = selectedColumndimIndexes[j];
            colName.push(component.dataRes.dimensions[tempCol].members[tempTuple[tempCol]].text);
            ColumnKey.push(component.dataRes.dimensions[tempCol].members[tempTuple[tempCol]].key);
            colKey.push(tempCol + ':' + tempTuple[tempCol]);
          }

          var newKey = colKey.join('-');
          colName = _.filter(colName, function(x) {              
            return (x != '' && x!= null && x!=" ");
          });
          var seriesName = colName.join('-');
          if (!measureInRow) {
            seriesName = that.formatSeriesName(component, seriesName, measureDimensionIndex + ':' + tempTuple[measureDimensionIndex], {});
          }

          /*if (component.scalingfactorenable() && colName.join('-').indexOf('(* ') == -1) {
            seriesName += (typeof tempTuple[measureDimensionIndex] == 'undefined' || scalingValues[tempTuple[measureDimensionIndex]] === '' ? '' : ' (* ' + scalingValues[tempTuple[measureDimensionIndex]] + ' )');
          }
          if(component.showunit() && colName.join('-').indexOf('(in ') == -1){
            seriesName += (typeof tempTuple[measureDimensionIndex] == 'undefined' || unitValues[tempTuple[measureDimensionIndex]] === '' ? '' : ' (in ' + unitValues[tempTuple[measureDimensionIndex]] + ' )');
          }*/

          if (typeof colRowIndexJson[newKey] == 'undefined') {
            colRowIndexJson[newKey] = [];
            var colorvalue = self.getSeriesColors(component, seriesColor, seriesData.length, defaultColor);
            var markerarray = {
              enabled: true,
              fillColor: self.getSeriesColors(component, seriesColor, seriesData.length, defaultColor)
            };
            if (measureColorPair && measureColorPair[ColumnKey.join('-')] !== undefined) {
              colorvalue = measureColorPair[ColumnKey.join('-')].color;
            }

            if (component.hasOwnProperty('measuremarkerpair')) {
              if (measureMarkerPair && measureMarkerPair[ColumnKey.join('-')] !== undefined) {
                markerarray = {
                  enabled: measureMarkerPair[ColumnKey.join('-')].enabled,
                  radius:parseFloat( measureMarkerPair[ColumnKey.join('-')].size),
                  symbol: measureMarkerPair[ColumnKey.join('-')].symbol,
                  lineColor: component.defaultmarkercolor() === false ? measureMarkerPair[ColumnKey.join('-')].color :  colorvalue,
                  fillColor: component.defaultmarkercolor() === false ? measureMarkerPair[ColumnKey.join('-')].color :  colorvalue,
                  states: {
                    hover: {
                      enabled: measureMarkerPair[ColumnKey.join('-')].hoverenable,
                      radius: parseFloat(measureMarkerPair[ColumnKey.join('-')].size)
                    }
                  }
                };
              }
            }
            /// FOR RADAR AND POLAR CHARTS IF TYPE IS NOT LINE OR AREA DEFAULT SERIES COLOR SHOULD BE APPLIED
            if (component.hasOwnProperty('polarcharttype')) {
              if (component.polarcharttype() == 'column' || component.polarcharttype() == 'bar') {
                markerarray = {
                  enabled: true,
                  fillColor: self.getSeriesColors(component, seriesColor, seriesData.length, defaultColor)
                };
              }
            }

            if (component.hasOwnProperty('radarcharttype')) {
              if (component.radarcharttype() == 'column' || component.radarcharttype() == 'bar') {
                markerarray = {
                  enabled: true,
                  fillColor: self.getSeriesColors(component, seriesColor, seriesData.length, defaultColor)
                };
              }
            }
            // used for storing all the position of particular measure  in the series.
            if (!measureInRow) {
              if (component.measureInOriginalSeries[ColumnKey[0]] === undefined) {
                component.measureInOriginalSeries[ColumnKey[0]] = selectedColumndimIndexes.length > 1 ? {} : seriesData.length;
              }

              if (typeof component.measureInOriginalSeries[ColumnKey[0]] == 'object') {
                component.measureInOriginalSeries[ColumnKey[0]][ColumnKey.slice(1).join('-')] = seriesData.length;
              }
            } else {
              component.columnInOriginalSeries[ColumnKey.join('-')] = seriesData.length;
            }

            if (subTotalEnabled && selectedColumndimIndexes.length > 1) {
              if (colJsonIndex[colKey[0]] === undefined) {
                colJsonIndex[colKey[0]] = [];
              }

              colJsonIndex[colKey[0]].push(seriesData.length);
            }

            if (component.hasOwnProperty('enablemarker') && !component.enablemarker()){
              markerarray = {};
            }
            //added a proprty point placement to avoid scalling error on radar chart
            if (component.hasOwnProperty('radarcharttype') || component.hasOwnProperty('polarcharttype')) {
              if(component.hasOwnProperty('polarcharttype') && (component.polarcharttype() === 'polarcolumn' || component.polarcharttype() === 'polarcolumnstacked') ){
                markerarray={};
              }
              if(component.hasOwnProperty('radarcharttype') && (component.radarcharttype() === 'radarcolumn' || component.radarcharttype() === 'radarcolumnstacked') ){
                markerarray = {};
              }
              seriesData.push({
                name: seriesName,
                key: newKey,
                uniquekey: ColumnKey[0],
                color: colorvalue,
                marker: markerarray,
                data: [],
                regression: component.trendlineenable !== undefined ? component.trendlineenable() : false,
                regressionSettings: {},
                pointPlacement: 'on'
              });
            } else {
              seriesData.push({
                name: seriesName,
                key: newKey,
                uniquekey: ColumnKey[0],
                color: colorvalue,
                marker: markerarray,
                data: [],
                regression: component.trendlineenable !== undefined ? component.trendlineenable() : false,
                regressionSettings: {}
              });
            }
          }

          colRowIndexJson[newKey].push(i);

		  /*#VBX141-4729*/
		  if(datautility && showtotaldatabase){
		  	  hasResultIntupleCol[i] = [];
			  for(var j=0, jLen = tempTuple.length; j<jLen; j++){
				  if(component.dataRes.dimensions[j].members[tempTuple[j]].type == "RESULT"){
					  hasResultIntupleCol[i].push(j);
				  }
			  }
		  }
          colNamesJson[newKey] = seriesName;
        }
      }
      // console.log("seriesData="+JSON.stringify(seriesData));
      //console.log("colNamesJson="+JSON.stringify(colNamesJson));
      /*seriesColor.splice(seriesData.length, seriesColor.length);
      component.dataseriescolor(seriesColor.join());*/

      var tupleToSkip = 0;
      var tuplesInColumn = [];
      var rowNames = {};
      var rowDataJson = {};
	  var rowDataJsonWithInfo = {};


      /*var measureKeyforScaling = [];
            for(var i=0;i<component.dataRes.dimensions.length;i++){
              if(component.dataRes.dimensions[i].containsMeasures === true){
                for(var j=0;j<component.dataRes.dimensions[i].members.length;j++){
                  measureKeyforScaling.push(component.dataRes.dimensions[i].members[j].key);
                }
              }
            }
*/
      //alert("that.dataRes.rowCount="+that.dataRes.rowCount);
      for (var i = 0; i < component.dataRes.rowCount; i++) {
        //rowDataArr.push([]);
        tupleToSkip = component.dataRes.columnCount * i;
        tuplesInColumn.push(component.dataRes.tuples[tupleToSkip]);
        var tempTuple = tuplesInColumn[i];
		/*#VBX141-4729*/
		var hasResultIntuple = [];
		if(datautility && showtotaldatabase){
			for(var j=noOfColumns, tLen = tempTuple.length; j< tLen; j++){
				if(component.dataRes.dimensions[j].members[tempTuple[j]].type == "RESULT"){
					hasResultIntuple.push(tempTuple[j]);
				}
			}
		}

        if (self.vbiCharts.eliminateResult(component.dataRes, tempTuple, 'ROWS', showtotaldatabase) === true) {
          var rowKey = 0;
          var rowHeader = 'Dimensions';
          var rowHeaderKey = 'Dimensions';
          var tempMeasureKey = [];
          if (selectedRowdimIndexes.length >= 1) {
            rowKey = selectedRowdimIndexes[0] + ':' + tempTuple[selectedRowdimIndexes[0]];
            rowHeaderKey = component.dataRes.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].key;
            rowHeader = component.dataRes.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].text;

            if (measureInRow) {
              tempMeasureKey = component.dataRes.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].key;
            }

            for (var j = 1; j < selectedRowdimIndexes.length; j++) {
              //rowKey+=":"+temp_tuple[component.selectedRowIndex[j]];
              rowKey += '-' + selectedRowdimIndexes[j] + ':' + tempTuple[selectedRowdimIndexes[j]];
              // jscs:disable
              // Code here will be ignored by JSCS.
              if(component.dataRes.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].text !== ''){//VBX141-5817
                rowHeader += (rowHeader !=="" ? '\\' : '') + component.dataRes.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].text;
              }
              rowHeaderKey += '\\' + component.dataRes.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].key;  // jscs:enable

            }
            if (measureInRow) {
              rowHeader = self.formatSeriesName(component, rowHeader, selectedRowdimIndexes[0] + ':' + tempTuple[selectedRowdimIndexes[0]], {});
            }
          }

          if (typeof rowNames[rowKey] == 'undefined') {
            //rowDataJson[rowKey]=[];
            rowNames[rowKey] = {
              key: rowHeaderKey,
              text: rowHeader,
              measurekey: tempMeasureKey
            };
            //defaultValuexAxiscategories.push(rowHeader);
            component.categoriesIndex.push(rowKey);
          }

          $.each(colRowIndexJson, function(key, value) {
            $.each(value, function(index, newval) {
				var curIndex = newval + tupleToSkip;
				var keygen = key + '_' + rowKey;
				if (rowDataJson[keygen] === undefined) {
					rowDataJson[keygen] = [];
					rowDataJsonWithInfo[keygen] = [];
				}
				rowDataJson[keygen].push(component.dataRes.data[curIndex]);

				/*#VBX141-4729*/
				if(datautility && showtotaldatabase && (hasResultIntuple.length || hasResultIntupleCol[newval].length)){
					var lastTempStore, lastTempstoreLen = 0;
					var totalLen = hasResultIntupleCol[newval].length + hasResultIntuple.length;
					if(rowDataJsonWithInfo[keygen].length){
						lastTempStore = rowDataJsonWithInfo[keygen][rowDataJsonWithInfo[keygen].length - 1];
						lastTempstoreLen = lastTempStore[0];
					}
					if(lastTempstoreLen < totalLen){
						rowDataJsonWithInfo[keygen].length = 0;
					}

					// save as 2D array of [[totalLen, Data], [totalLen, Data]...]
					rowDataJsonWithInfo[keygen].push([totalLen, (component.dataRes.data[curIndex] === null ? 0 : component.dataRes.data[curIndex])]);
				}

            });
          });
        }
      }

	  /*#VBX141-4729*/
	  if(datautility && showtotaldatabase){
		  $.each(rowDataJsonWithInfo, function(k, v){
			  if(v.length){
				  rowDataJson[k].length = 0;
					for(var i=0, len=v.length; i<len; i++){
						rowDataJson[k].push(Number(v[i][1]));
					}
			  }
		  });
	  }
      //      alert(JSON.stringify(rowNames))
      var categoryDataRowAggr = [];
      var finalCategoryNames = [];
      var finalCategorymeasurekey = [];
      var finalCategoryNamesKeys = [];
      $.each(rowNames, function(key, names) {
        if (measureInRow) {
          // jscs:disable
          // Code here will be ignored by JSCS.
          var rowKeyArr = names.key.split('\\');
          // jscs:enable
          for (var i = 0; i < rowKeyArr.length; i++) {
            if (component.measureInOriginalSeries[rowKeyArr[0]] === undefined) {
              component.measureInOriginalSeries[rowKeyArr[0]] = rowKeyArr.length > 1 ? {} : finalCategoryNames.length;
            }

            if (typeof component.measureInOriginalSeries[rowKeyArr[0]] == 'object') {
              // jscs:disable
              // Code here will be ignored by JSCS.
              component.measureInOriginalSeries[rowKeyArr[0]][rowKeyArr.slice(1).join('\\')] = finalCategoryNames.length;  // jscs:enable
            }
          }
        }

        component.categoryInOriginalSeries[names.key] = finalCategoryNames.length;
        for (var i = 0; i < seriesData.length; i++) {
          var genKey = seriesData[i].key + '_' + key;
          var yVal = that.barValueAggregation(component, rowDataJson[genKey]);
          if (component.hasOwnProperty('measuremarkerpair')) {
            seriesData[i].data.push({
              y: yVal,
              color: seriesData[i].marker.fillColor
            });
          } else {
            seriesData[i].data.push({y: yVal});
          }
        }

        finalCategoryNames.push(names.text);
        finalCategoryNamesKeys.push(names.key);

        if (names.measurekey !== '') {
          finalCategorymeasurekey.push(names.measurekey);
        }

      });
      //console.log("finalCategoryNames="+finalCategoryNames);
      categoryDataRowAggr = seriesData;
      //console.log("seriesData="+JSON.stringify(seriesData));
      that.defaultvalueseriesdata = seriesData;
      component.categoryNames = finalCategoryNames;
      var cfdataCalled = !1;
      //errorbar enable need the complete cfdata
      if (component.hasOwnProperty('errorbarenable')) {
        if (component.errorbarenable() === true) {
          if (component.erroramount() === 'Custom') {
            that.createCFData(component, 'bar', component.fulljson());
            cfdataCalled = !0;
          }
        }
      }
      //Conditional formatting
      //***************New Implementation Conditional Formatting*************
      if (ruleInfo !== '' && cfStatus != 'ncf'  /*&& DMchange === false*/) {
        try {
          if (!cfdataCalled) {
            that.createCFData(component, 'bar', component.fulljson());
          }

          that.processConditionalFormatting(component, categoryDataRowAggr, ruleInfo, 'bar');
        } catch (e) {
        }
      }

     // var totalData = [];
     // var entireData = [];
      var categoryDataRowAggrNew = [];
      if (component.showtotal() === true) {
        for (var i in categoryDataRowAggr) {
          if (categoryDataRowAggrNew[i] === undefined) {
            categoryDataRowAggrNew[i] = [];
          }

          for (var j = 0; j < categoryDataRowAggr[i].data.length; j++) {
            categoryDataRowAggrNew[i].push(categoryDataRowAggr[i].data[j].y);
          }
        }

        for (var k = 0; k < categoryDataRowAggr.length; k++) {
          var total = categoryDataRowAggrNew[k].reduce(function(a, b) {
            return a + b;
          });
          categoryDataRowAggr[k].data.push({y: total});
        }

        finalCategoryNames.push('Total Result');
        finalCategoryNamesKeys.push('Total Result');
      }
      /*
             * Total logic is true
             * Getting the values and addding those values in that same array
             * Adding Total-Result in xaxis catagory
             */
      if (subTotalEnabled && selectedColumndimIndexes.length > 1) {
        // alert(JSON.stringify(measureMarkerPair));
        var tempSeries = [];
        var markerarray = {};
        $.extend(true, tempSeries, categoryDataRowAggr);
        var lastIndex = 0;
        var count = 0;
        $.each(colJsonIndex, function(key, indexes) {
          var colKey = key.split(':');
          //lastIndex= indexes[0] + count;
          lastIndex = type == 'stackchart' ? indexes[0] + count : indexes[indexes.length - 1] + 1 + count;
          count++;
          if (measureColorPair && measureColorPair[component.dataRes.dimensions[colKey[0]].members[colKey[1]].key + '-Result'] !== undefined) {
            colorvalue = measureColorPair[component.dataRes.dimensions[colKey[0]].members[colKey[1]].key + '-Result'].color;
          } else {
            colorvalue = self.getSeriesColors(component, seriesColor, categoryDataRowAggr.length, defaultColor);
          }

          if (component.hasOwnProperty('measuremarkerpair')) {
            if (measureMarkerPair && measureMarkerPair[component.dataRes.dimensions[colKey[0]].members[colKey[1]].key + '-Result'] !== undefined) {
              markerarray = {
                enabled: measureMarkerPair[component.dataRes.dimensions[colKey[0]].members[colKey[1]].key + '-Result'].enabled,
                radius:parseFloat( measureMarkerPair[component.dataRes.dimensions[colKey[0]].members[colKey[1]].key + '-Result'].size),
                symbol: measureMarkerPair[component.dataRes.dimensions[colKey[0]].members[colKey[1]].key + '-Result'].symbol,
                lineColor: component.defaultmarkercolor() === false ? measureMarkerPair[component.dataRes.dimensions[colKey[0]].members[colKey[1]].key + '-Result'].color :  colorvalue,
                fillColor: component.defaultmarkercolor() === false ? measureMarkerPair[component.dataRes.dimensions[colKey[0]].members[colKey[1]].key + '-Result'].color :  colorvalue,
                states: {
                  hover: {
                    enabled: measureMarkerPair[ColumnKey.join('-')].hoverenable,
                    radius: parseFloat(measureMarkerPair[ColumnKey.join('-')].size)
                  }
                }
              };
            }
          }
          /// FOR RADAR AND POLAR CHARTS IF TYPE IS NOT LINE OR AREA DEFAULT SERIES COLOR SHOULD BE APPLIED
          if (component.hasOwnProperty('polarcharttype')) {
            if (component.polarcharttype() == 'column' || component.polarcharttype() == 'bar') {
              markerarray = {
                enabled: true,
                fillColor: self.getSeriesColors(component, seriesColor, seriesData.length, defaultColor)
              };
            }
          }

          if (component.hasOwnProperty('radarcharttype')) {
            if (component.radarcharttype() == 'column' || component.radarcharttype() == 'bar') {
              markerarray = {
                enabled: true,
                fillColor: self.getSeriesColors(component, seriesColor, seriesData.length, defaultColor)
              };
            }
          }

          if (component.hasOwnProperty('enablemarker') && !component.enablemarker()){
              markerarray = {};
          }
          if (tempMeasure === 0) {
            categoryDataRowAggr.splice(lastIndex, 0, {
              name: component.dataRes.dimensions[colKey[0]].members[colKey[1]].text + '-Result',
              keyval: component.dataRes.dimensions[colKey[0]].members[colKey[1]].key,
              color: colorvalue,
              marker: markerarray,
              key: key,
              data: [],
              regression: component.trendlineenable !== undefined ? component.trendlineenable() : false,
              regressionSettings: {}
            });
          } else {
            categoryDataRowAggr.push({
              name: component.dataRes.dimensions[colKey[0]].members[colKey[1]].text + '-Result',
              color: colorvalue,
              marker: markerarray,
              key: key,
              data: [],
              regression: component.trendlineenable !== undefined ? component.trendlineenable() : false,
              regressionSettings: {}
            });
          }
          /*
                     *If the measure is at the top then follow the splice
                      *Else append it at the Bottom
                    */
          for (var k = 0; k < finalCategoryNames.length; k++) {
            for (var m = 0; m < indexes.length; m++) {
              if (categoryDataRowAggr[lastIndex].data[k] === undefined) {
                categoryDataRowAggr[lastIndex].data[k] = {y: 0};
              }

              categoryDataRowAggr[lastIndex].data[k].y += tempSeries[indexes[m]].data[k].y;
            }
          }
        });
      }

	  seriesColor.splice(seriesData.length, seriesColor.length);
      component.dataseriescolor(seriesColor.join());
      /*
             * sub Total Logic is true
             * getting the value and putting in the seperate array
             * adding those value in into the series tab.
             */
      component.getorginal_DS =  jQuery.extend(true, [], categoryDataRowAggr);// jshint ignore:line
      component.getorginal_Category = jQuery.extend(true, [], finalCategoryNames);// jshint ignore:line
      /**
       *Getting the orginal catagory &json
       *Updating it to the master-container
       *To control the errorbar&trendline&HIERARCHY
       **/
      if (component.trendlineenable !== undefined) {
        if (component.trendlineenable()) {
          var glovalLength;
          var GlobalValCheck = [];
          for (var i = 0; i < categoryDataRowAggr.length; i++) {
            for (var j = 0; j < categoryDataRowAggr[i].data.length; j++) {
              if (GlobalValCheck[i] === undefined) {
                GlobalValCheck[i] = [];
              }

              GlobalValCheck[i].push(categoryDataRowAggr[i].data[j].y);
              categoryDataRowAggr[i].data[j].x = j;
            }

            if (!component.trendlineequation()) {
              categoryDataRowAggr[i].regressionSettings = {
                type: '',
                color: categoryDataRowAggr[i].color,
                name: 'Linear Trendline-' + categoryDataRowAggr[i].name
              };
            } else {
              categoryDataRowAggr[i].regressionSettings = {
                type: '',
                color: categoryDataRowAggr[i].color
              };
            }

            glovalLength = i;
          }
          /**
            *Adding Trendline to the charts
            * implementation for adding regressionSettings ends here
            **/
          function isMax(value) {// jshint ignore:line
            return function(element, index, array) {// jshint ignore:line
              return element > value;
            };
          }
          /**
            *creating this function to check weather the array has more than 0 in it.
            * Trendline won't work if more than tow 0 in a array.
            **/
          for (var i = 0; i < GlobalValCheck.length; i++) {
            var finalValue = GlobalValCheck[i].filter(isMax(1));
            if (finalValue.length < 2) {
              categoryDataRowAggr[i].regression = false;
            }
          }

          component.trendlinelength(glovalLength);
        }
      }
      /*
            *Trendline function in bar family .
            *Need to change the value for defaultValue loop Condition in all charts
            */
      defaultValue.xAxis.categories = [];
      defaultValue.xAxis.measurecategories = [];
      defaultValue.xAxis.key = [];
      defaultValue.xAxis.categories = defaultValue.xAxis.categories.concat(finalCategoryNames);
      if (finalCategorymeasurekey !== '') {
        defaultValue.xAxis.measurecategories = finalCategorymeasurekey;
      }
      //console.log(finalCategoryNames);
      try {
        if (component.enablehierarchylabels() === true /*&& selectedRowdimIndexes.length > 1*/) {
          //var processedCategories = self.createHierarchyLabels(component.result(), selectedRowdimIndexes, component);
          //defaultValue.xAxis.categories = processedCategories.withHier;
         // console.log(JSON.stringify(component.dataRes));

          var xAxisDefaultCategories = [];
          xAxisDefaultCategories = xAxisDefaultCategories.concat(defaultValue.xAxis.categories);
          var processedCategories = this.createHierarchyLabelsStacked(component, selectedRowdimIndexes, xAxisDefaultCategories);
          defaultValue.xAxis.categories = processedCategories.withHier;

          /* Following code is required to manipulate the series according to the order of xAxis categories.
                       This case will occur when the row Dimension selected in Data Utility is not in the same order as in Initial View.
                    */
          var selRowInd = [];
          selRowInd = selRowInd.concat(selectedRowdimIndexes);
          selRowInd.sort(function(a, b) {
            return a - b;
          });

          if (selRowInd.join(',') != selectedRowdimIndexes.join(',')) {
            var newCategoriesOrder = [];
            $.each(processedCategories.withoutHier, function(i, v) {
              self.createFlatCategoryLabelsStacked(v, newCategoriesOrder, [v.key]);
            });

            //console.log(JSON.stringify(newCategoriesOrder));

            var newcategoryDataRowAggr = [];
            $.extend(true, newcategoryDataRowAggr, categoryDataRowAggr);
            $.each(newCategoriesOrder, function(i, v) {
              var k = finalCategoryNamesKeys.indexOf(v);
              $.each(newcategoryDataRowAggr, function(ind, ele) {
                var val = ele.data[k];
                categoryDataRowAggr[ind].data[i] = val;
              });
            });
          }
        }
      } catch (e) {
            console.log(e); // jshint ignore:line
      }
      //defaultValue.xAxis.categories = this.createHierarchyLabels(component.dataRes,selectedRowdimIndexes);
      //defaultValue.xAxis.key=defaultValue.xAxis.key.concat(finalCategoryNamesKey);
     //Fix  - VBX141-7456
      var data = _.pick(categoryDataRowAggr,"data");
      if(_.isEmpty(data))
      {
	      setTimeout(function()
	      {
      		component.$().find(".smokeScreen").css("opacity",1);
	      },10);
      }
      //End of fix - VBX141-7456
      defaultValue.series = categoryDataRowAggr;
      //console.log("categoryDataRowAggr="+JSON.stringify(categoryDataRowAggr))
      //      alert(defaultValue.xAxis.categories);
      //      alert(JSON.stringify(categoryDataRowAggr));
      //component.updateColors();
      //alert(  component.categoriesIndex );
      return seriesNamesinAdditionalProp;
    };
  }

  if (validateImplementMethod(args, 'createMeasuresData')) {// jshint ignore:line
    /**
         * Map data from JSON Tuple to Highchart
         * @param {object} component - Reference to component
         * @param {string} type - type of the chart
         * @param {object} defaultValue - HighCharts values
         * @return {Array} seriesNames
         */
    that.createMeasuresData = function(component, type, defaultValue, cfStatus) {
      //alert("Measure data creation!");
      var self = this;
      component.categoriesIndex = [];
       var measureMarkerPair;
      //var seriesColor = component.dataseriescolor().split(",");
      var defaultColor = [
        '#B586DA',
        '#FF6657',
        '#F3A730',
        '#946B66',
        '#B0AD53',
        '#7AC1DE',
        '#F1C337',
        '#566C6C',
        '#A1CC54',
        '#543F1E'
      ];
      var seriesColor = [];
      if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
        seriesColor = [];
      } else {
        seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
      }

      var ruleInfo = '';
      if (cfStatus != 'ncf') {
        if (component.ruletable() !== undefined && component.ruletable() !== '' && component.ruletable() != '{}') {
          that.updateRuleInfo(component, 'bar');
          ruleInfo = JSON.parse(component.ruletable());
        }
      }
      //alert(component.dataseriescolor());
      var categoryDataRowAggr = [];
      var seriesName = [];
      var seriesKey = [];
      var seriesData = [];
      var measureColorPair;
      if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
        measureColorPair = JSON.parse(component.measurecolorpair());
      }

      if (component.hasOwnProperty('measuremarkerpair')) {

        if (!(component.measuremarkerpair() === undefined || component.measuremarkerpair() === '')) {
          measureMarkerPair = JSON.parse(component.measuremarkerpair());
        }
      }

      component.measureInOriginalSeries = {};
      component.categoryInOriginalSeries = {};
      component.columnInOriginalSeries = {};
      if (component.dataRes.dimensions[0] && component.dataRes.dimensions[0].axis == 'COLUMNS') {
        for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {

          var markerarray = {fillColor: seriesColor[i]};
          component.categoriesIndex.push('0' + ':' + i);
          if (measureColorPair && measureColorPair[component.dataRes.dimensions[0].members[i].key] !== undefined) {
            seriesColor[i] = measureColorPair[component.dataRes.dimensions[0].members[i].key].color;
          }

          if (component.hasOwnProperty('measuremarkerpair')) {

            if (measureMarkerPair && measureMarkerPair[component.dataRes.dimensions[0].members[i].key] !== undefined) {
              markerarray = {
                enabled: measureMarkerPair[component.dataRes.dimensions[0].members[i].key].enabled,
                radius:parseFloat( measureMarkerPair[component.dataRes.dimensions[0].members[i].key].size),
                symbol: measureMarkerPair[component.dataRes.dimensions[0].members[i].key].symbol,
                fillColor: component.defaultmarkercolor === false ? measureMarkerPair[component.dataRes.dimensions[0].members[i].key].color : measureColorPair[component.dataRes.dimensions[0].members[i].key].color,
                states: {
                  hover: {
                    enabled: measureMarkerPair[component.dataRes.dimensions[0].members[i].key].hoverenable,
                    radius: parseFloat(measureMarkerPair[component.dataRes.dimensions[0].members[i].key].size)
                  }
                }
              };
            }
          }

          component.measureInOriginalSeries[component.dataRes.dimensions[0].members[i].key] = categoryDataRowAggr.length;
          categoryDataRowAggr.push({
            name: self.formatSeriesName(component, component.dataRes.dimensions[0].members[i].text, 0 + ':' + i, {}),
            uniquekey: component.dataRes.dimensions[0].members[i].key,
            keyvalue: component.dataRes.dimensions[0].members[i].key,
            key: '0' + ':' + i,
            color: self.getSeriesColors(component, seriesColor, categoryDataRowAggr.length, defaultColor),
            id: +'' + i + '',
            marker: markerarray,
            data: [{y: component.dataRes.data[i]}]
          });
          defaultValue.xAxis.categories = [' '];
          defaultValue.xAxis.key = [' '];
          component.categoryInOriginalSeries['dimension'] = 0;
        }
      } else if(component.dataRes.dimensions[0]) {
        for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {

          var markerarray = {fillColor: seriesColor[i]};
          seriesName.push(self.formatSeriesName(component, component.dataRes.dimensions[0].members[i].text, 0 + ':' + i, {}));
          seriesKey.push(component.dataRes.dimensions[0].members[i].key);
          component.measureInOriginalSeries[component.dataRes.dimensions[0].members[i].key] = seriesData.length;
          seriesData.push({y: component.dataRes.data[i]});
          component.categoriesIndex.push('0' + ':' + i);
        }

        if (component.hasOwnProperty('measuremarkerpair')) {
          if (measureMarkerPair && measureMarkerPair['Measures'] !== undefined) {
            markerarray = {
              enabled: measureMarkerPair['Measures'].enabled,
              radius:parseFloat( measureMarkerPair['Measures'].size),
              symbol: measureMarkerPair['Measures'].symbol,
              fillColor: measureMarkerPair['Measures'].color,
              states: {
                hover: {
                  enabled: measureMarkerPair['Measures'].hoverenable,
                  radius: parseFloat(measureMarkerPair['Measures'].size)
                }
              }
            };
          }
        }

        defaultValue.xAxis.categories = seriesName;
        defaultValue.xAxis.key = seriesKey;
        defaultValue.xAxis.measurecategories = [];
        defaultValue.xAxis.measurecategories =seriesKey;
        defaultValue.legend.enabled = false;
        categoryDataRowAggr.push({
          name: '',
          uniquekey: 'dimension',
          key: '0' + ':' + i,
          color: self.getSeriesColors(component, seriesColor, categoryDataRowAggr.length, defaultColor),
          marker: markerarray,
          id: +'' + 0 + '',
          data: []
        });
        component.columnInOriginalSeries['dimension'] = 0;
        categoryDataRowAggr[0].data = seriesData;
      }

      if (ruleInfo !== '' && cfStatus != 'ncf') {
        that.createCFMeasureData(component, 'bar', component.fulljson());
        that.processConditionalFormatting(component, categoryDataRowAggr, ruleInfo, 'bar');
      }

      seriesColor.splice(categoryDataRowAggr.length, seriesColor.length);
      component.dataseriescolor(seriesColor.join());
      defaultValue.series = categoryDataRowAggr;
      categoryDataRowAggr = seriesData;
      that.defaultvalueseriesdata = seriesData;
    };
  }

  if (validateImplementMethod(args, 'createCFMeasureData')) {// jshint ignore:line
    that.createCFMeasureData = function(component, type, completeJSONCF) {
      component.measureInCFSeries = {};
      component.categoryInCFSeries = {};
      component.columnInCFSeries = {};
      var categoryDataRowAggr = [];
      var seriesData = [];
      var scalingFactor = 1;
      if (completeJSONCF.dimensions[0].axis == 'COLUMNS') {
        for (var i = 0; i < completeJSONCF.dimensions[0].members.length; i++) {
          scalingFactor = Math.pow(10, completeJSONCF.dimensions[0].members[i].scalingFactor || 0);
          component.measureInCFSeries[completeJSONCF.dimensions[0].members[i].key] = categoryDataRowAggr.length;
          categoryDataRowAggr.push({
            name: completeJSONCF.dimensions[0].members[i].text,
            uniquekey: completeJSONCF.dimensions[0].members[i].key,
            key: '0' + ':' + i,
            data: [completeJSONCF.data[i] * scalingFactor]
          });
          component.categoryInCFSeries['dimension'] = 0;
        }
      } else {
        for (var i = 0; i < completeJSONCF.dimensions[0].members.length; i++) {
          component.measureInCFSeries[completeJSONCF.dimensions[0].members[i].key] = seriesData.length;
          scalingFactor = Math.pow(10, completeJSONCF.dimensions[0].members[i].scalingFactor || 0);
          seriesData.push(completeJSONCF.data[i] * scalingFactor);
        }

        categoryDataRowAggr.push({
          name: '',
          uniquekey: 'dimension',
          key: '',
          data: []
        });
        component.columnInCFSeries['dimension'] = 0;
        categoryDataRowAggr[0].data = seriesData;
      }

      component.conditionalFormattingData = categoryDataRowAggr;
    };
  }

  if (validateImplementMethod(args, 'createCFData')) {// jshint ignore:line
    /**
         * Create conditional formatting data
         * @param {object} component - Reference to component
         * @param {string} type - type of the chart
         * @param {object} Complete JSON data
         * @return {Array} Conditional Formatting Data
         */
    that.createCFData = function(component) {
      var self = this;
      //console.log("in cfdata");
      var seriesColor = component.dataseriescolor().split(',');
      component.categoriesIndex = [];
      var noOfColumns = 0;
      var completeJSONCF = component.dataRes;
      // if(!(component.measurecolorpair()=== undefined || component.measurecolorpair() === '')){
      //  measureColorPair = JSON.parse(component.measurecolorpair());
      // }
      //alert("Component.dataRes==="+ JSON.stringify(component.dataRes));
      if (completeJSONCF === undefined || completeJSONCF === '') {
        return '';
      }

      for (var i = 0; i < completeJSONCF.dimensions.length; i++) {
        if (completeJSONCF.dimensions[i].axis == 'COLUMNS') {
          noOfColumns++;
        }
      }

      var selectedColumndimIndexes = [];
      var selectedRowdimIndexes = [];
      var measureDimensionIndex = component.getMeasureIndex();
      var measureInRow = completeJSONCF.dimensions[measureDimensionIndex].axis == 'ROWS' ? true : false;
      if (measureInRow) {
        selectedRowdimIndexes.push(measureDimensionIndex);
      } else {
        selectedColumndimIndexes.push(measureDimensionIndex);
      }

      var bardatacustomizationJson = {
        'COLUMNS': [],
        'ROWS': []
      };
      if (component.bardatacustomization() !== '') {
        bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
      }

   /*   if (component.datautility() === true && (bardatacustomizationJson['COLUMNS'].length !== 0 || bardatacustomizationJson['ROWS'].length !== 0)) {
        if (bardatacustomizationJson['COLUMNS'].length !== 0) {
          //selectedColumndim=bardatacustomizationJson['COLUMNS'][0].text;
          //selectedColumndimIndexes=selectedColumndimIndexes.concat(bardatacustomizationJson['COLUMNS'][0].index.split("-"));
          $.each(bardatacustomizationJson['COLUMNS'], function(index, value) {
            selectedColumndimIndexes.push(_.parseInt(value.index));
          });
        }

        if (bardatacustomizationJson['ROWS'].length !== 0) {
          $.each(bardatacustomizationJson['ROWS'], function(index, value) {
            selectedRowdimIndexes.push(_.parseInt(value.index));
          });
        } else {
          this.createSmokeScreen(component.$(), 'Please select Dimension in Data Utility');
        }
      } else */if (component.datautility() === true && (bardatacustomizationJson['COLUMNS'].length === 0 && bardatacustomizationJson['ROWS'].length === 0)) {
        this.createSmokeScreen(component.$(), 'Please select Dimension in Data Utility');
      } else {
        for (var i = 0; i < noOfColumns; i++) {
          if (i != measureDimensionIndex) {
            selectedColumndimIndexes.push(i);
          }
        }

        for (var i = noOfColumns; i < completeJSONCF.dimensions.length; i++) {
          if (i != measureDimensionIndex) {
            selectedRowdimIndexes.push(i);
          }
        }
      }

      var scalingValues = [];
      for (var i = 0; i < completeJSONCF.dimensions[measureDimensionIndex].members.length; i++) {
        scalingValues.push(Math.pow(10, completeJSONCF.dimensions[measureDimensionIndex].members[i].scalingFactor || 0));
      }
      // **************** Please don't delete the code below. new code begins : Amit *********************/
      var defaultColor = [
        '#B586DA',
        '#FF6657',
        '#F3A730',
        '#946B66',
        '#B0AD53',
        '#7AC1DE',
        '#F1C337',
        '#566C6C',
        '#A1CC54',
        '#543F1E'
      ];
      var seriesColor = [];
      if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
        seriesColor = [];
      } else {
        seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
      }

      var tuplesInArow = completeJSONCF.tuples.slice(0, completeJSONCF.columnCount);
      // Getting tuples for all Columns in first row of crosstab.
      var colRowIndexJson = {};
      var colNamesJson = {};
      var seriesData = [];
	  var hasResultIntupleCol = {};
	  var showtotaldatabase = component.showtotaldatabase();
	  var datautility = component.datautility();
      component.measureInCFSeries = {};
      component.columnInCFSeries = {};
      for (var i = 0; i < tuplesInArow.length; i++) {
        var tempTuple = tuplesInArow[i].slice(0, noOfColumns);
        if (self.vbiCharts.eliminateResult(completeJSONCF, tempTuple, undefined, component.showtotaldatabase()) === true) {
          var colKey = [];
          var colName = [];
          var ColumnKey = [];
          for (var j = 0; j < selectedColumndimIndexes.length; j++) {
            var tempCol = selectedColumndimIndexes[j];
            colName.push(completeJSONCF.dimensions[tempCol].members[tempTuple[tempCol]].text);
            ColumnKey.push(completeJSONCF.dimensions[tempCol].members[tempTuple[tempCol]].key);
            colKey.push(tempCol + ':' + tempTuple[tempCol]);
          }

          var newKey = colKey.join('-');
          if (typeof colRowIndexJson[newKey] == 'undefined') {
            colRowIndexJson[newKey] = [];
            if (!measureInRow) {
              if (component.measureInCFSeries[ColumnKey[0]] === undefined) {
                component.measureInCFSeries[ColumnKey[0]] = selectedColumndimIndexes.length > 1 ? {} : seriesData.length;
              }

              if (typeof component.measureInCFSeries[ColumnKey[0]] == 'object') {
                component.measureInCFSeries[ColumnKey[0]][ColumnKey.slice(1).join('-')] = seriesData.length;
              }
            } else {
              component.columnInCFSeries[ColumnKey.join('-')] = seriesData.length;
            }

            seriesData.push({
              name: colName.join('-'),
              uniquekey: ColumnKey[0],
              key: newKey,
              color: self.getSeriesColors(component, seriesColor, seriesData.length, defaultColor),
              data: [],
              regression: component.trendlineenable !== undefined ? component.trendlineenable() : false,
              regressionSettings: {}
            });
          }

          colRowIndexJson[newKey].push(i);
		  if(datautility && showtotaldatabase){
		  	  hasResultIntupleCol[i] = [];
			  for(var j=0, jLen = tempTuple.length; j<jLen; j++){
				  if(completeJSONCF.dimensions[j].members[tempTuple[j]].type == "RESULT"){
					  hasResultIntupleCol[i].push(j);
				  }
			  }
		  }
          colNamesJson[newKey] = colName.join('-');
        }
      }
      //console.log("seriesData="+JSON.stringify(seriesData));
      //console.log("colNamesJson="+JSON.stringify(colNamesJson));
      seriesColor.splice(seriesData.length, seriesColor.length);
      component.dataseriescolor(seriesColor.join());
      var tupleToSkip = 0;
      var tuplesInColumn = [];
      var rowNames = {};
      var rowDataJson = {};
	  var rowDataJsonWithInfo = {};
      //alert("that.dataRes.rowCount="+that.dataRes.rowCount);
      for (var i = 0; i < completeJSONCF.rowCount; i++) {
        //rowDataArr.push([]);
        tupleToSkip = completeJSONCF.columnCount * i;
        tuplesInColumn.push(completeJSONCF.tuples[tupleToSkip]);
        var tempTuple = tuplesInColumn[i];
		var hasResultIntuple = [];
		if(datautility && showtotaldatabase){
			for(var j=noOfColumns, tLen = tempTuple.length; j< tLen; j++){
				if(completeJSONCF.dimensions[j].members[tempTuple[j]].type == "RESULT"){
					hasResultIntuple.push(tempTuple[j]);
				}
			}
		}
        if (self.vbiCharts.eliminateResult(completeJSONCF, tempTuple, 'ROWS', component.showtotaldatabase()) === true) {
          var rowKey = 0;
          var rowHeader = 'Dimensions';
          var rowHeaderKey = 'Dimensions';
          if (selectedRowdimIndexes.length >= 1) {
            rowKey = selectedRowdimIndexes[0] + ':' + tempTuple[selectedRowdimIndexes[0]];
            rowHeader = completeJSONCF.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].text;
            rowHeaderKey = completeJSONCF.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].key;
            for (var j = 1; j < selectedRowdimIndexes.length; j++) {
              rowKey += '-' + selectedRowdimIndexes[j] + ':' + tempTuple[selectedRowdimIndexes[j]];
              // jscs:disable
              // Code here will be ignored by JSCS.
              rowHeader += '\\' + completeJSONCF.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].text;
              rowHeaderKey += '\\' + completeJSONCF.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].key;  // jscs:enable
            }
          }

          if (typeof rowNames[rowKey] == 'undefined') {
            //rowDataJson[rowKey]=[];
            rowNames[rowKey] = {
              key: rowHeaderKey,
              text: rowHeader
            };
            //defaultValuexAxiscategories.push(rowHeader);
            component.categoriesIndex.push(rowKey);
          }

          var curScalingValue = 1;
          $.each(colRowIndexJson, function(key, value) {
            $.each(value, function(index, newval) {
              var curIndex = newval + tupleToSkip;
              var keygen = key + '_' + rowKey;
              if (measureDimensionIndex != -1) {
                curScalingValue = scalingValues[completeJSONCF.tuples[curIndex][measureDimensionIndex]] || 1;
              }

              if (rowDataJson[keygen] === undefined) {
                rowDataJson[keygen] = [];
				rowDataJsonWithInfo[keygen] = [];
              }

              rowDataJson[keygen].push(completeJSONCF.data[curIndex] * curScalingValue);
			  if(datautility && showtotaldatabase && (hasResultIntuple.length || hasResultIntupleCol[newval].length)){
					var lastTempStore, lastTempstoreLen = 0;
					var totalLen = hasResultIntupleCol[newval].length + hasResultIntuple.length;
					if(rowDataJsonWithInfo[keygen].length){
						lastTempStore = rowDataJsonWithInfo[keygen][rowDataJsonWithInfo[keygen].length - 1];
						lastTempstoreLen = lastTempStore[0];
					}
					if(lastTempstoreLen < totalLen){
						rowDataJsonWithInfo[keygen].length = 0;
					}
					rowDataJsonWithInfo[keygen].push([totalLen , (completeJSONCF.data[curIndex] === null ? 0 : completeJSONCF.data[curIndex] * curScalingValue)]);
				}
            });
          });
        }
      }

	  if(datautility && showtotaldatabase){
		  $.each(rowDataJsonWithInfo, function(k, v){
			  if(v.length){
				  rowDataJson[k].length = 0;
					for(var i=0, len=v.length; i<len; i++){
						rowDataJson[k].push(Number(v[i][1]));
					}
			  }
		  });
	  }

      var categoryDataRowAggr = [];
      var finalCategoryNames = [];
      component.categoryInCFSeries = {};
      $.each(rowNames, function(key, names) {
        if (measureInRow) {
          // jscs:disable
          // Code here will be ignored by JSCS.
          var rowKeyArr = names.key.split('\\');
          // jscs:enable
          for (var i = 0; i < rowKeyArr.length; i++) {
            if (component.measureInCFSeries[rowKeyArr[0]] === undefined) {
              component.measureInCFSeries[rowKeyArr[0]] = rowKeyArr.length > 1 ? {} : finalCategoryNames.length;
            }

            if (typeof component.measureInCFSeries[rowKeyArr[0]] == 'object') {
              // jscs:disable
              // Code here will be ignored by JSCS.
              component.measureInCFSeries[rowKeyArr[0]][rowKeyArr.slice(1).join('\\')] = finalCategoryNames.length;  // jscs:enable
            }
          }
        }

        component.categoryInCFSeries[names.key] = finalCategoryNames.length;
        finalCategoryNames.push(names.text);
        for (var i = 0; i < seriesData.length; i++) {
          var genKey = seriesData[i].key + '_' + key;
          var yVal = that.barValueAggregation(component, rowDataJson[genKey]);
          seriesData[i].data.push(yVal);
        }
      });

      categoryDataRowAggr = seriesData;
      component.conditionalFormattingData = categoryDataRowAggr;
      // code for changing the measure name when measure name is changed by the user
      if (component.chartmeasurechange() !== undefined && component.chartmeasurechange() !== '' && component.chartmeasurechange() !== null) {
        var xaxisname = JSON.parse(component.chartmeasurechange());
        for (var i = 0; i < component.conditionalFormattingData.length; i++) {
          if (xaxisname[component.conditionalFormattingData[i].uniquekey] !== '') {
            component.conditionalFormattingData[i].name = xaxisname[component.conditionalFormattingData[i].uniquekey];
          }
        }
      }

      that.fullseriesData = component.conditionalFormattingData;  //  console.log(that.fullseriesData);
      //console.log("component.measureInCFSeries="+JSON.stringify(component.measureInCFSeries));
      //Adding error bar functionality for measure here
      //      alert(JSON.stringify(xAxisCategories));
      //      alert(JSON.stringify(categoryDataRowAggr));
    };

    this.defaultvalueseries = function() {
      return that.defaultvalueseriesdata;
    };

    this.createErrorbar = function() {
      return that.fullseriesData;
    };
  }
}
