function scatterSeries() {//jshint ignore:line
  var that = this;
  /**
   * Map data from JSON Tuple to Highchart
   * @override
   * @param {object} component - Reference to component
   * @param {string} type - type of the chart
   * @param {object} defaultValue - HighCharts values
   * @return {Array} seriesNames
   */
  that.createSeriesData = function(component, type, defaultValue) {
    var aggrigationType = component.chartaggregation() || "sum";
    try{
    if (type == 'scatter') {
      var isCFApplied = false; 
      var measureColorPair;
      if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
        measureColorPair = JSON.parse(component.measurecolorpair());
      }

      var seriesColor = component.dataseriescolor().split(',');
      var marksymbols = component.markersymbol().split(',');
    
      var measures = [];
      for (var i = 0; i < component.dataRes.dimensions.length; i++) {
        if (component.dataRes.dimensions[i].containsMeasures === true) {
          for (var j = 0; j < component.dataRes.dimensions[i].members.length; j++) {
            measures.push(component.dataRes.dimensions[i].members[j].text);
          }
        }
      }

      var measureJson = JSON.parse(component.getMeasureJson());
      if (component.chartmeasurechange() !== undefined && component.chartmeasurechange() !== '' && component.chartmeasurechange() !== null /*&& measures == component.measurechange()*/) {
        var xaxisname = JSON.parse(component.chartmeasurechange());
        //   var xaxisname = xaxisname[xaxisname.length - 1].split(',');
        for (var i = 0; i < component.dataRes.dimensions.length; i++) {
          if (component.dataRes.dimensions[i].containsMeasures === true) {
            for (var j = 0; j < component.dataRes.dimensions[i].members.length; j++) {
              if (xaxisname[component.dataRes.dimensions[i].members[j].key] !== undefined) {
                component.dataRes.dimensions[i].members[j].text = xaxisname[component.dataRes.dimensions[i].members[j].key];
                if (measureJson[component.dataRes.dimensions[i].members[j].key] !== undefined){
                  measureJson[component.dataRes.dimensions[i].members[j].key].text =  component.dataRes.dimensions[i].members[j].text ;
                }
              }
            }
          }
        }

      }

      
     
    
      var rowSelected = [];
      for (var i = 0; i < component.dataRes.dimensions.length; i++) {
          if (component.dataRes.dimensions[i].axis == 'ROWS' && component.dataRes.dimensions[i].containsMeasures !== true) {
            rowSelected.push({index:i});          
            if(!component.showtotaldatabase() && component.datautility() !== true){
              break;
            }
          }
      }
      var selectedMeasureIndex = [];    
        if (component.keyfigureLength < 2) {
          noData = 1;//jshint ignore:line
        } else if (!component.isDimensionAvailable) {
          noData = 2;//jshint ignore:line
        } else {
          if (component.xaxismeasure() !== null && component.xaxismeasure() !== undefined && component.xaxismeasure() !== '' && measureJson[component.xaxismeasure()]) {
            selectedMeasureIndex[0] = measureJson[component.xaxismeasure()].index;
          } else {
            component.xaxismeasure(component.dataRes.dimensions[component.keyfigureIndex].members[0].key);
          }

          if (component.yaxismeasure() !== null && component.yaxismeasure() !== undefined && component.yaxismeasure() !== '' && measureJson[component.yaxismeasure()]) {
            selectedMeasureIndex[1] = measureJson[component.yaxismeasure()].index;
          } else {
            component.yaxismeasure(component.dataRes.dimensions[component.keyfigureIndex].members[1].key);
          }
        }
       
    
   
     
      var sortedarray = [];
      var selectedDimension = component.dataRes["axis_columns"][0].indexOf(-1);
      var ddselectedDimension = 0;       
        if(component.xaxismeasure() === component.yaxismeasure()){
          component.yaxismeasure("");
        }
        if (component.xaxismeasure() === null || component.xaxismeasure() === undefined || component.xaxismeasure() === '' || !measureJson[component.xaxismeasure()]) {
          noData = 3;//jshint ignore:line
        } else if (component.yaxismeasure() === null || component.yaxismeasure() === undefined || component.yaxismeasure() === '' || !measureJson[component.yaxismeasure()]) {
          noData = 4;//jshint ignore:line
        } else if (rowSelected.length <= 0) {
          noData = 5;//jshint ignore:line
        } else {
          var ruleInfo = {};
          if (component.ruletable() !== undefined && component.ruletable() !== '') {
            that.updateRuleInfo(component, 'scatter');
            ruleInfo = JSON.parse(component.ruletable());
          }

          $.each(ruleInfo, function() {
            isCFApplied = true;
          });

          var axisLabelArray = [];
          selectedMeasureIndex[0] = measureJson[component.xaxismeasure()].index;
          selectedMeasureIndex[1] = measureJson[component.yaxismeasure()].index;
          axisLabelArray.push(measureJson[component.xaxismeasure()].text);
          axisLabelArray.push(measureJson[component.yaxismeasure()].text);
          var tempselectedMeasureIndex = [];
          tempselectedMeasureIndex[0] = component.keyfigureIndex + ':' + selectedMeasureIndex[0];
          tempselectedMeasureIndex[1] = component.keyfigureIndex + ':' + selectedMeasureIndex[1];
          var columnSelected = [];
          columnSelected = columnSelected.concat(tempselectedMeasureIndex);
          component.columnSelected = columnSelected;
          var selectedRowIndexArray = [];
          $.each(rowSelected, function(key, value) {
            selectedRowIndexArray.push(value.index);
          });

          var rowSelLength = rowSelected.length;
          //-----------------------------------------------tempselectedMeasureIndex-------------------------===============================================
          var rowResultIndex = [];
          if(!component.showtotaldatabase()){
          for (var i = 0; i < component.dataRes.dimensions.length; i++) {
            if (component.dataRes.dimensions[i].axis == 'ROWS') {
              for (var j = 0; j < component.dataRes.dimensions[i].members.length; j++) {
                if (component.dataRes.dimensions[i].members[j].type == 'RESULT') {
                  var resultObject = {};
                  resultObject.resultIndex = i + '-' + j;
                  rowResultIndex.push(resultObject);
                }
              }
            }
          }
        }

          selectedDimension = rowSelected[0].index;
          ddselectedDimension = rowSelected[rowSelLength - 1].index;
          component.categoriesIndex = {};
          component.categoriesIndex['Level1'] = component.dataRes.dimensions[selectedDimension].key;
          component.categoriesIndex['Level2'] = component.dataRes.dimensions[ddselectedDimension].key;
          var resultCountIndex = -1;

          var xScale = component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[0]].scalingFactor;
          var yScale = component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[1]].scalingFactor;
            
          xScale = xScale <= 0 ? 0 : xScale;//jshint ignore:line
          yScale = yScale <= 0 ? 0 : yScale;//jshint ignore:line

          component.xAxisScalingFactor = Math.pow(10, xScale);
          component.yAxisScalingFactor = Math.pow(10, yScale);

          component.xAxisunit = component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[0]].unitOfMeasure;
          component.yAxisunit = component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[1]].unitOfMeasure;

          if (isNaN(component.xAxisScalingFactor)) {
            component.xAxisScalingFactor = 1;
          }

          if (isNaN(component.yAxisScalingFactor)) {
            component.yAxisScalingFactor = 1;
          }

          var unitvalx;
          var unitvaly;
          if (component.showunit()) {
            if (component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[0]].unitOfMeasure !== '' && component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[0]].unitOfMeasure !== undefined) {
              unitvalx = '(in ' + component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[0]].unitOfMeasure + ')';
            } else {
              unitvalx = '';
            }

            if (component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[1]].unitOfMeasure !== '' && component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[1]].unitOfMeasure !== undefined) {
              unitvaly = '(in ' + component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[1]].unitOfMeasure + ')';
            } else {
              unitvaly = '';
            }
          } else {
            unitvalx = '';
            unitvaly = '';
          }

          if (component.scalingfactorenable()) {
            component.xAxisLabel = axisLabelArray[0] + '(*' + Math.pow(10, component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[0]].scalingFactor) + ')' + unitvalx;
            component.yAxisLabel = axisLabelArray[1] + '(*' + Math.pow(10, component.dataRes.dimensions[component.keyfigureIndex].members[selectedMeasureIndex[1]].scalingFactor) + ')' + unitvaly;
          } else {
            component.xAxisLabel = axisLabelArray[0] + unitvalx;
            component.yAxisLabel = axisLabelArray[1] + unitvaly;
          }

          if (component.swapaxes()) {
            var tempXLabel = component.xAxisLabel;
            component.xAxisLabel = component.yAxisLabel;
            component.yAxisLabel = tempXLabel;
          }

        if(!component.showtotaldatabase()){
              for (var i = 0; i < component.dataRes.dimensions[rowSelected[0].index].members.length; i++) {
                if (component.dataRes.dimensions[rowSelected[0].index].members[i].type == 'RESULT') {
                  resultCountIndex = i;
                }
              }
            }
         

          var isResultTuples = function(tupleArray) {
            if(component.showtotaldatabase()){
               return false;
            }
           for (var i = 0; i < tupleArray.length; i++) {
              if (component.dataRes.dimensions[i].members[tupleArray[i]].type == 'RESULT') {
                return true;
              }
            }
            return false;
           
          };
           var isResultTuplesOfTotal= function(tupleArray) {           
           for (var i = 0; i < tupleArray.length; i++) {
              if (component.dataRes.dimensions[i].members[tupleArray[i]].type == 'RESULT') {
                return true;
              }
            }
            return false;
           
          };

          var isResultRow = function(rowIndexArray, rowResultIndex) {
             if(component.showtotaldatabase()){
               return false;
            }
            for (var i = 0; i < rowResultIndex.length; i++) {
              var indexArray = rowResultIndex[i].resultIndex.toString().split('-');
              if (rowIndexArray[indexArray[0]] == indexArray[1]) {
                return true;
              }
            }

            return false;
          };
          var totalX = [];
          var totalY = [];
         // var addedRow = [];
          var seriesObject = {};
          //Separating conditonal formating array
          for (var rowIndex = 0; rowIndex < component.dataRes["axis_rows"].length; rowIndex++) {
            if (!isResultRow(component.dataRes["axis_rows"][rowIndex], rowResultIndex)) {

              var pointName = '';
              var pointKey = [];
              var pointIndex = [];

              for (var i = 0; i < rowSelLength; i++) {
                if(component.dataRes.dimensions[rowSelected[i].index].members[component.dataRes["axis_rows"][rowIndex][rowSelected[i].index]].text){
                  pointName = pointName + '/' + component.dataRes.dimensions[rowSelected[i].index].members[component.dataRes["axis_rows"][rowIndex][rowSelected[i].index]].text;
                }
                pointKey.push(component.dataRes.dimensions[rowSelected[i].index].members[component.dataRes["axis_rows"][rowIndex][rowSelected[i].index]].key);
                pointIndex.push(rowSelected[i].index + ':' + component.dataRes["axis_rows"][rowIndex][rowSelected[i].index]);
              }

              pointName = pointName.indexOf('/') === 0 ? pointName.substring(1,pointName.length) : pointName;
              pointName = ( pointName.indexOf('/') === (pointName.length - 1) )  ? pointName.substring(0,pointName.length - 1) : pointName;

              var columnCount = component.dataRes.columnCount;
              var columnMaxIndex = (rowIndex + 1) * columnCount;
              var x = [];
              var y = [];
              for (var columnIndex = rowIndex * columnCount; columnIndex < columnMaxIndex; columnIndex++) {
                if (/*component.dataRes.data[columnIndex] === null ||*/ isResultTuples(component.dataRes.tuples[columnIndex])) {
                  continue;
                }

                if (component.dataRes.tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[0]) {
                  x.push(component.dataRes.data[columnIndex]);
                }

                if (component.dataRes.tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[1]) {
                  y.push(component.dataRes.data[columnIndex]);
                }
                if(component.showtotal()&& !isResultTuplesOfTotal(component.dataRes.tuples[columnIndex])){
                   if (component.dataRes.tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[0]) {
                     totalX.push(component.dataRes.data[columnIndex]);
                   }
                  if (component.dataRes.tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[1]) {
                     totalY.push(component.dataRes.data[columnIndex]);
                  }                   
                }
              }

              var pointindexString = pointIndex.join('-');
              if (!seriesObject[pointindexString]) {
                seriesObject[pointindexString] = {};
                seriesObject[pointindexString] .name = pointName;
                seriesObject[pointindexString] ["dimension_key"] = pointKey.join('/');
                seriesObject[pointindexString]["dimension_index"] = pointindexString;
                var rowObject = {};
                rowObject.name = pointName;
                rowObject.key = pointKey;
                rowObject.rowIndex = pointindexString;
                rowObject.x = x;
                rowObject.y = y;

                seriesObject[pointindexString].data = [rowObject];
              }else {
                var rowObject = seriesObject[pointindexString].data[0];
                rowObject.x = rowObject.x.concat(x);
                rowObject.y = rowObject.y.concat(y);
                seriesObject[pointindexString].data = [rowObject];
              }

              if (measureColorPair && measureColorPair[pointKey[0]] !== undefined) {
                seriesObject[pointindexString].color = measureColorPair[pointKey[0]].color;
              } else {
                var seriesIndex = component.dataRes["axis_rows"][rowIndex][rowSelected[0].index];
                seriesObject[pointindexString].color = seriesColor[seriesIndex - (resultCountIndex == -1 ? 0 : (resultCountIndex < seriesIndex) ? 1 : 0)];
              }
            }
          }

          for (var itemkey in seriesObject) {
            sortedarray.push(seriesObject[itemkey]);
          }

          sortedarray.sort(function(a, b) {
            var firstText = a["dimension_index"].toUpperCase(); // ignore upper and lowercase
            var secondText = b["dimension_index"].toUpperCase();
            return firstText.localeCompare(secondText);
          });
        


          for (var i = 0; i < sortedarray.length; i++) {
            if (rowSelected.length < 2) {
              sortedarray[i].marker = {};
              sortedarray[i].marker.symbol = marksymbols[i];
            }

            for (var j = 0; j < sortedarray[i].data.length; j++) {
              sortedarray[i].key = columnSelected.join('-');

              sortedarray[i].data[j].x = that.aggregateArray(sortedarray[i].data[j].x,aggrigationType);
              sortedarray[i].data[j].y = that.aggregateArray(sortedarray[i].data[j].y,aggrigationType);

              if (component.swapaxes()) {
                var tempX = sortedarray[i].data[j].x;
                sortedarray[i].data[j].x = sortedarray[i].data[j].y;
                sortedarray[i].data[j].y = tempX;
              }              

            }
          }
          if(component.showtotal() === true) {
              var totalX = totalX.reduce(function(a, b) {
                return a + b;
              });
               var totalY = totalY.reduce(function(a, b) {
                return a + b;
              });
                if (measureColorPair && measureColorPair['Total Result'] !== undefined) {
                seriesColor[sortedarray.length] = measureColorPair['Total Result'].color;
              }   
              var rowObject = {};
                rowObject.name = "";
                rowObject.key = "Total Result";
                rowObject.rowIndex = 0;
                rowObject.x = totalX;
                rowObject.y = totalY;
                var seriesOBJ = {};
                 seriesOBJ.key = columnSelected.join('-');
                seriesOBJ.name = "Total Result";
                seriesOBJ["dimension_key"] = "Total Result";
                seriesOBJ["dimension_index"] = sortedarray.length;
                seriesOBJ["data"]= [rowObject];
               seriesOBJ.color = seriesColor[sortedarray.length];
               sortedarray.push(seriesOBJ);
         }

          var seriesData = [{}];
          seriesData = sortedarray;
          if (isCFApplied) {
            that.createCFSeriesData(component, seriesData);
          }
          
          try {

            if (component.datautility() && component.trendlineenable()) {

              var dataArray = [];
              for (var i = 0; i < seriesData.length; i++) {
                var temp = seriesData[i]["dimension_index"].toString().split('-');
                var tempVal = temp[0].split(':');
                if (dataArray[tempVal[1]] === undefined) {
                  dataArray[tempVal[1]] = [];
                  var tempObj = {};
                  tempObj = {};
                  var tempName = seriesData[i].name.toString().split('/');
                  tempObj.name = ' ';
                  tempObj.color = 'none';
                  tempObj.regression = true;
                  tempObj.tempName = tempName[0];
                  tempObj.regressionSettings = {
                    name: tempName[0],
                    color: seriesData[i].color,
                    type: 'linear'
                  };
                  tempObj.data = [];
                  tempObj.data.push({
                    x: seriesData[i].data[0].x,
                    y: seriesData[i].data[0].y
                  });
                  dataArray[tempVal[1]] = tempObj;
                } else {
                  dataArray[tempVal[1]].data.push({
                    x: seriesData[i].data[0].x,
                    y: seriesData[i].data[0].y
                  });
                }
              }

              for (var i = 0; i < dataArray.length; i++) {
                if (dataArray[i].data.length > 1) {
                  for (var j = 0; j < dataArray[i].data.length; j++) {
                    if (dataArray[i].data[j].x === 0 || dataArray[i].data[j].y === 0) {
                      dataArray[i].regression = false;
                      break;
                    }
                  }
                } else {
                  dataArray[i].regression = false;
                }
              }

              for (var i = 0; i < dataArray.length; i++) {
                if (dataArray[i].regression){
                  seriesData.push(dataArray[i]);
                }
              }
            }

          } catch (e) {

          }

          defaultValue.series = seriesData;
      
        }
      
    }
  }catch(e){
  // console.log(e);
  }
  };
  that.calculateValue =function(v1, v2, op) {
      switch (op) {
        case '+':
          return v1 + v2;
        case '-':
          return v1 - v2;
        case '*':
          return v1 * v2;
        case '/':
          return v1 / v2;
      }
    };
  that.createCFSeriesData = function(component, originalArray) {
    var aggrigationType = component.chartaggregation() || "sum";
    try {   
    
      var measureJson = JSON.parse(component.getMeasureJson());
      var selectedMeasureIndex = [];
      var rowSelected = [];
      var sortedarray = [];
      var selectedDimension = component.fulljson()["axis_columns"][0].indexOf(-1);    
      for (var i = 0; i < component.dataRes.dimensions.length; i++) {
          if (component.dataRes.dimensions[i].axis == 'ROWS' && component.dataRes.dimensions[i].containsMeasures !== true) {
            rowSelected.push({index:i});          
            if(!component.showtotaldatabase() && component.datautility() !== true){
              break;
            }
          }
      }
      var ruleInfo = {};
      var isCFApplied = false;
      var isMeasureConFormattingApplied = false;
      if (component.ruletable() !== undefined && component.ruletable() !== '') {
        //  that.updateRuleInfo(component,'scatter');
        ruleInfo = JSON.parse(component.ruletable());
      }

      $.each(ruleInfo, function(k, ruleJson) {
      isCFApplied = true;
      var ruleType = ruleJson['cfui-ruleType'];
      switch (ruleType) {
        case 'single_measure':
          isMeasureConFormattingApplied = true;
          break;
        case 'measure_calculation':
          isMeasureConFormattingApplied = true;
          break;
        case 'target_value':
          isMeasureConFormattingApplied = true;
          break;
        case 'dimension':
          break;
      }
    });

      var axisLabelArray = [];
      selectedMeasureIndex[0] = measureJson[component.xaxismeasure()].index;
      selectedMeasureIndex[1] = measureJson[component.yaxismeasure()].index;
      axisLabelArray.push(measureJson[component.xaxismeasure()].text);
      axisLabelArray.push(measureJson[component.yaxismeasure()].text);
      var tempselectedMeasureIndex = [];
      tempselectedMeasureIndex[0] = component.keyfigureIndex + ':' + selectedMeasureIndex[0];
      tempselectedMeasureIndex[1] = component.keyfigureIndex + ':' + selectedMeasureIndex[1];
      var columnSelected = [];
      columnSelected = columnSelected.concat(tempselectedMeasureIndex);
      component.columnSelected = columnSelected;
      var selectedRowIndexArray = [];
      $.each(rowSelected, function(key, value) {
      selectedRowIndexArray.push(value.index);
    });

      var rowSelLength = rowSelected.length;
      //------------------------------------------------------------------------===============================================
      var rowResultIndex = [];
      if(!component.showtotaldatabase()){
      for (var i = 0; i < component.fulljson().dimensions.length; i++) {
        if (component.fulljson().dimensions[i].axis == 'ROWS') {
          for (var j = 0; j < component.fulljson().dimensions[i].members.length; j++) {
           if (component.fulljson().dimensions[i].members[j].type == 'RESULT') {
              var resultObject = {};
              resultObject.resultIndex = i + '-' + j;
              rowResultIndex.push(resultObject);
            }
          }
        }
      }
    }

      selectedDimension = rowSelected[0].index;
      var resultCountIndex = -1;
      component.xAxisScalingFactor = Math.pow(10, component.fulljson().dimensions[component.keyfigureIndex].members[selectedMeasureIndex[0]].scalingFactor);
      component.yAxisScalingFactor = Math.pow(10, component.fulljson().dimensions[component.keyfigureIndex].members[selectedMeasureIndex[1]].scalingFactor);

      component.xAxisunit = component.fulljson().dimensions[component.keyfigureIndex].members[selectedMeasureIndex[0]].unitOfMeasure;
      component.yAxisunit = component.fulljson().dimensions[component.keyfigureIndex].members[selectedMeasureIndex[1]].unitOfMeasure;
      if (isNaN(component.xAxisScalingFactor)) {
        component.xAxisScalingFactor = 1;
      }

      if (isNaN(component.yAxisScalingFactor)) {
        component.yAxisScalingFactor = 1;
      }

      if (isMeasureConFormattingApplied) {
        component.scalingFactorObj = {};
        for (var mIndex = 0; mIndex < component.fulljson().dimensions[component.keyfigureIndex].members.length; mIndex++) {
          var key = component.fulljson().dimensions[component.keyfigureIndex].members[mIndex].key;
          component.scalingFactorObj[key + 'AxisScalingFactor'] = Math.pow(10, component.fulljson().dimensions[component.keyfigureIndex].members[mIndex].scalingFactor);
          if (isNaN(component.scalingFactorObj[key + 'AxisScalingFactor'])) {
            component.scalingFactorObj[key + 'AxisScalingFactor'] = 1;
          }
        }
      }
      if(!component.showtotaldatabase()){
          for (var i = 0; i < component.fulljson().dimensions[rowSelected[0].index].members.length; i++) {
            if (component.fulljson().dimensions[rowSelected[0].index].members[i].type == 'RESULT') {
              resultCountIndex = i;
            }
          }
        }

      var isResultRow = function(rowIndexArray, rowResultIndex) {
        if(component.showtotaldatabase()){
               return false;
            }
      for (var i = 0; i < rowResultIndex.length; i++) {
        var indexArray = rowResultIndex[i].resultIndex.toString().split('-');
        if (rowIndexArray[indexArray[0]] == indexArray[1]) {
          return true;
        }
      }
       return false;

    };

      var isResultTuples = function(tupleArray) {
        if(component.showtotaldatabase()){
               return false;
            }
      for (var i = 0; i < tupleArray.length; i++) {
        if (component.fulljson().dimensions[i].members[tupleArray[i]].type == 'RESULT') {
          return true;
        }
      }
       return false;
    };
     var isResultTuplesOfTotal= function(tupleArray) {           
           for (var i = 0; i < tupleArray.length; i++) {
              if (component.fulljson().dimensions[i].members[tupleArray[i]].type == 'RESULT') {
                return true;
              }
            }
            return false;
           
          };
      var totalX = [];
      var totalY = [];
      //var addedRow = [];
      var seriesObject = {};
      //Separating conditonal formating array
      for (var rowIndex = 0; rowIndex < component.fulljson()["axis_rows"].length; rowIndex++) {
        if (!isResultRow(component.fulljson()["axis_rows"][rowIndex], rowResultIndex)) {
          var pointName = '';
          var pointKey = [];
          var pointIndex = [];

          for (var i = 0; i < rowSelLength; i++) {
            if(component.fulljson().dimensions[rowSelected[i].index].members[component.fulljson()["axis_rows"][rowIndex][rowSelected[i].index]].text){
              pointName = pointName + '/' + component.fulljson().dimensions[rowSelected[i].index].members[component.fulljson()["axis_rows"][rowIndex][rowSelected[i].index]].text;
            }
            pointKey.push(component.fulljson().dimensions[rowSelected[i].index].members[component.fulljson()["axis_rows"][rowIndex][rowSelected[i].index]].key);
            pointIndex.push(rowSelected[i].index + ':' + component.fulljson()["axis_rows"][rowIndex][rowSelected[i].index]);
          }

          pointName = pointName.indexOf('/') === 0 ? pointName.substring(1,pointName.length) : pointName;//to remove first '/'
          pointName = ( pointName.indexOf('/') === (pointName.length - 1) )  ? pointName.substring(0,pointName.length - 1) : pointName;//to remove last '/'

          var x = [];
          var y = [];
          var columnCount = component.fulljson().columnCount;
          var columnMaxIndex = (rowIndex + 1) * columnCount;
          var conditionArrayIndexObj = {};
          for (var columnIndex = rowIndex * columnCount; columnIndex < columnMaxIndex; columnIndex++) {
            if (/*component.fulljson().data[columnIndex] === null ||*/ isResultTuples(component.fulljson().tuples[columnIndex])) {
              continue;
            }

            if (component.fulljson().tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[0]) {
              x.push(component.fulljson().data[columnIndex]);
            }

            if (component.fulljson().tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[1]) {
              y.push(component.fulljson().data[columnIndex]);
            }
            if(component.showtotal()&& !isResultTuplesOfTotal(component.fulljson().tuples[columnIndex])){
                   if (component.fulljson().tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[0]) {
                     totalX.push(component.fulljson().data[columnIndex]);
                   }
                  if (component.fulljson().tuples[columnIndex][component.keyfigureIndex] == selectedMeasureIndex[1]) {
                     totalY.push(component.fulljson().data[columnIndex]);
                  }                   
                }

            if (isMeasureConFormattingApplied) {
              var mIndex = component.fulljson().tuples[columnIndex][component.keyfigureIndex];
              if (conditionArrayIndexObj[component.fulljson().dimensions[component.keyfigureIndex].members[mIndex].key] === undefined) {
                conditionArrayIndexObj[component.fulljson().dimensions[component.keyfigureIndex].members[mIndex].key] = [];
              }

              conditionArrayIndexObj[component.fulljson().dimensions[component.keyfigureIndex].members[mIndex].key].push(component.fulljson().data[columnIndex]);
            }
          }

          var pointindexString = pointIndex.join('-');
          if (!seriesObject[pointindexString]) {
            seriesObject[pointindexString] = {};
            seriesObject[pointindexString] .name = pointName;
            seriesObject[pointindexString] ["dimension_key"] = pointKey.join('/');
            seriesObject[pointindexString]["dimension_index"] = pointindexString;
            var rowObject = {};
            rowObject.name = pointName;
            rowObject.key = pointKey;
            rowObject.rowIndex = pointindexString;
            rowObject.x = x;
            rowObject.y = y;
            if (isMeasureConFormattingApplied) {
              for (var prop in conditionArrayIndexObj) {
                rowObject[prop] = conditionArrayIndexObj[prop];
              }
            }

            seriesObject[pointindexString].data = [rowObject];
          }else {
            var rowObject = seriesObject[pointindexString].data[0];
            rowObject.x = rowObject.x.concat(x);
            rowObject.y = rowObject.y.concat(y);
            if (isMeasureConFormattingApplied) {
              for (var prop in conditionArrayIndexObj) {
                rowObject[prop] = rowObject[prop].concat(conditionArrayIndexObj[prop]);
              }
            }

            seriesObject[pointindexString].data = [rowObject];
          }
        }
      }

      for (var itemkey in seriesObject) {
        sortedarray.push(seriesObject[itemkey]);
      }
      if(component.showtotal() === true) {              
              var rowObject = {};
                rowObject.name = "";
                rowObject.key = "Total Result";
                rowObject.rowIndex = 0;
                rowObject.x = totalX;
                rowObject.y = totalY;
                var seriesOBJ = {};
                seriesOBJ.name = "Total Result";
                seriesOBJ["dimension_key"] = "Total Result";
                seriesOBJ["dimension_index"] = sortedarray.length;
                seriesOBJ["data"]= [rowObject];             
               sortedarray.push(seriesOBJ);
         }

      for (var i = 0; i < sortedarray.length; i++) {
        for (var j = 0; j < sortedarray[i].data.length; j++) {
          sortedarray[i].key = columnSelected.join('-');
          sortedarray[i].data[j].x = that.aggregateArray(sortedarray[i].data[j].x, aggrigationType);
          sortedarray[i].data[j].y = that.aggregateArray(sortedarray[i].data[j].y, aggrigationType);
          sortedarray[i].data[j].scalingX = sortedarray[i].data[j].x * component.xAxisScalingFactor;
          sortedarray[i].data[j].scalingY = sortedarray[i].data[j].y * component.yAxisScalingFactor;
          if (isMeasureConFormattingApplied) {
            for (var mIndex = 0; mIndex < component.fulljson().dimensions[component.keyfigureIndex].members.length; mIndex++) {
              if (component.fulljson().dimensions[component.keyfigureIndex].members[mIndex].type != 'RESULT' || component.showtotaldatabase()) {
                var key = component.fulljson().dimensions[component.keyfigureIndex].members[mIndex].key;
                sortedarray[i].data[j][key] = that.aggregateArray(sortedarray[i].data[j][key], aggrigationType);
                sortedarray[i].data[j][key] = sortedarray[i].data[j][key] * component.scalingFactorObj[key + 'AxisScalingFactor'];

              }
            }
          }

          if (isCFApplied) {
            var measureKeys = [
                component.xaxismeasure(),
                component.yaxismeasure()
            ];
            $.each(ruleInfo, function(k, ruleJson) {
            var ruleType = ruleJson['cfui-ruleType'];
            switch (ruleType) {
              case 'single_measure':
                var staticVal1 = '';
                var point = 0;
                var smOp = ruleJson['cfui-operator'];
                if (measureKeys.indexOf(ruleJson['cfui-highlightedMeasure'].key) > -1) {
                  point = sortedarray[i].data[j][ruleJson['cfui-comparisionMeasure'].key];
                  if (ruleJson['cfui-comparisionValueType'] == 'static') {
                    if (smOp == 'bt') {
                      staticVal1 = [
                          ruleJson['cfui-static_comparisionValue1'],
                          ruleJson['cfui-static_comparisionValue2']
                      ];
                    } else {
                      staticVal1 = ruleJson['cfui-static_comparisionValue1'];
                    }
                  } else if (ruleJson['cfui-dynamicSelectionType'] == 'measure_selection') {
                    if (smOp == 'bt') {
                      staticVal1 = [
                          sortedarray[i].data[j][ruleJson['cfui-dynamic_comparisionValue1'].key],
                          sortedarray[i].data[j][ruleJson['cfui-dynamic_comparisionValue2'].key]
                      ];
                    } else {
                      staticVal1 = [sortedarray[i].data[j][ruleJson['cfui-dynamic_comparisionValue1'].key]];
                    }
                  } else if (ruleJson['cfui-dynamicSelectionType'] == 'cell_selection') {
                    if (smOp == 'bt') {
                      staticVal1 = [
                          VbiUtil.prototype.trendCellSelectionObjToDataValue(component.fulljson(), ruleJson['dynamiccellselection'].key).data,
                          VbiUtil.prototype.trendCellSelectionObjToDataValue(component.fulljson(), ruleJson['dynamiccellselection2'].key).data
                      ];
                    } else {
                      staticVal1 = VbiUtil.prototype.trendCellSelectionObjToDataValue(component.fulljson(), ruleJson['dynamiccellselection'].key).data;
                    }
                  }

                  if (that.checkValues(point, staticVal1, smOp)) {
                    sortedarray[i].data[j].color = ruleJson['inputcondformat'];
                    sortedarray[i].data[j].states = {hover: {color: ruleJson['inputcondformat']}};
                    sortedarray[i].data[j].marker = {
                      fillColor: ruleJson['inputcondformat'],
                      states: {hover: {fillColor: ruleJson['inputcondformat']}}
                    };
                  }
                }

                break;
              case 'measure_calculation':
                if (measureKeys.indexOf(ruleJson['cfui-highlightedMeasure'].key) > -1) {
                  var smOp = ruleJson['cfui-operator'];
                  point = sortedarray[i].data[j][ruleJson['cfui-comparisionMeasure'].key];
                  var StaticVal = that.calculateValue(sortedarray[i].data[j][ruleJson['cfui-calcMeasure1'].key], sortedarray[i].data[j][ruleJson['cfui-calcMeasure2'].key], ruleJson['cfui-calcOperator']);
                  if (that.checkValues(point, StaticVal, smOp)) {
                    sortedarray[i].data[j].color = ruleJson['inputcondformat'];
                    sortedarray[i].data[j].states = {hover: {color: ruleJson['inputcondformat']}};
                    sortedarray[i].data[j].marker = {
                      fillColor: ruleJson['inputcondformat'],
                      states: {hover: {fillColor: ruleJson['inputcondformat']}}
                    };
                  }
                }

                break;
              case 'target_value':
                if (measureKeys.indexOf(ruleJson['cfui-highlightedMeasure'].key) > -1) {
                  var targetValue;
                  if (ruleJson['cfui-targetValueType'] == 'static') {
                     targetValue = ruleJson['cfui-static_targetValue'];
                  } else if (ruleJson['cfui-dynamicSelectionType'] == 'measure_selection') {
                     targetValue = [sortedarray[i].data[j][ruleJson['cfui-dynamic_targetValue'].key]];
                  } else if (ruleJson['cfui-dynamicSelectionType'] == 'cell_selection') {
                     targetValue = VbiUtil.prototype.trendCellSelectionObjToDataValue(component.fulljson(), ruleJson['dynamiccellselection'].key).data;
                  }

                  var point = sortedarray[i].data[j][ruleJson['cfui-comparisionMeasure'].key];
                  var smOp = 'bt';
                  var targetRules = ruleJson['cfui-targetRules'];
                  for (var tIndex = 0; tIndex < targetRules.length; tIndex++) {
                    var rule = targetRules[tIndex];
                    var from = Number(targetValue) * (Number(rule.from) / 100);
                    var to = Number(targetValue) * (Number(rule.to) / 100);
                    var compValue = [
                        from,
                        to
                    ];
                    if (that.checkValues(point, compValue, smOp)) {
                      sortedarray[i].data[j].color = rule.color;
                      sortedarray[i].data[j].states = {hover: {color: rule.color}};
                      sortedarray[i].data[j].marker = {
                        fillColor: rule.color,
                        states: {hover: {fillColor: rule.color}}
                      };
                    }
                  }
                }

                break;
              case 'dimension':
                if (sortedarray[i].data[j].key.indexOf(ruleJson['cfui-member'].key) > -1) {
                  sortedarray[i].data[j].color = ruleJson['inputcondformat'];
                  sortedarray[i].data[j].states = {hover: {color: ruleJson['inputcondformat']}};
                  sortedarray[i].data[j].marker = {
                    fillColor: ruleJson['inputcondformat'],
                    states: {hover: {fillColor: ruleJson['inputcondformat']}}
                  };
                }

                break;
            }
          });
          }
        }
      }

      for (var oIndex = 0; oIndex < originalArray.length; oIndex++) {
        for (var filteredIndex = 0; filteredIndex < sortedarray.length; filteredIndex++) {
          if (originalArray[oIndex]["dimension_key"] == sortedarray[filteredIndex]["dimension_key"]) {
            for (var oDataIndex = 0; oDataIndex < originalArray[oIndex].data.length; oDataIndex++) {
              for (var filteredDataIndex = 0; filteredDataIndex < sortedarray[filteredIndex].data.length; filteredDataIndex++) {
                if (originalArray[oIndex].data[oDataIndex].key.join('/') == sortedarray[filteredIndex].data[filteredDataIndex].key.join('/')) {
                  if (sortedarray[filteredIndex].data[filteredDataIndex].hasOwnProperty('color')) {
                  //commented for VBX141-4385
                  //  originalArray[oIndex].color = sortedarray[filteredIndex].data[filteredDataIndex].color;
                    originalArray[oIndex].data[oDataIndex].color = sortedarray[filteredIndex].data[filteredDataIndex].color;
                    originalArray[oIndex].data[oDataIndex].states = {hover: {color: sortedarray[filteredIndex].data[filteredDataIndex].color}};
                    // originalArray[oIndex].data[oDataIndex].marker ={fillColor:sortedarray[filteredIndex].data[filteredDataIndex].color ,states:{hover:{ fillColor:finalDataArray[filteredIndex].data[filteredDataIndex].color}}}
                    originalArray[oIndex].data[oDataIndex].marker = {
                    states: {
                      hover: {
                        fillColor: sortedarray[filteredIndex].data[filteredDataIndex].color,
                        lineColor: sortedarray[filteredIndex].data[filteredDataIndex].color
                      }
                    }
                  };
                  }

                  break;
                }
              }
            }

            break;
          }
        }
      }
    }catch (e) {
	
     }
  };

  that.createMeasuresData = function(component, type, defaultValue) {
   // var self = this;
    var seriesColor = component.dataseriescolor().split(',');
    var marksymbols = component.markersymbol().split(',');
    var seriesData = [];
    var sortedarray = [];
    sortedarray[0] = {};
    sortedarray[0].name = 'Measures';
    sortedarray[0].color = seriesColor[0];
    sortedarray[0].data = [];
    if (!component.swapaxes()) {
      seriesData.push({
        x: component.dataRes.data[0],
        y: component.dataRes.data[1]
      });
    } else {
      seriesData.push({
        x: component.dataRes.data[1],
        y: component.dataRes.data[0]
      });
    }

    sortedarray[0].data = seriesData;
    sortedarray[0].marker = {};
    sortedarray[0].marker.symbol = marksymbols[0];
    defaultValue.legend.enabled = false;
    defaultValue.series = sortedarray;
  };

}
