function treeMapSeries() {  // jshint ignore:line

    var that = this;

    /*
     * Includes required methods from other files
     */
    /*
     implementMethods(that, { // that refers to seriesLibrary object
         familyBar : []
     });
     */
    /**
     * Map data from JSON Tuple to Highchart
     * @override
     * @param {object} component - Reference to component
     * @param {string} type - type of the chart
     * @param {object} defaultValue - HighCharts values
     * @return {Array} seriesNames
     */
    that.createSeriesData = function(component, type, defaultValue, cfStatus) {
        var seriesColor = component.dataseriescolor().split(',');
        component.categoriesIndex = [];
        var newTreeFormatedArray = [];
        var colCount = 0;
        var rowCount = 0;
        var dimension = 0;
        var colMember = [];
        var rowMember = [];
        var resultData = [];// jshint ignore:line
        var dime;
        var measureAxis;
        var majorData = [];
        var majorData1 = [];
        var ruleInfo = '';
        component.measureInOriginalSeries = {};
        component.categoryInOriginalSeries = {};
        component.columnInOriginalSeries = {};
        component.selectedRowdimIndexes = [];
        component.selectedColumndimIndexes = [];

        var measurelist = component.getDataSeries();
        for (var i = 0; i < measurelist[1].length; i++) {
            component.categoryInOriginalSeries[measurelist[1][i]] = i;
        }

        if (cfStatus !== 'ncf') {
            if (component.ruletable() !== undefined && component.ruletable() != '' && component.ruletable() != '{}') {// jshint ignore:line
                that.updateRuleInfo(component, 'pie');
                ruleInfo = JSON.parse(component.ruletable());
            }
        }

        var bardatacustomizationJson = {
            'COLUMNS': [],
            'ROWS': []
        };

        if (component.dataRes === undefined || component.dataRes === '') {
            return '';
        }

        var newRowIndex = [];
        var newsColIndex = [];
        for (var lenn = 0; lenn < component.dataRes.dimensions.length; lenn++) {
            if (component.dataRes.dimensions[lenn].containsMeasures !== true) {
                

                dimension++;
                if (component.dataRes.dimensions[lenn].axis === 'COLUMNS') {
                    colCount++;
                    newsColIndex.push(lenn);
                } else if (component.dataRes.dimensions[lenn].axis === 'ROWS') {
                    rowCount++;
                    newRowIndex.push(lenn);
                }
            } else {
                dime = lenn;
                measureAxis = component.dataRes.dimensions[lenn].axis;
            }
        }

        /*
         * Condition for tuples not equal to "TYPE==RESULT"
         */
        var treecolormeasure = component.treecolormeasure();
        var treesizemeasure = component.treesizemeasure();
        var getMeasureArr = component.getMeasureArr();
        var treecolormeasureindex = getMeasureArr.indexOf(treecolormeasure);
        var treesizemeasureindex = getMeasureArr.indexOf(treesizemeasure);
        var TempData = component.dataRes.tuples;

        for (var d = 0; d < component.dataRes.data.length; d++) {
            if (TempData[d][dime] === treecolormeasureindex) {

                    if(component.dataRes.data[d]===null){
                        component.dataRes.data[d]=0;
                    }
                    majorData.push(component.dataRes.data[d]);
                
                 
            } else if (TempData[d][dime] === treesizemeasureindex) {
                
                    if(component.dataRes.data[d]===null){
                        component.dataRes.data[d]=0;
                    }
                    majorData1.push(component.dataRes.data[d]);
                
            }

        }
        component.measureInOriginalSeries[treesizemeasure] = 0;
        if (newsColIndex != '' && newRowIndex !== undefined) {// jshint ignore:line
            component.selectedRowdimIndexes = newsColIndex;
        } else {
            component.selectedRowdimIndexes = newRowIndex;
        }

        component.selectedColumndimIndexes[0] = dime;
        component.columnInOriginalSeries = component.measureInOriginalSeries;
        var defaultView = false;
        // If default view is more than 2 dimensions, then it consider only first 2 dimension
        if (colCount > 2 && component.datautility() === false) {
            for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                if (bardatacustomizationJson.COLUMNS.length === 2) {
                    continue;
                }
                if (i != dime) {
                    bardatacustomizationJson.COLUMNS.push({
                        'index': i,
                        'text': component.dataRes.dimensions[i].text,
                        'key': component.dataRes.dimensions[i].key
                    });
                    defaultView = true;
                }
            }
        }

        if (rowCount > 2 && component.datautility() === false) {
            for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                if (bardatacustomizationJson.ROWS.length === 2) {
                    continue;
                }
                if (i != dime) {
                    bardatacustomizationJson.ROWS.push({
                        'index': i,
                        'text': component.dataRes.dimensions[i].text,
                        'key': component.dataRes.dimensions[i].key
                    });
                    defaultView = true;
                }
            }
        }
        /*
         * Getting Col & Row from Data utility
         */

        if (component.bardatacustomization() != '' && component.datautility() === true) {// jshint ignore:line
            bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
        }

        component.defaultView = defaultView;
        component.bardatacustomizationJson = bardatacustomizationJson;

        var dimMesIndexJson = getDimMesJson(component);
        var measureDimIndex = component.getMeasureIndex();
        var dataArrayval = [];
        var dataArrayval1 = [];
        dataArrayval = dataArr(component, dimMesIndexJson, treecolormeasureindex, measureDimIndex);
        if (treecolormeasureindex != treesizemeasureindex) {
            dataArrayval1 = dataArr(component, dimMesIndexJson, treesizemeasureindex, measureDimIndex);
        }

        //if ((component.datautility() === true && (bardatacustomizationJson['COLUMNS'].length !== 0 || bardatacustomizationJson['ROWS'].length !== 0)) || ((bardatacustomizationJson['COLUMNS'].length !== 0 || bardatacustomizationJson['ROWS'].length !== 0) && defaultView === true)) {
           if(false){
            var newlocalChanges = bardatacustomizationJson;
            var newsCols = [];
            var newsRows = [];
            var newsRowsIndex = [];
            var newsColsIndex = [];
            for (var i = 0; i < newlocalChanges.COLUMNS.length; i++) {
                newsCols.push(newlocalChanges.COLUMNS[i].text);
                newsColsIndex.push(newlocalChanges.COLUMNS[i].index);
            }

            for (var i = 0; i < newlocalChanges.ROWS.length; i++) {
                newsRows.push(newlocalChanges.ROWS[i].text);
                newsRowsIndex.push(newlocalChanges.ROWS[i].index);
            }

            var newCol = newsCols.toString();
            var newRow = newsRows.toString();

            if (newCol === '' && newRow === '') {
                this.createSmokeScreen(component.$(), 'Please select Minimum One Dimension in Row or Column');
            }

            var colArray = [];
            var rowArray = [];
            var DataRow = [];
            var DataColumn = [];
            var rowTemp;
            var colTemp;
            var newTest;
            var newcolTemp;
            for (var i = 0; i < newCol.split(',').length; i++) {
                var test = newCol.split(',');
                newTest = test[i];
                var newColLogic;
                if (i >= 1) {
                    newColLogic = test[i - 1];
                }

                for (var j = 0; j < component.dataRes.dimensions.length; j++) {
                    if (newTest === component.dataRes.dimensions[j]['picker_text']) {
                        colArray[j] = j;
                        colTemp = j;
                    }

                    if (newColLogic === component.dataRes.dimensions[j]['picker_text']) {
                        newcolTemp = j;
                    }
                }

            }
            var newTestRow;
            var newrowTemp;
            for (var k = 0; k < newRow.split(',').length; k++) {
                var testRow = newRow.split(',');
                newTestRow = testRow[k];
                var newRowLogic;
                if (k >= 1) {
                    newRowLogic = testRow[k - 1];
                }

                for (var j = 0; j < component.dataRes.dimensions.length; j++) {
                    if (newTestRow === component.dataRes.dimensions[j]['picker_text']) {
                        rowArray[j] = j;
                        rowTemp = j;
                    }

                    if (newRowLogic === component.dataRes.dimensions[j]['picker_text']) {
                        newrowTemp = j;
                    }
                }
            }

            /*
             * Main For Loop For Getting Xaxis Length And Yaxis Text.
             * Getting Tuples Lengtht(Data-Utiltity)
             */
            component.categoriesIndex = [];
            for (var i = 0; i < component.dataRes['axis_rows'].length; i++) {
                var RowName = [];
                var RowNameobj={};
                var tempRow = component.dataRes['axis_rows'][i];
                var dimensionMemberPair = '';
                if (newsRowsIndex[0] > newsRowsIndex[1]) {
                    for (k = rowArray.length - 1; k >= 0; k--) {
                        // To get only dimension members  & If measure and dimensions are present in Row
                        if (rowArray[k] == null || tempRow[dime] !== 0 && measureAxis === 'ROWS') {// jshint ignore:line
                            continue;
                        }

                        if (RowName.length !== 0) {
                            //RowName.push(component.dataRes.dimensions[k].members[tempRow[k]].text || component.dataRes.dimensions[k].members[tempRow[k]].key);
                            dimensionMemberPair = dimensionMemberPair + '-' + k + ':' + tempRow[k];
                        } else {
                            //RowName.push(component.dataRes.dimensions[k].members[tempRow[k]].text || component.dataRes.dimensions[k].members[tempRow[k]].key);
                            if (k != newsRowsIndex[1]) {
                                dimensionMemberPair = k + ':' + tempRow[k];
                            }
                        }
                        RowNameobj.key=component.dataRes.dimensions[k].members[tempRow[k]].key;
                        RowNameobj.text=component.dataRes.dimensions[k].members[tempRow[k]].text;
                        RowName.push(RowNameobj);
                        RowNameobj={};
                        if (dimensionMemberPair != '' && ($.inArray(dimensionMemberPair, component.categoriesIndex) === -1)) {// jshint ignore:line
                            component.categoriesIndex.push(dimensionMemberPair);
                        }
                    }
                } else {
                    for (var k = 0; k < rowArray.length; k++) {
                        // To get only dimension members  & If measure and dimensions are present in Row
                        if (rowArray[k] == null || tempRow[dime] !== 0 && measureAxis === 'ROWS') {// jshint ignore:line
                            continue;
                        }


                        if (RowName.length !== 0) {
                            //RowName.push(component.dataRes.dimensions[k].members[tempRow[k]].text || component.dataRes.dimensions[k].members[tempRow[k]].key);
                            dimensionMemberPair = dimensionMemberPair + '-' + k + ':' + tempRow[k];
                        } else {
                            //RowName.push(component.dataRes.dimensions[k].members[tempRow[k]].text || component.dataRes.dimensions[k].members[tempRow[k]].key);
                            dimensionMemberPair = k + ':' + tempRow[k];
                        }
                        RowNameobj.key=component.dataRes.dimensions[k].members[tempRow[k]].key;
                        RowNameobj.text=component.dataRes.dimensions[k].members[tempRow[k]].text;
                        RowName.push(RowNameobj);
                        RowNameobj={};
                        if (dimensionMemberPair != '' && ($.inArray(dimensionMemberPair, component.categoriesIndex) === -1)) {// jshint ignore:line
                            component.categoriesIndex.push(dimensionMemberPair);
                        }
                    }
                }

                if (RowName.length !== 0 && $.inArray(RowName.toString(), DataRow.toString().split(',')) === -1) {
                    // If dimensions selected in reverse order in data utility
                    // Remove duplication
                    $.each(DataRow, function(ind, val) {
                        if (val.toString() === RowName.toString()) {
                            RowName = [];
                        }
                    });
                    // Push only if Rowname is not empty
                    if (RowName.length !== 0) {
                        DataRow.push(RowName);
                    }

                }
            }
            /*
             * Including only the Data Utility Row Series
             */
            for (var i = 0; i < component.dataRes['axis_columns'].length; i++) {
                var ColName = [];
                var ColNameobj={};
                var dimensionMemberPair = '';
                var tempColumn = component.dataRes['axis_columns'][i];

                if (newsColsIndex[0] > newsColsIndex[1]) {
                    for (k = colArray.length - 1; k >= 0; k--) {
                        // To get only dimension members  & If measure and dimensions are present in Column
                        if (colArray[k] == null || tempColumn[dime] !== 0 && measureAxis === 'COLUMNS') {// jshint ignore:line
                            continue;
                        }


                        if (ColName.length !== 0) {
                            //ColName.push(component.dataRes.dimensions[k].members[tempColumn[k]].text || component.dataRes.dimensions[k].members[tempColumn[k]].key);
                            dimensionMemberPair = dimensionMemberPair + '-' + k + ':' + tempColumn[k];
                        } else {
                            //ColName.push(component.dataRes.dimensions[k].members[tempColumn[k]].text || component.dataRes.dimensions[k].members[tempColumn[k]].key);
                            if (k != newsColsIndex[1]) {
                                dimensionMemberPair = k + ':' + tempColumn[k];
                            }
                        }
                        ColNameobj.key=component.dataRes.dimensions[k].members[tempColumn[k]].key;
                        ColNameobj.text=component.dataRes.dimensions[k].members[tempColumn[k]].text;
                        ColName.push(ColNameobj);
                        ColNameobj={};
                        if (dimensionMemberPair != '' && ($.inArray(dimensionMemberPair, component.categoriesIndex) === -1)) {// jshint ignore:line
                            component.categoriesIndex.push(dimensionMemberPair);
                        }
                    }
                } else {
                    for (var k = 0; k < colArray.length; k++) {
                        // To get only dimension members  & If measure and dimensions are present in Column
                        if (colArray[k] == null || tempColumn[dime] !== 0 && measureAxis === 'COLUMNS') {// jshint ignore:line
                            continue;
                        }


                        if (ColName.length !== 0) {
                            //ColName.push(component.dataRes.dimensions[k].members[tempColumn[k]].text || component.dataRes.dimensions[k].members[tempColumn[k]].key);
                            dimensionMemberPair = dimensionMemberPair + '-' + k + ':' + tempColumn[k];
                        } else {
                            //ColName.push(component.dataRes.dimensions[k].members[tempColumn[k]].text || component.dataRes.dimensions[k].members[tempColumn[k]].key);
                            dimensionMemberPair = k + ':' + tempColumn[k];
                        }
                        ColNameobj.key=component.dataRes.dimensions[k].members[tempColumn[k]].key;
                        ColNameobj.text=component.dataRes.dimensions[k].members[tempColumn[k]].text;
                        ColName.push(ColNameobj);
                        ColNameobj={};
                        if (dimensionMemberPair != '' && ($.inArray(dimensionMemberPair, component.categoriesIndex) === -1)) {// jshint ignore:line
                            component.categoriesIndex.push(dimensionMemberPair);
                        }
                    }
                }

                if (ColName.length !== 0  && $.inArray(ColName.toString(), DataColumn.toString().split(',')) === -1) {

                    $.each(DataColumn, function(ind, val) {
                        if (val.toString() === ColName.toString()) {
                            ColName = [];
                        }
                    });

                    if (ColName.length !== 0) {
                        DataColumn.push(ColName);
                    }
                }
            }
            /*
             *Including only the Data Utility Column Series.
             */

            var utilityLogic = false;
            if (newsRows.length > 1 || newsCols.length > 1) {
                var utilityLogic = true;
            }

            if (newsRows.length > 1 || newsCols.length > 1) {
                var utilityLogic = true;
            }

            if (newTestRow === component.dataRes.dimensions[component.dataRes.dimensions.length - 1]['picker_text']) {
                if (newRow.split(',').length <= 1) {
                    utilityLogic = false;
                } else {
                    utilityLogic = true;
                }
            }

            if (newTest === component.dataRes.dimensions[component.dataRes.dimensions.length - 1]['picker_text']) {
                if (newCol.split(',').length <= 1) {
                    utilityLogic = false;
                } else {
                    utilityLogic = true;
                }
            }

            var UtitlityData = component.dataRes.tuples;
            var matched = false;// jshint ignore:line
            var arr = [];
            var arr1 = [];
            for (var i = 0; i < component.dataRes.data.length; i++) {
                var newDimTemp;
                var dimTemp;
                if (newsCols.length > 0) {
                    newDimTemp = newcolTemp;
                    dimTemp = colTemp;
                } else {
                    newDimTemp = newrowTemp;
                    dimTemp = rowTemp;
                }

                if (UtitlityData[i][dime] === treecolormeasureindex) {
                    arr = dataFormation(arr, newDimTemp, dimTemp);
                }

                if (UtitlityData[i][dime] === treesizemeasureindex && treecolormeasureindex != treesizemeasureindex) {
                    arr1 = dataFormation(arr1, newDimTemp, dimTemp);
                }

            }

            Math.stDeviation = function(array) {
                var mean = array.reduce(function(a, b) {
                        return a + b;
                    }) / array.length,
                    dev = array.map(function(itm) {
                        return (itm - mean) * (itm - mean);
                    });

                return dev.reduce(function(a, b) {
                    return a + b;
                }) / array.length;
            };

            var globalArray = [];
            var globalArray1 = [];
            if (defaultView === true) {
                if (component.dataRes.dimensions.length != newsRows.length + newsCols.length + 1 && utilityLogic === false) {
                    globalArray = aggregation(arr);
                    globalArray1 = aggregation(arr1);
                } else if (component.dataRes.dimensions.length != newsRows.length + newsCols.length + 1 && utilityLogic === true) {
                    globalArray = aggregationForUtility(arr);
                    globalArray1 = aggregationForUtility(arr1);
                } else {
                    globalArray = majorData;
                    globalArray1 = majorData1;
                }
            } else {
                globalArray = dataArrayval;
                globalArray1 = dataArrayval1;
            }
            var TreeFormatedArray = formatArray(newsRows.length, newsCols.length, DataRow, DataColumn, globalArray, globalArray1);
            var TreeFormatedArrchild = TreeFormatedArray[1];
            var TreeFormatedArrparent = TreeFormatedArray[2];
            if (component.treeColorType() === 'seriescolor') {
                for (i = 0; i < TreeFormatedArrchild.length; i++) {
                    delete TreeFormatedArrchild[i].colorValue;
                    TreeFormatedArrchild[i].color = seriesColor[i];
                }
            }

            component.measureInOriginalSeries[treesizemeasure] = 0;

            if (newsColsIndex != '' && newsColsIndex !== undefined) {// jshint ignore:line
                component.selectedRowdimIndexes = newsColsIndex;
            } else {
                component.selectedRowdimIndexes = newsRowsIndex;
            }

            component.selectedColumndimIndexes[0] = dime;
            component.columnInOriginalSeries = component.measureInOriginalSeries;
            if (ruleInfo !== '') {
                try {
                    createCFData(component, 'pie', component.fulljson());

                    that.processConditionalFormatting(component, TreeFormatedArrchild, ruleInfo, 'pie');
                } catch (y) {}
            }
            if (TreeFormatedArrparent !== '') {
                newTreeFormatedArray = TreeFormatedArrchild.concat(TreeFormatedArrparent);
                newTreeFormatedArray.sort(function(a, b) {
                    return parseFloat(a.index) - parseFloat(b.index);
                });
            } else {
                newTreeFormatedArray = TreeFormatedArrchild;
            }
            defaultValue.series[0].data = newTreeFormatedArray;
            return defaultValue.series;

        }
        /*
         * End of Data utility
         */

        /*
         *For loop for getting Col
         */
        for (var i = 0; i < component.dataRes['axis_columns'].length; i++) {
            var ColName = [];
            var ColNameobj={};
            var tempColumn = component.dataRes['axis_columns'][i];
            var dimensionMemberPair = '';

            for (var k = 0; k < tempColumn.length; k++) {

                if (tempColumn[dime] !== 0 && measureAxis === 'COLUMNS') {
                    continue;
                } else {
                    if ([dime] == k && measureAxis === 'COLUMNS') {
                        continue;
                    }
                    if (tempColumn[k] != -1) {                   
                        if (ColName.length !== 0) {
                            //ColName.push(component.dataRes.dimensions[k].members[tempColumn[k]].text || component.dataRes.dimensions[k].members[tempColumn[k]].key);
                            dimensionMemberPair = dimensionMemberPair + '-' + k + ':' + tempColumn[k];
                        } else {
                            //ColName.push(component.dataRes.dimensions[k].members[tempColumn[k]].text || component.dataRes.dimensions[k].members[tempColumn[k]].key);
                            dimensionMemberPair = k + ':' + tempColumn[k];
                        }
                        ColNameobj.key=component.dataRes.dimensions[k].members[tempColumn[k]].key;
                        ColNameobj.text=component.dataRes.dimensions[k].members[tempColumn[k]].text;
                        ColName.push(ColNameobj);
                        ColNameobj={};
                    }
                }

                if (dimensionMemberPair != '' && ($.inArray(dimensionMemberPair, component.categoriesIndex) === -1)) {// jshint ignore:line
                    component.categoriesIndex.push(dimensionMemberPair);
                }
            }

            if (ColName.length !== 0 && $.inArray(ColName, colMember) === -1) {
                colMember.push(ColName);
            }
        }
        /*
         * For loop for getting Row
         */
        for (var i = 0; i < component.dataRes['axis_rows'].length; i++) {
            var RowName = [];
            var RowNameobj={};
            var dimensionMemberPair = '';
            var tempRow = component.dataRes['axis_rows'][i];
            for (var k = 0; k < tempRow.length; k++) {
                if (tempRow[dime] !== 0 && measureAxis === 'ROWS') {
                    continue;
                } else {
                    if ([dime] == k && measureAxis === 'ROWS') {
                        continue;
                    }
                    if (tempRow[k] != -1) {
                        if (RowName.length !== 0) {
                            //RowName.push(component.dataRes.dimensions[k].members[tempRow[k]].text || component.dataRes.dimensions[k].members[tempRow[k]].key);
                            dimensionMemberPair = dimensionMemberPair + '-' + k + ':' + tempRow[k];
                           
                        } else {
                            //RowName.push(component.dataRes.dimensions[k].members[tempRow[k]].text || component.dataRes.dimensions[k].members[tempRow[k]].key);
                            dimensionMemberPair = k + ':' + tempRow[k];
                        }
                        RowNameobj.key=component.dataRes.dimensions[k].members[tempRow[k]].key;
                        RowNameobj.text=component.dataRes.dimensions[k].members[tempRow[k]].text;
                        RowName.push(RowNameobj);
                        RowNameobj={};
                    }
                }

                if (dimensionMemberPair != '' && ($.inArray(dimensionMemberPair, component.categoriesIndex) === -1)) {// jshint ignore:line
                    component.categoriesIndex.push(dimensionMemberPair);
                }
            }

            if (RowName.length !== 0 && $.inArray(RowName, rowMember) === -1) {
                rowMember.push(RowName);
            }

        }
        var TreeFormatedArray = formatArray(rowCount, colCount, rowMember, colMember, majorData, majorData1);
        var TreeFormatedArrchild = TreeFormatedArray[1];
        var TreeFormatedArrparent = TreeFormatedArray[2];
        if (component.treeColorType() === 'seriescolor') {
            for (i = 0; i < TreeFormatedArrchild.length; i++) {
                delete TreeFormatedArrchild[i].colorValue;
                TreeFormatedArrchild[i].color = seriesColor[i];
            }
        }
        if (ruleInfo !== '') {
            try {
                createCFData(component, 'pie', component.fulljson());
                that.processConditionalFormatting(component, TreeFormatedArrchild, ruleInfo, 'pie');
            } catch (y) {}
        }

        if (TreeFormatedArrparent !== '') {
            newTreeFormatedArray = TreeFormatedArrchild.concat(TreeFormatedArrparent);
            //sort array depends on index
            newTreeFormatedArray.sort(function(a, b) {
                return parseFloat(a.index) - parseFloat(b.index);
            });
        } else {
            var newTreeFormatedArray = TreeFormatedArrchild;
        }
        defaultValue.series[0].data = newTreeFormatedArray;
        return defaultValue.series;

        /*
         * Format array
         */

        function formatArray(rowCounter, colCounter, rowMem, colMem, dataArr, dataArr1) {
            var formatTreeData = [];
            var newarr = [];
            var memberData = [];
            if (rowCounter >= 1) {
                memberData = rowMem;
            } else if (colCounter >= 1) {
                memberData = colMem;
            }
            for (var i = 0; i < memberData.length; i++) {
                if (dataArr1.length >= 1) {
                    if (rowCounter === 1 || colCounter === 1) {
                        formatTreeData.push([memberData[i][0], dataArr[i], dataArr1[i]]);
                    } else {
                        if (i === 0) {
                            newarr.push(memberData[i][0], [memberData[i][1], dataArr[i], dataArr1[i]]);
                            if (i === memberData.length - 1) {
                                formatTreeData.push(newarr);
                            }
                        } else if (i === memberData.length - 1 && memberData[i - 1][0] === memberData[i][0]) {
                            newarr.push([memberData[i][1], dataArr[i], dataArr1[i]]);
                            formatTreeData.push(newarr);
                        } else if (i === memberData.length - 1 && memberData[i - 1][0] != memberData[i][0]) {
                            formatTreeData.push(newarr);
                            newarr = [];
                            newarr.push(memberData[i][0], [memberData[i][1], dataArr[i], dataArr1[i]]);
                            formatTreeData.push(newarr);
                        } else if (memberData[i - 1][0] === memberData[i][0]) {
                            newarr.push([memberData[i][1], dataArr[i], dataArr1[i]]);
                        } else {
                            formatTreeData.push(newarr);
                            newarr = [];
                            newarr.push(memberData[i][0], [memberData[i][1], dataArr[i], dataArr1[i]]);
                        }
                    }
                } else {
                    if (rowCounter === 1 || colCounter === 1) {
                        formatTreeData.push([memberData[i][0], dataArr[i]]);
                    } else {
                        if (i === 0) {
                            newarr.push(memberData[i][0], [memberData[i][1], dataArr[i]]);
                            if (i === memberData.length - 1) {
                                formatTreeData.push(newarr);
                            }
                        } else if (i === memberData.length - 1 && memberData[i - 1][0] === memberData[i][0]) {
                            newarr.push([memberData[i][1], dataArr[i]]);
                            formatTreeData.push(newarr);
                        } else if (i === memberData.length - 1 && memberData[i - 1][0] !== memberData[i][0]) {
                            formatTreeData.push(newarr);
                            newarr = [];
                            newarr.push(memberData[i][0], [memberData[i][1], dataArr[i]]);
                            formatTreeData.push(newarr);
                        } else if (memberData[i - 1][0] === memberData[i][0]) {
                            newarr.push([memberData[i][1], dataArr[i]]);
                        } else {
                            formatTreeData.push(newarr);
                            newarr = [];
                            newarr.push(memberData[i][0], [memberData[i][1], dataArr[i]]);
                        }
                    }
                }
            }

            var arrFormat = [];
            var newarrFormat = [];
            var newarrFormat1 = [];
            var count = 0;
            for (var i = 0; i < formatTreeData.length; i++) {

                if (rowCounter === 1 || colCounter === 1) {
                    if (dataArr1.length >= 1) {
                        /*if(formatTreeData[i][1]==null){
                                formatTreeData[i][1]=0;
                        }

                        if(formatTreeData[i][2]==null){
                            formatTreeData[i][2]=0;
                        }*/
                        arrFormat.push({
                            name: formatTreeData[i][0].text,
                            value: formatTreeData[i][1],
                            colorValue: formatTreeData[i][2]
                        });
                        newarrFormat.push({
                            name: formatTreeData[i][0].text,
                            value: formatTreeData[i][1],
                            colorValue: formatTreeData[i][2]
                        });
                        //arrFormat.push({ name: formatTreeData[i][0], value: formatTreeData[i][1], seriesColor[i]});
                    } else {
                        arrFormat.push({
                            name: formatTreeData[i][0].text,
                            value: formatTreeData[i][1]
                        });
                        newarrFormat.push({
                            name: formatTreeData[i][0].text,
                            value: formatTreeData[i][1]
                        });
                    }
                } else {

                    for (var j = 0; j < formatTreeData[i].length; j++) {
                        var countr = count++;
                        var arr = {};
                        var arrnew = {};
                        var arrnew1 = {};
                        if (j === 0) {

                            arr.id = formatTreeData[i][j].key;
                            arr.name = formatTreeData[i][j].text;

                            arrnew1.id = formatTreeData[i][j].key;
                            arrnew1.name = formatTreeData[i][j].text;
                            arrnew1.index = countr;
                        } else if (Array.isArray(formatTreeData[i][j])) {

                            arr.parenttext = formatTreeData[i][0].text;
                            arr.parent = formatTreeData[i][0].key;
                            arr.name = formatTreeData[i][j][0].text;
                            arr.id = formatTreeData[i][j][0].key;
                            arr.value = formatTreeData[i][j][1];

                            arrnew.parenttext = formatTreeData[i][0].text;
                            arrnew.parent = formatTreeData[i][0].key;
                            arrnew.name = formatTreeData[i][j][0].text;
                            arrnew.id = formatTreeData[i][j][0].key;
                            arrnew.value = formatTreeData[i][j][1];
                            arrnew.index = countr;
                            if (dataArr1.length >= 1) {
                                arr.colorValue = formatTreeData[i][j][2];
                                arrnew.colorValue = formatTreeData[i][j][2];
                            }
                        }
                        arr.index = countr;


                        for (var k in arrFormat) {
                            if (arrFormat[k]['id'] === arr['id'] && arr.id !== undefined) {
                                arr = {};
                            }

                        }

                        for (var k in newarrFormat1) {
                            if (newarrFormat1[k]['id'] === arrnew1['id'] && arrnew1.id !== undefined) {
                                arrnew1 = {};
                            }
                        }

                        if (!jQuery.isEmptyObject(arr)) {
                            arrFormat.push(arr);

                        }

                        if (!jQuery.isEmptyObject(arrnew)) {
                            newarrFormat.push(arrnew);
                        }

                        if (!jQuery.isEmptyObject(arrnew1)) {
                            newarrFormat1.push(arrnew1);
                        }

                    }
                }
            }

            // console.log([arrFormat,newarrFormat,newarrFormat1]);
            return [arrFormat, newarrFormat, newarrFormat1];
        }

        function dataFormation(dataFormat, newDimTemp, dimTemp) {
            var matched = false;
            
            /*
             * Same logic as Edit Intial view for removing result value.
             */

            // utilityLogic=true;

            if (matched === false) {
                if (utilityLogic === true) {
                    for (var q = 0; q < component.dataRes.dimensions[newDimTemp].members.length; q++) {
                        if (dataFormat[q] === undefined ) {
                            dataFormat[q] = [];
                        }
                        if (UtitlityData[i][newDimTemp] === q) {
                            for (var m = 0; m < component.dataRes.dimensions[dimTemp].members.length; m++) {
                                if (dataFormat[q][m] === undefined ) {
                                    dataFormat[q][m] = [];
                                }
                                if (UtitlityData[i][dimTemp] === m) {
                                    var temp = component.dataRes.data[i];
                                    if (temp != null) {// jshint ignore:line
                                        dataFormat[q][m].push(temp);
                                    }
                                }
                            }
                        }
                    }

                } else {
                    for (var m = 0; m < component.dataRes.dimensions[dimTemp].members.length; m++) {
                        if (dataFormat[m] === undefined) {
                            dataFormat[m] = [];
                        }
                        if (UtitlityData[i][dimTemp] === m) {
                            var temp = component.dataRes.data[i];
                            if (temp != null) {// jshint ignore:line
                                dataFormat[m].push(temp);
                            }
                        }
                    }
                }

            }

            return dataFormat;
        }

        function aggregation(arr) {
            var aggArr = [];
            var total;
            for (var o = 0; o < arr.length; o++) {
                if (arr[o] != null) {// jshint ignore:line
                    if (arr[o].length !== 0) {
                        if (component.chartaggregation() === 'sum') {
                            total = arr[o].reduce(function(a, b) {
                                return a + b;
                            });

                        } else if (component.chartaggregation() === 'min') {
                            total = arr[o].reduce(function(a, b) {
                                return a < b ? a : b;
                            });

                        } else if (component.chartaggregation() === 'max') {
                            total = arr[o].reduce(function(a, b) {
                                return a > b ? a : b;
                            });

                        } else if (component.chartaggregation() === 'avg') {
                            total = arr[o].reduce(function(a, b) {
                                return a + b;
                            });

                            total = total / arr[o].length;
                        } else if (component.chartaggregation() === 'variance') {
                            total = Math.stDeviation(arr[o]);
                        } else if (component.chartaggregation() === 'sd') {
                            total = Math.sqrt(Math.stDeviation(arr[o]));
                        }
                    } else {
                        total = null;
                    }
                }

                if (total != null) {// jshint ignore:line
                    aggArr.push(total);
                }
            }

            return aggArr;
        }

        // Aggregation function when more than 2 dimensions are present in initial view, selecting 2 dimensions in utility
        function aggregationForUtility(standardLogic) {
            var aggArray = [];
            var total;

            /*
             * Getting the lasted Selected array And creating the array according previous selected member.
             */
            for (var o = 0; o < standardLogic.length; o++) {
                if (standardLogic[o] != null) {// jshint ignore:line
                    for (var p = 0; p < standardLogic[o].length; p++) {
                        if (standardLogic[o][p] != null) {// jshint ignore:line
                            if (standardLogic[o][p].length !== 0) {
                                if (component.chartaggregation() === 'sum') {
                                    total = standardLogic[o][p].reduce(function(a, b) {
                                        return a + b;
                                    });
                                } else if (component.chartaggregation() === 'min') {
                                    total = standardLogic[o][p].reduce(function(a, b) {
                                        return a < b ? a : b;
                                    });

                                } else if (component.chartaggregation() === 'max') {
                                    total = standardLogic[o][p].reduce(function(a, b) {
                                        return a > b ? a : b;
                                    });

                                } else if (component.chartaggregation() === 'avg') {
                                    total = standardLogic[o][p].reduce(function(a, b) {
                                        return a + b;
                                    });

                                    total = total / standardLogic[o][p].length;
                                } else if (component.chartaggregation() === 'variance') {
                                    total = Math.stDeviation(arr[o][p]);
                                } else if (component.chartaggregation() === 'sd') {
                                    total = Math.sqrt(Math.stDeviation(arr[o][p]));
                                }
                            } else {
                                total = null;
                            }

                            if (total != null) {// jshint ignore:line
                                aggArray.push(total);
                            }
                        }
                    }
                }
            }

            return aggArray;

            /*
             * Suming the entire value using ".reduce Method"
             */
        }

        function createCFData(component) {
            var completeJSONCF = component.dataRes;
            var measureDimIndex = component.getMeasureIndex();

            if (completeJSONCF === undefined || completeJSONCF === '' || completeJSONCF == null) {// jshint ignore:line
                return '';
            }

            var seriesColor = component.dataseriescolor().split(',');

            component.categoryInCFSeries = {};
            component.measureInCFSeries = {};
            var sortedArray = [];
            var dimMesIndexJson = getDimMesJson(component);
            //var measureKey = completeJSONCF.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].key;
            for (var z = 0; z < completeJSONCF.dimensions[measureDimIndex].members.length; z++) {
                component.measureInCFSeries[completeJSONCF.dimensions[measureDimIndex].members[z].key] = z;
            }
            var CFseriesData = [];
            if (dimMesIndexJson.dimIndexArray.length > 0) {
                var dataArray = [];
                var mesDimListIndex = [];
                var categoriesArray = [];
                var categoriesKeyArray = [];
                var aggregationCountArray = [];
                component.tempAggregationArray = [];
                var measureIndexArray = [];
                var execute = true;
                var x;
                var checkArray = [];
                var count = [];
                var scalingFactor = [];
                var pieName = '';
                var catName = [];
                var catKey = [];
                for (var i = 0; i < completeJSONCF.data.length; i++) {
                    var y = '';
                    var categories = [];
                    var categoriesKey = [];
                    var tempKey = '';
                    mesDimListIndex[i] = '';
                    var execute = true;
                    var highlightedMesIndex = dimMesIndexJson.mesIndex;
                    var currentTuple = completeJSONCF.tuples[i][measureDimIndex];
                    if (measureIndexArray.indexOf(currentTuple) === -1) {
                        measureIndexArray.push(currentTuple);
                        categoriesArray[currentTuple] = [];
                        categoriesKeyArray[currentTuple] = [];
                        dataArray[currentTuple] = [];
                        checkArray[currentTuple] = [];
                        scalingFactor[currentTuple] = completeJSONCF.dimensions[measureDimIndex].members[currentTuple].scalingFactor;
                        count[currentTuple] = -1;
                    }

                    for (var j = 0; j < dimMesIndexJson.dimIndexArray.length; j++) {
                        pieName = completeJSONCF.dimensions[dimMesIndexJson.dimIndexArray[j]].text;
                        y = y + '' + completeJSONCF.tuples[i][dimMesIndexJson.dimIndexArray[j]];
                        tempKey = tempKey + '-' + dimMesIndexJson.dimIndexArray[j] + ':' + completeJSONCF.tuples[i][dimMesIndexJson.dimIndexArray[j]];
                        categories.push(completeJSONCF.dimensions[dimMesIndexJson.dimIndexArray[j]].members[completeJSONCF.tuples[i][dimMesIndexJson.dimIndexArray[j]]].text);
                        categoriesKey.push(completeJSONCF.dimensions[dimMesIndexJson.dimIndexArray[j]].members[completeJSONCF.tuples[i][dimMesIndexJson.dimIndexArray[j]]].key);
                      
                    }

                    tempKey = tempKey.substr(1);
                    if (execute) {
                        if (checkArray[currentTuple].indexOf(y) === -1) {
                            count[currentTuple]++;
                            aggregationCountArray[count[currentTuple]] = [];
                            if (highlightedMesIndex === currentTuple) {
                                component.valueAggregation(component, completeJSONCF.data[i] * Math.pow(10, scalingFactor[currentTuple]), dataArray[checkArray.indexOf(y)], aggregationCountArray, count[currentTuple]);
                            }

                            categoriesArray[currentTuple] = categories.join('\\');
                            categoriesKeyArray[currentTuple] = categoriesKey.join('\\');
                            catKey[count[currentTuple]] = categoriesKeyArray[currentTuple];
                            catName[count[currentTuple]] = categoriesArray[currentTuple];

                            component.categoryInCFSeries[categoriesKeyArray[currentTuple]] = count[currentTuple];
                            mesDimListIndex[count[currentTuple]] = tempKey;
                            x = y;
                            checkArray[currentTuple].push(y);
                            dataArray[currentTuple][count[currentTuple]] = completeJSONCF.data[i] * Math.pow(10, scalingFactor[currentTuple]);

                        } else {
                            if (highlightedMesIndex === currentTuple) {
                                aggregationCountArray[checkArray[currentTuple].indexOf(y)]++;
                                dataArray[currentTuple][checkArray[currentTuple].indexOf(y)] = component.valueAggregation(component, completeJSONCF.data[i] * Math.pow(10, scalingFactor[currentTuple]), dataArray[currentTuple][checkArray[currentTuple].indexOf(y)], aggregationCountArray, checkArray[currentTuple].indexOf(y));
                            } else {
                                dataArray[currentTuple][checkArray[currentTuple].indexOf(y)] = dataArray[currentTuple][checkArray[currentTuple].indexOf(y)] + completeJSONCF.data[i] * Math.pow(10, scalingFactor[currentTuple]);
                            }
                        }
                    }
                }

                for (var j = 0; j < dataArray.length; j++) {
                    sortedArray[j] = [];
                    for (var i = 0; i < dataArray[j].length; i++) {
                        sortedArray[j].push({
                            name: catName[i],
                            keyName: catKey[i],
                            color: seriesColor[i],
                            data: dataArray[j][i],
                            key: mesDimListIndex[i]
                        });
                    }
                }
                var measureColorPair;
                if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
                    measureColorPair = JSON.parse(component.measurecolorpair());
                }


                for (var j = 0; j < sortedArray.length; j++) {
                    CFseriesData.push({
                        name: completeJSONCF.dimensions[measureDimIndex].members[j].key,
                        data: []
                    });
                    for (var i = 0; i < sortedArray[j].length; i++) {
                        CFseriesData[j].data = dataArray[j]; //component.categoryInCFSeries[sortedArray[j][i].keyName] = j;
                    }
                }

                //var localtotalpie = [];
            }

            component.columnInCFSeries = component.measureInCFSeries;
            component.conditionalFormattingData = CFseriesData;
        }

        function dataArr(component, dimMesIndexJson, treeindex, measureIndex) {
            var dataArray = [];
            if (dimMesIndexJson.dimIndexArray.length > 0 && dimMesIndexJson.mesIndex != -1) {
                var mesDimListIndex = [];
                var categoriesArray = [];
                var categoriesKeyArray = [];
                var aggregationCountArray = [];
                var execute = true;
                component.tempAggregationArray = [];
                var x;
                var checkArray = [];
                var count = -1;
                for (var i = 0; i < component.dataRes.data.length; i++) {
                    var y = '';
                    var categories = [];
                    var categoriesKey = [];
                    var tempKey = '';
                    mesDimListIndex[i] = '';
                    var execute = true;
                    if (component.dataRes.tuples[i][measureIndex] === treeindex) {
                        for (var j = 0; j < dimMesIndexJson.dimIndexArray.length; j++) {
                            y = y + '' + component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]];
                            tempKey = tempKey + '-' + dimMesIndexJson.dimIndexArray[j] + ':' + component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]];
                            categories.push(component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]].members[component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]]].text);
                            categoriesKey.push(component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]].members[component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]]].key);
                            
                        }

                        tempKey = tempKey.substr(1);
                        if (execute) {
                            if (checkArray.indexOf(y) === -1) {
                                count++;
                                aggregationCountArray[count] = 0;
                                that.valueAggregation(component, component.dataRes.data[i], dataArray[checkArray.indexOf(y)], aggregationCountArray, count);
                                categoriesArray[count] = categories.join('\\');
                                categoriesKeyArray[count] = categoriesKey.join('\\');
                                mesDimListIndex[count] = tempKey;
                                x = y;
                                checkArray.push(y);
                                dataArray[count] = component.dataRes.data[i];
                            } else {
                                aggregationCountArray[checkArray.indexOf(y)]++;
                                dataArray[checkArray.indexOf(y)] = that.valueAggregation(component, component.dataRes.data[i], dataArray[checkArray.indexOf(y)], aggregationCountArray, checkArray.indexOf(y));
                            }
                        }
                    }
                }
            }

            return dataArray;
        }

        function getDimMesJson(component) {

            var dimMesJson = {};
            var memIndexArray = [];
            var measureIndex;
            if (component.measurelist() === '' || component.measurelist() === undefined || component.measurelist() == null) {// jshint ignore:line
                var measureIndex = 0;
            } else {
                var measureMembersArr = component.getMeasureMembersKeyAndText();
                measureIndex = measureMembersArr[1].indexOf(component.measurelist());
                if (measureIndex === -1) {
                    if (measureMembersArr[0].indexOf(component.measurelist()) !== -1) {
                        measureIndex = measureMembersArr[0].indexOf(component.measurelist());
                    } else {
                        measureIndex = 0;
                    }
                }
            }

                measureIndex = 0;
                var rowIndex = component.dataRes['axis_columns'][0].indexOf(-1);
                if (rowIndex !== -1) {
                    for (var i = rowIndex; i < component.dataRes.dimensions.length; i++) {
                        if (!component.dataRes.dimensions[i].containsMeasures) {
                            memIndexArray.push(i);
                        }
                    }
                } else {
                    rowIndex = component.dataRes.dimensions.length;
                }

                if (memIndexArray.length === 0) {
                    for (var i = 0; i < rowIndex; i++) {
                        if (!component.dataRes.dimensions[i].containsMeasures) {
                            memIndexArray.push(i);
                        }
                    }
                }

                dimMesJson = {
                    'mesIndex': 0,
                    'dimIndexArray': memIndexArray,
                    'dimensionAxis': 'rows'
                };
            

            return dimMesJson;
        }

    };

}