function treeMapDrilldownSeries() {// jshint ignore:line
    var that = this;

    /*
     * Includes required methods from other files
     */
    /*
     implementMethods(that, { // that refers to seriesLibrary object
         familyBar : []
     });
     */
    /**
     * Map data from JSON Tuple to Highchart
     * @override
     * @param {object} component - Reference to component
     * @param {string} type - type of the chart
     * @param {object} defaultValue - HighCharts values
     * @return {Array} seriesNames
     */
    that.createSeriesData = function(component, type, defaultValue, cfStatus, setval) {
        var self = this;
        var seriesColor = component.dataseriescolor().split(',');
        component.categoriesIndex = [];
        //var columnCount = 0;
        var colCount = 0;
        var rowCount = 0;
        var dimension = 0;
        //var localResult = component.showtotal();
        var colMember = [];
        var rowMember = [];
        var resultData = [];
        //var newmajorData = [];
        var dime;
        var measureAxis;
        var majorData = [];
        var majorData1 = [];
        //var ruleInfo = '';
        component.maxvalueJSON = 0;
        var lowest = Number.POSITIVE_INFINITY;
        var highest = Number.NEGATIVE_INFINITY;
        var tmp;
        var hierarchy = component.isHierarchy;
        component.measureInOriginalSeries = {};
        component.categoryInOriginalSeries = {};
        component.columnInOriginalSeries = {};
        component.selectedRowdimIndexes = [];
        component.selectedColumndimIndexes = [];
        component.ztlSelectedRowJson = {};
        component.ztlSelectedColumnJson = {};
        var measurelist = component.getDataSeries();
        for (var i = 0; i < measurelist[1].length; i++) {
            component.categoryInOriginalSeries[measurelist[1][i]] = i;
        }

        /*var bardatacustomizationJson = {
            'COLUMNS': [],
            'ROWS': []
        };*/

        if (component.dataRes === undefined || component.dataRes === '') {
            return '';
        }

        var newRowIndex = [];
        var newsColIndex = [];
        //var categoryDataRowAggr = [];
        for (var lenn = 0; lenn < component.dataRes.dimensions.length; lenn++) {
            if (component.dataRes.dimensions[lenn].containsMeasures !== true) {
                for (var e = 0; e < component.dataRes.dimensions[lenn].members.length; e++) {
                    if (component.dataRes.dimensions[lenn].members[e].type == 'RESULT') {
                        resultData[lenn] = e;
                    }
                }

                dimension++;
                if (component.dataRes.dimensions[lenn].axis == 'COLUMNS') {
                    colCount++;
                    newsColIndex.push(lenn);
                } else if (component.dataRes.dimensions[lenn].axis == 'ROWS') {
                    rowCount++;
                    newRowIndex.push(lenn);
                }
            } else {
                dime = lenn;
                measureAxis = component.dataRes.dimensions[lenn].axis;
            }
        }
        /*
         * Condition for tuples not equal to "TYPE==RESULT"
         */
        var treecolormeasure = component.treecolormeasure();
        var treesizemeasure = component.treesizemeasure();
        var getMeasureArr = component.getMeasureArr();
        var treecolormeasureindex = getMeasureArr[0].indexOf(treecolormeasure);
        var treesizemeasureindex = getMeasureArr[0].indexOf(treesizemeasure);
        var treecolormeasurename = getMeasureArr[1][treecolormeasureindex];
        //var treesizemeasurename = getMeasureArr[1][treesizemeasureindex];
        var TempData = component.dataRes.tuples;
        for (var d = 0; d < component.dataRes.data.length; d++) {
            if (TempData[d][dime] == treecolormeasureindex)
            /*
             * Condition for Measure[0]
             */
            {
                var matched = false;
                for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                    if (TempData[d][i] == resultData[i]) {
                        matched = true;
                        break;
                    }
                }

                if (matched === false) {
                    majorData.push(component.dataRes.data[d]);
                }
            } else if (TempData[d][dime] == treesizemeasureindex) {
                var matched = false;
                for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                    if (TempData[d][i] == resultData[i]) {
                        matched = true;
                        break;
                    }
                }

                if (matched === false) {
                    majorData1.push(component.dataRes.data[d]);
                }
            }
        }

        component.ztlSelectedColumnJson[treecolormeasure] = {
            'internalKey': treecolormeasure,
            'text': treecolormeasurename
        };

        var dimMesIndexJson = getDimMesJson(component, self);
        var measureDimIndex = component.getMeasureIndex();
        var aggArray = [];
        var aggArray1 = [];
        aggArray = dataArr(component, dimMesIndexJson, treecolormeasureindex, measureDimIndex);
        if (treecolormeasureindex != treesizemeasureindex) {
            aggArray1 = dataArr(component, dimMesIndexJson, treesizemeasureindex, measureDimIndex);
        }

        var arr = {};
        var arrFormat = [];
        for (var i = 0; i < aggArray.length; i++) {
            arr.id = aggArray[i].key;
            arr.name = aggArray[i].name;
            arr.value = aggArray[i].value;
            arr.parenttext=aggArray[i].name;
            if (aggArray1.length !== 0) {
                arr.colorValue = aggArray1[i].value;
            }

            arr.namekey = aggArray[i].Namekey;
            var res = aggArray[i].Namekey.split('-');
            arr.level = res.length - 1;

            for (var k in arrFormat) {
                if (arrFormat[k]['id'] === arr['id'] && arr.id !== undefined) {
                    arr = {};
                }
            }

            if (!jQuery.isEmptyObject(arr)) {
                arrFormat.push(arr);
                arr = {};
            }

            for (var j = 0; j < aggArray[i].data.length; j++) {
                var s = getDifference(aggArray[i].name + '/', aggArray[i].data[j].name);
                arr.id = aggArray[i].data[j].key;
                arr.name = s;
                arr.parent = aggArray[i].key;
                arr.parenttext = aggArray[i].name;
                arr.value = aggArray[i].data[j].y;
                arr.namekey = aggArray[i].data[j].Namekey;
                if (aggArray1.length !==0) {
                    arr.colorValue = aggArray1[i].data[j].y;
                }

                var res = aggArray[i].data[j].Namekey.split('-');
                arr.level = res.length - 1;
                for (var k in arrFormat) {
                    if (arrFormat[k]['id'] === arr['id'] && arr.id !== undefined) {
                        arr = {};
                    }
                }

                if (!jQuery.isEmptyObject(arr)) {
                    arrFormat.push(arr);
                    arr = {};
                }
            }
        }

        if (hierarchy === false) {
            if (component.treeColorType() == 'seriescolor') {
                var countValue = 0;
                for (i = 0; i < arrFormat.length; i++) {
                    delete arrFormat[i].colorValue;
                    if (arrFormat[i].level === 0) {
                        arrFormat[i].color = seriesColor[countValue];
                        countValue++;
                    }
                }
            }
            for (var i = arrFormat.length - 1; i >= 0; i--) {
                tmp = arrFormat[i].level;
                if (tmp < lowest) {
                    lowest = tmp;
                }
                if (tmp > highest) {
                    highest = tmp;
                }
            }

            component.maxvalueJSON = highest;
            defaultValue.series[0].data = arrFormat;
            return defaultValue.series;
        }

        if (hierarchy === true) {
            var rowArr = [];
            var colArr = [];
            var setflag = false;
            var setflag1 = false;
            var seriesLev = [];
            if (component.enablehierarchydrilldown() === true && JSON.stringify(component.dataRes).indexOf('HIERARCHY_NODE') != -1) {
                for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                    if (JSON.stringify(component.dataRes.dimensions[i]).indexOf('HIERARCHY_NODE') != -1) {
                        component.selectedDimension = i;
                        break;
                    }
                }
                for (var i = 0; i < component.dataRes.dimensions[component.selectedDimension].members.length; i++) {
                    if (component.dataRes.dimensions[component.selectedDimension].members[i].level) {
                        seriesLev.push(component.dataRes.dimensions[component.selectedDimension].members[i].level);
                    }
                }

                component.largest = Math.max.apply(Math, seriesLev);
            }

            for (var i = 0; i < component.dataRes['axis_rows'].length; i++) {
                var RowName = [];
                //var dimensionMemberPair = '';
                var tempRow = component.dataRes['axis_rows'][i];
                var dimarr;
                for (var k = 0; k < tempRow.length; k++) {
                    if (k != component.selectedDimension) {
                        continue;
                    }

                    if (tempRow[dime] !== 0 && measureAxis == 'ROWS') {
                        continue;
                    } else {
                        if ([dime] == k && measureAxis == 'ROWS') {
                            continue;
                        }
                        if (tempRow[k] != -1) {

                            if (component.dataRes.dimensions[k].members[tempRow[k]].type == 'RESULT') {
                                RowName = [];
                                continue;
                            }

                            if (component.dataRes.dimensions[k].members[tempRow[k]].nodeState == 'COLLAPSED' && component.dataRes.dimensions[k].members[tempRow[k]].level === undefined) {
                                RowName.push(component.dataRes.dimensions[k].members[tempRow[k]].text + '##$$##' + component.dataRes.dimensions[k].members[tempRow[k]].key + '##$$##' + component.dataRes.dimensions[k].members[tempRow[k]].nodeState);
                                RowName.push(0);
                                setflag = true;
                            } else {
                                setflag1 = true;
                                if (component.dataRes.dimensions[k].members[tempRow[k]].level === undefined || component.dataRes.dimensions[k].members[tempRow[k]].level === '') {
                                    dimarr = '';
                                    dimarr = component.dataRes.dimensions[k].members[tempRow[k]].text + '##$$##' + component.dataRes.dimensions[k].members[tempRow[k]].key + '##$$##' + component.dataRes.dimensions[k].members[tempRow[k]].nodeState;
                                } else {
                                    RowName.push(component.dataRes.dimensions[k].members[tempRow[k]].text + '##$$##' + component.dataRes.dimensions[k].members[tempRow[k]].key + '##$$##' + component.dataRes.dimensions[k].members[tempRow[k]].nodeState);
                                    RowName.push(component.dataRes.dimensions[k].members[tempRow[k]].level);
                                    RowName.push(dimarr);
                                }
                            }
                        }
                    }
                }

                if (RowName.length !== 0) {
                    rowArr.push(RowName);
                }
            }
            for (var i = 0; i < component.dataRes['axis_columns'].length; i++) {
                var ColName = [];
                var tempColumn = component.dataRes['axis_columns'][i];
                //var dimensionMemberPair = '';
                for (var k = 0; k < tempColumn.length; k++) {
                    if (tempColumn[dime] !== 0 && measureAxis == 'COLUMNS') {
                        continue;
                    } else {
                        if ([dime] == k && measureAxis == 'COLUMNS') {
                            continue;
                        }
                        if (tempColumn[k] != -1) {

                            if (component.dataRes.dimensions[k].members[tempColumn[k]].type == 'RESULT') {
                                ColName = [];
                                continue;
                            }

                            if (component.dataRes.dimensions[k].members[tempColumn[k]].nodeState == 'COLLAPSED' && component.dataRes.dimensions[k].members[tempColumn[k]].level === undefined) {
                                ColName.push(component.dataRes.dimensions[k].members[tempColumn[k]].text + '##$$##' + component.dataRes.dimensions[k].members[tempColumn[k]].key);
                            } else {
                                if (component.dataRes.dimensions[k].members[tempColumn[k]].level === undefined || component.dataRes.dimensions[k].members[tempColumn[k]].level === '') {
                                    var dimarr = '';
                                    dimarr = component.dataRes.dimensions[k].members[tempColumn[k]].text + '##$$##' + component.dataRes.dimensions[k].members[tempColumn[k]].key;
                                } else {
                                    ColName.push(component.dataRes.dimensions[k].members[tempColumn[k]].text + '##$$##' + component.dataRes.dimensions[k].members[tempColumn[k]].key);
                                    ColName.push(component.dataRes.dimensions[k].members[tempColumn[k]].level);
                                    ColName.push(dimarr);
                                }
                            }
                        }
                    }
                }

                if (ColName.length !== 0) {
                    colArr.push(ColName);
                }
            }

            var finalArr = [];
            if (rowCount >= 1) {
                finalArr = rowArr;
            } else {
                finalArr = colArr;
            }

            var maxArr = [];
            var maxvalue;
            var flagvalue = false;
            for (var i = 0; i < finalArr.length; i++) {
                if (finalArr[i].length > 2) {
                    if (flagvalue === false) {
                        maxArr.push({
                            name: finalArr[i][2],
                            value: finalArr[i][1]
                        });
                        flagvalue = true;
                    } else if (finalArr[i][2] !== undefined && finalArr[i - 1][2] !== undefined) {
                        if (finalArr[i][2] != finalArr[i - 1][2]) {
                            maxvalue = '';
                            maxArr.push({
                                name: finalArr[i][2],
                                value: finalArr[i][1]
                            });
                        } else {
                            if (maxvalue === '' || maxvalue === undefined) {
                                maxvalue = finalArr[i][1];
                            }

                            if (finalArr[i][1] >= maxvalue) {
                                maxArr.pop();
                                maxvalue = finalArr[i][1];
                                maxArr.push({
                                    name: finalArr[i][2],
                                    value: maxvalue
                                });
                            }
                        }
                    } else {
                        maxArr.push({
                            name: finalArr[i][2],
                            value: finalArr[i][1]
                        });
                    }
                }
            }

            var val = [];
            var incrementVar = [];
            var finalMember = [];
            var incrementVarb = [];
            if (setflag1 === true && setflag === false) {
                for (var i = 0; i < finalArr.length; i++) {
                    if (i === 0) { //i==0
                        val.push(finalArr[i][0]);
                        if (i == finalArr.length - 1) { //only 1 value
                            val.unshift(finalArr[i][2]);
                            finalMember.push(val);
                        }
                    } else if (finalArr[i][1] == finalArr[i - 1][1] + 1) { //for increamental levels ie i[1]=2 and i-1[1]=1
                        val.push(finalArr[i][0]);
                        if (i == finalArr.length - 1) { //for increamental levels and its last
                            val.unshift(finalArr[i][2]);
                            finalMember.push(val);
                        }
                    } else if (finalArr[i][1] <= finalArr[i - 1][1]) { //for same level elements i[1]=1 and i-1[1]=1 or i[1]=1 and i-1[1]=4
                        incrementVar = val.slice();
                        val.unshift(finalArr[i - 1][2]);
                        finalMember.push(val);
                        var toSpilce = finalArr[i][1];
                        incrementVar.splice(toSpilce - 1);
                        incrementVar.push(finalArr[i][0]);
                        val = [];
                        val = incrementVar;
                        if (i == finalArr.length - 1) {
                            val.unshift(finalArr[i][2]);
                            finalMember.push(val);
                        }
                    }
                }
            } else {
                var flagval = false;
                var setfl = false;
                var maxval;
                for (var i = 0; i < finalArr.length; i++) {
                    if (finalArr[i].length > 2) {
                        if (flagval === false) {
                            val.push(finalArr[i][0]);
                            maxval = search(finalArr[i][2], maxArr);
                            if (maxval.value == finalArr[i][1]) {
                                val.unshift(finalArr[i][2]);
                                finalMember.push(val);
                            }

                            flagval = true;
                        } else if (finalArr[i][1] == finalArr[i - 1][1] + 1 && finalArr[i][2] == finalArr[i - 1][2]) { //for increamental levels ie i[1]=2 and i-1[1]=1
                            val.push(finalArr[i][0]);
                            maxval = search(finalArr[i][2], maxArr);
                            incrementVar = val.slice();
                            if (maxval.value == finalArr[i][1]) {
                                if (setfl === false) {
                                    val.unshift(finalArr[i][2]);
                                } else {
                                    finalMember.pop();
                                }

                                finalMember.push(val);
                                val = [];
                                val = incrementVar;
                            }
                        } else if (finalArr[i][1] <= finalArr[i - 1][1] && finalArr[i][2] == finalArr[i - 1][2]) { //for same level elements i[1]=1 and i-1[1]=1 or i[1]=1 and i-1[1]=4
                            maxval = search(finalArr[i][2], maxArr);
                            if (finalArr[i][1] == finalArr[i - 1][1] /*&& maxval.value==finalArr[i][1]finalArr[i][1]==component.largest*/ ) {
                                incrementVar = val.slice();
                                if (finalArr[i - 1][1] != maxval.value) {
                                    val.unshift(finalArr[i - 1][2]);
                                    finalMember.push(val);
                                }

                                incrementVar.splice(-1);
                                incrementVar.push(finalArr[i][0]);
                                val = [];
                                val = incrementVar;
                                incrementVarb = val.slice();
                                if (finalArr[i][1] == maxval.value) {
                                    val.unshift(finalArr[i][2]);
                                    finalMember.push(val);
                                }

                                val = [];
                                val = incrementVarb;
                            } else if (finalArr[i][1] < finalArr[i - 1][1]) {
                                incrementVar = val.slice();
                                if (finalArr[i - 1][1] != maxval.value) {
                                    val.unshift(finalArr[i - 1][2]);
                                    finalMember.push(val);
                                }

                                var toSpilce = finalArr[i][1];
                                incrementVar.splice(toSpilce - 1);
                                incrementVar.push(finalArr[i][0]);
                                val = [];
                                val = incrementVar;
                                if (finalArr[i][1] == maxval.value) {
                                    val.unshift(finalArr[i][2]);
                                    finalMember.push(val);
                                } else {
                                    val.unshift(finalArr[i][2]);
                                    finalMember.push(val);
                                    setfl = true;
                                }
                            }
                        } else if (finalArr[i][1] <= finalArr[i - 1][1] && finalArr[i][2] != finalArr[i - 1][2]) {
                            maxval = search(finalArr[i][2], maxArr);
                            if (maxval.value == finalArr[i][1]) {
                                val = [];
                                val.push(finalArr[i][0]);
                                val.unshift(finalArr[i][2]);
                                finalMember.push(val);
                            } else if (maxval.value != finalArr[i][1]) {
                                val = [];
                                val.push(finalArr[i][0]);
                            }
                        } else {
                            maxval = search(finalArr[i][2], maxArr);
                            val = [];
                            val.push(finalArr[i][0]);
                            if (finalArr[i][1] == maxval.value) {
                                val.unshift(finalArr[i][2]);
                                finalMember.push(val);
                            }
                        }
                    } else {
                        val = [];
                        val.push(finalArr[i][0]);
                        finalMember.push(val);
                        val = [];
                    }
                }
            }

            if (rowCount >= 1) {
                rowMember = finalMember;
            } else {
                colMember = finalMember;
            }
        }

        var TreeFormatedArray = formatArray(rowCount, colCount, rowMember, colMember, majorData, majorData1, hierarchy, aggArray, aggArray1);
        var TreeFormatedArrmain = TreeFormatedArray[0];
        if (component.treeColorType() == 'seriescolor') {
            if ((component.includerootnodes() === true && component.enablehierarchydrilldown() === true && JSON.stringify(component.dataRes).indexOf('HIERARCHY_NODE') != -1) || (JSON.stringify(component.dataRes).indexOf('HIERARCHY_NODE') == -1)) {
                var countValue = 0;
                for (i = 0; i < TreeFormatedArrmain.length; i++) {
                    delete TreeFormatedArrmain[i].colorValue;
                    if (TreeFormatedArrmain[i].level === 0) {
                        TreeFormatedArrmain[i].color = seriesColor[countValue];
                        countValue++;
                    }
                }
            } else {
                var countValue = 0;
                for (i = 0; i < TreeFormatedArrmain.length; i++) {
                    delete TreeFormatedArrmain[i].colorValue;
                    if (TreeFormatedArrmain[i].level == 1) {
                        TreeFormatedArrmain[i].color = seriesColor[countValue];
                        countValue++;
                    }
                }
            }
        }
        var allowednooflevels = Number(component.allowednooflevels());
        if (isNaN(allowednooflevels) || allowednooflevels < 2) {
            allowednooflevels = 1000;
        }
        if (component.includerootnodes()) {
            allowednooflevels = allowednooflevels - 1;
        }
        if (component.includerootnodes() === false && component.enablehierarchydrilldown() === true && JSON.stringify(component.dataRes).indexOf('HIERARCHY_NODE') != -1) {
            for (i = 0; i < TreeFormatedArrmain.length; i++) {
                if (TreeFormatedArrmain[i].level == 1) {
                    delete TreeFormatedArrmain[i].parent;
                }
            }
            TreeFormatedArrmain = TreeFormatedArrmain.filter(function(obj) {
                return (obj.level !== 0 && obj.level <= allowednooflevels);
            });
        }else{
             TreeFormatedArrmain = TreeFormatedArrmain.filter(function(obj) {
                return obj.level <= allowednooflevels;
            });
         }
        //console.log(JSON.stringify(TreeFormatedArrmain));
        for (var i = TreeFormatedArrmain.length - 1; i >= 0; i--) {
            tmp = TreeFormatedArrmain[i].level;
            if (tmp < lowest) {
                lowest = tmp;
            }
            if (tmp > highest) {
                highest = tmp;
            }
        }

        component.maxvalueJSON = highest;
        if (setval) {
            return TreeFormatedArrmain;
        } else {
            defaultValue.series[0].data = TreeFormatedArrmain;
            return defaultValue.series;
        }

        /*
         * Format array
         */

        function formatArray(rowCounter, colCounter, rowMem, colMem, dataArr, dataArr1, hierarchy, aggArray, aggArray1) {
            var memberData = [];
            if (rowCounter >= 1) {
                memberData = rowMem;
            } else if (colCounter >= 1) {
                memberData = colMem;
            }

            var arrFormat = [];
            for (var i = 0; i < memberData.length; i++) {
                for (var j = 0; j < memberData[i].length; j++) {
                    var arr = {};
                    var newname = '';
                    var aggval;
                    var aggval1;
                    if (hierarchy === false) {
                        if (j == 1) {
                            newname = memberData[i][j - 1];
                        } else if (j == 2) {
                            newname = memberData[i][j - 2] + '/' + memberData[i][j - 1];
                        } else if (j == 3) {
                            newname = memberData[i][j - 3] + '/' + memberData[i][j - 2] + '/' + memberData[i][j - 1];
                        } else if (j == 4) {
                            newname = memberData[i][j - 4] + '/' + memberData[i][j - 3] + '/' + memberData[i][j - 2] + '/' + memberData[i][j - 1];
                        } else if (j == 5) {
                            newname = memberData[i][j - 5] + '/' + memberData[i][j - 4] + '/' + memberData[i][j - 3] + '/' + memberData[i][j - 2] + '/' + memberData[i][j - 1];
                        } else if (j == 6) {
                            newname = memberData[i][j - 6] + '/' + memberData[i][j - 5] + '/' + memberData[i][j - 4] + '/' + memberData[i][j - 3] + '/' + memberData[i][j - 2] + '/' + memberData[i][j - 1];
                        }
                        if (j === 0) {
                            aggval = search(memberData[i][j], aggArray);
                            aggval1 = search(memberData[i][j], aggArray1);
                            arr.id = memberData[i][j];
                            arr.name = memberData[i][j];
                            arr.value = aggval.value;
                            if (aggArray1.length >= 1) {
                                arr.colorValue = aggval1.value;
                            } else {
                                arr.colorValue = aggval.value;
                            }
                        } else if (j != memberData[i].length - 1 && j !== 0) {
                            aggval = search(newname + '/' + memberData[i][j], aggArray);
                            aggval1 = search(newname + '/' + memberData[i][j], aggArray1);
                            arr.id = newname + '/' + memberData[i][j];
                            arr.name = memberData[i][j];
                            arr.parent = newname;
                            arr.value = aggval.value;
                            if (aggArray1.length >= 1) {
                                arr.colorValue = aggval1.value;
                            } else {
                                arr.colorValue = aggval.value;
                            }
                        } else if (j == memberData[i].length - 1) {
                            arr.id = newname + '/' + memberData[i][j];
                            arr.name = memberData[i][j];
                            arr.parent = newname;
                            arr.value = dataArr[i];
                            if (aggArray1.length >= 1) {
                                arr.colorValue = dataArr1[i];
                            } else {
                                arr.colorValue = dataArr[i];
                            }
                        }

                        arr.level = j;
                    } else {
                        if (j == 1) {
                            newname = memberData[i][j - 1].split('##$$##')[0];
                        } else if (j == 2) {
                            newname = memberData[i][j - 2].split('##$$##')[0] + '/' + memberData[i][j - 1].split('##$$##')[0];
                        } else if (j == 3) {
                            newname = memberData[i][j - 3].split('##$$##')[0] + '/' + memberData[i][j - 2].split('##$$##')[0] + '/' + memberData[i][j - 1].split('##$$##')[0];
                        } else if (j == 4) {
                            newname = memberData[i][j - 4].split('##$$##')[0] + '/' + memberData[i][j - 3].split('##$$##')[0] + '/' + memberData[i][j - 2].split('##$$##')[0] + '/' + memberData[i][j - 1].split('##$$##')[0];
                        } else if (j == 5) {
                            newname = memberData[i][j - 5].split('##$$##')[0] + '/' + memberData[i][j - 4].split('##$$##')[0] + '/' + memberData[i][j - 3].split('##$$##')[0] + '/' + memberData[i][j - 2].split('##$$##')[0] + '/' + memberData[i][j - 1].split('##$$##')[0];
                        } else if (j == 6) {
                            newname = memberData[i][j - 6].split('##$$##')[0] + '/' + memberData[i][j - 5].split('##$$##')[0] + '/' + memberData[i][j - 4].split('##$$##')[0] + '/' + memberData[i][j - 3].split('##$$##')[0] + '/' + memberData[i][j - 2].split('##$$##')[0] + '/' + memberData[i][j - 1].split('##$$##')[0];
                        } else if (j == 7) {
                            newname = memberData[i][j - 7].split('##$$##')[0] + '/' + memberData[i][j - 6].split('##$$##')[0] + '/' + memberData[i][j - 5].split('##$$##')[0] + '/' + memberData[i][j - 4].split('##$$##')[0] + '/' + memberData[i][j - 3].split('##$$##')[0] + '/' + memberData[i][j - 2].split('##$$##')[0] + '/' + memberData[i][j - 1].split('##$$##')[0];
                        } else if (j == 8) {
                            newname = memberData[i][j - 8].split('##$$##')[0] + '/' + memberData[i][j - 7].split('##$$##')[0] + '/' + memberData[i][j - 6].split('##$$##')[0] + '/' + memberData[i][j - 5].split('##$$##')[0] + '/' + memberData[i][j - 4].split('##$$##')[0] + '/' + memberData[i][j - 3].split('##$$##')[0] + '/' + memberData[i][j - 2].split('##$$##')[0] + '/' + memberData[i][j - 1].split('##$$##')[0];
                        } else if (j == 9) {
                            newname = memberData[i][j - 9].split('##$$##')[0] + '/' + memberData[i][j - 8].split('##$$##')[0] + '/' + memberData[i][j - 7].split('##$$##')[0] + '/' + memberData[i][j - 6].split('##$$##')[0] + '/' + memberData[i][j - 5].split('##$$##')[0] + '/' + memberData[i][j - 4].split('##$$##')[0] + '/' + memberData[i][j - 3].split('##$$##')[0] + '/' + memberData[i][j - 2].split('##$$##')[0] + '/' + memberData[i][j - 1].split('##$$##')[0];
                        } else if (j == 10) {
                            newname = memberData[i][j - 10].split('##$$##')[0] + '/' + memberData[i][j - 9].split('##$$##')[0] + '/' + memberData[i][j - 8].split('##$$##')[0] + '/' + memberData[i][j - 7].split('##$$##')[0] + '/' + memberData[i][j - 6].split('##$$##')[0] + '/' + memberData[i][j - 5].split('##$$##')[0] + '/' + memberData[i][j - 4].split('##$$##')[0] + '/' + memberData[i][j - 3].split('##$$##')[0] + '/' + memberData[i][j - 2].split('##$$##')[0] + '/' + memberData[i][j - 1].split('##$$##')[0];
                        }

                        var textToReplace = memberData[i][j].split('##$$##');
                        if (j === 0) {
                            arr.id = textToReplace[0];
                            arr.name = textToReplace[0];
                            arr.nameKey = 'HIERARCHY_NODE/0HIER_NODE/' + textToReplace[1];
                            arr.nodestate = textToReplace[2];
                        } else if (j != memberData[i].length - 1 && j !== 0) {
                            arr.id = newname + '/' + textToReplace[0];
                            arr.name = textToReplace[0];
                            arr.parent = newname;
                            arr.nameKey = 'HIERARCHY_NODE/0HIER_NODE/' + textToReplace[1];
                            arr.nodestate = textToReplace[2];
                        } else if (j == memberData[i].length - 1) {
                            arr.id = newname + '/' + textToReplace[0];
                            arr.name = textToReplace[0];
                            arr.parent = newname;
                            arr.nodestate = textToReplace[2];
                            arr.nameKey = 'HIERARCHY_NODE/0HIER_NODE/' + textToReplace[1];
                            if (hierarchy === false) {
                                arr.value = dataArr[i];
                            }
                        }

                        arr.level = j;
                    }

                    for (var k in arrFormat) {
                        if (arrFormat[k]['id'] === arr['id'] && arr.id !== undefined) {
                            arr = {};
                        }
                    }

                    if (!jQuery.isEmptyObject(arr)) {
                        arrFormat.push(arr);
                    }
                }
            }

            if (hierarchy === true) {
                for (var i = 0; i < arrFormat.length; i++) {
                    arrFormat[i].value = dataArr[i];
                    if (dataArr1.length >= 1) {
                        arrFormat[i].colorValue = dataArr1[i];
                    } else {
                        arrFormat[i].colorValue = dataArr[i];
                    }
                }
            }

            return [arrFormat];
        }
       
        function dataArr(component, dimMesIndexJson, treecolormeasureindex, measureDimIndex) {
            var measureInRow = component.dataRes.dimensions[measureDimIndex].axis == 'ROWS' ? true : false;
            var dimensionInRow = true;
            if (measureInRow) {
                dimensionInRow = false;
            }

            var tupleToSkip = 0;
            var tuplesInColumn = [];
            var rowNames = {};
            var rowNamesKey={};
            var rowDataJson = {};
            var drilldownSeries = {};
            var positionJson = {};
            var colRowIndexJson = {};
            var dimToBeConsideredForRow = dimMesIndexJson.dimIndexArray;

            for (var i = 0; i < component.dataRes[dimensionInRow ? 'rowCount' : 'columnCount']; i++) {
                if (measureInRow) {
                    tupleToSkip = i;
                } else {
                    tupleToSkip = component.dataRes.columnCount * i;
                }

                tuplesInColumn.push(component.dataRes.tuples[tupleToSkip]);
                var tempTuple = tuplesInColumn[i];
                if (self.vbiCharts.eliminateResult(component.dataRes, tempTuple, dimensionInRow ? 'ROWS' : 'COLUMNS') === true) {
                    var colKey = '';
                    var rowKey = 0;
                    var rowHeader = 'Dimensions';
                    var rowHeaderKey;
                    var rowKeyArr = [];
                    colKey = measureDimIndex + ':' + treecolormeasureindex;
                    colRowIndexJson[colKey] = [];
                    colRowIndexJson[colKey].push(treecolormeasureindex);

                    for (var j = 0; j < dimToBeConsideredForRow.length; j++) {
                        if (j === 0) {
                            rowKey = dimToBeConsideredForRow[0] + ':' + tempTuple[dimToBeConsideredForRow[0]];
                            rowHeader = component.dataRes.dimensions[dimToBeConsideredForRow[0]].members[tempTuple[dimToBeConsideredForRow[0]]].text;
                            rowHeaderKey = component.dataRes.dimensions[dimToBeConsideredForRow[0]].members[tempTuple[dimToBeConsideredForRow[0]]].key;
                        } else {
                            rowKey += '-' + dimToBeConsideredForRow[j] + ':' + tempTuple[dimToBeConsideredForRow[j]];
                            rowHeader += '/' + component.dataRes.dimensions[dimToBeConsideredForRow[j]].members[tempTuple[dimToBeConsideredForRow[j]]].text; // jscs:enable
                            rowHeaderKey += '/' + component.dataRes.dimensions[dimToBeConsideredForRow[j]].members[tempTuple[dimToBeConsideredForRow[j]]].key; // jscs:enable
                        }

                        rowKeyArr.push(rowKey);
                        if (typeof rowNames[rowKey] == 'undefined') {
                            rowNames[rowKey] = rowHeader;
                            rowNamesKey[rowKey] = rowHeaderKey;
                            if (typeof component.ztlSelectedRowJson[rowKey] == 'undefined') {
                                var dimKey = component.dataRes.dimensions[dimToBeConsideredForRow[j]].key;
                                component.ztlSelectedRowJson[rowKey] = {};
                                component.ztlSelectedRowJson[rowKey][dimKey] = {
                                    internalKey: component.dataRes.dimensions[dimToBeConsideredForRow[j]].members[tempTuple[dimToBeConsideredForRow[j]]].key,
                                    text: component.dataRes.dimensions[dimToBeConsideredForRow[j]].members[tempTuple[dimToBeConsideredForRow[j]]].text
                                };
                            }
                        }
                    }

                    $.each(colRowIndexJson, function(key, value) {
                        $.each(rowKeyArr, function(rowInd, ele) {
                            var seriesKeyName = treecolormeasure;
                            var keygen = ele + '-' + seriesKeyName;
                            if (rowDataJson[keygen] === undefined) {
                                rowDataJson[keygen] = [];
                            }

                            if (rowInd != rowKeyArr.length - 1) {
                                if (!drilldownSeries[keygen]) {
                                    drilldownSeries[keygen] = {
                                        name: rowNames[ele],
                                        key: rowNamesKey[ele],
                                        value: [],
                                        data: [],
                                        Namekey: ele
                                    };
                                    positionJson[keygen] = {}; // all the sereis details
                                }
                            }

                            var yArr = [];
                            var curIndex = 0;
                            $.each(value, function(index, newval) {
                                curIndex = newval + tupleToSkip;
                                yArr.push(component.dataRes.data[curIndex] || 0);
                                rowDataJson[keygen].push(component.dataRes.data[curIndex] || 0);
                            });

                            if (rowInd > 0) {
                                var parentKey = ele.slice(0, ele.lastIndexOf('-'));
                                var parentKeygen = parentKey + '-' + seriesKeyName;
                                if (positionJson[parentKeygen].hasOwnProperty(ele)) {
                                    var currentYarr = drilldownSeries[parentKeygen].data[positionJson[parentKeygen][ele]].y;
                                    currentYarr = currentYarr.concat(yArr);
                                    drilldownSeries[parentKeygen].data[positionJson[parentKeygen][ele]].y = currentYarr;
                                } else {
                                    var temNam = rowNames[ele];
                                    var temNamKey = rowNamesKey[ele];
                                    positionJson[parentKeygen][ele] = drilldownSeries[parentKeygen].data.length;
                                    drilldownSeries[parentKeygen].data.push({
                                        name: temNam,
                                        key: temNamKey,
                                        y: yArr,
                                        Namekey: ele
                                    });
                                    component.Namekey = ele;
                                }

                                drilldownSeries[parentKeygen].value = drilldownSeries[parentKeygen].value.concat(yArr);
                            }
                        });
                    });
                }
            }

            if (component.datautility() === false) {
                component.chartaggregation('sum');
            }

            $.each(drilldownSeries, function(key, json) {
                json.value = that.barValueAggregation(component, json.value);
                $.each(json.data, function(i, v) {
                    v.y = that.barValueAggregation(component, v.y);
                });
            });

            var aggArray = $.map(drilldownSeries, function(value) {
                return [value];
            });
            return aggArray;
        }

        function getDimMesJson(component) {
            var dimMesJson = {};
            var memIndexArray = [];
            var measureIndex;
            if (component.measurelist() === '' || component.measurelist() === undefined || component.measurelist() === null) {
                var measureIndex = 0;
            } else {
                var measureMembersArr = component.getMeasureMembersKeyAndText();
                measureIndex = measureMembersArr[1].indexOf(component.measurelist());
                if (measureIndex == -1) {
                    if (measureMembersArr[0].indexOf(component.measurelist()) !== -1) {
                        measureIndex = measureMembersArr[0].indexOf(component.measurelist());
                    } else {
                        measureIndex = 0;
                    }
                }
            }

            //if (!component.datautility()) {
                measureIndex = 0;
                var rowIndex = component.dataRes['axis_columns'][0].indexOf(-1);
                if (rowIndex !== -1) {
                    for (var i = rowIndex; i < component.dataRes.dimensions.length; i++) {
                        if (!component.dataRes.dimensions[i].containsMeasures) {
                            memIndexArray.push(i);
                        }
                    }
                } else {
                    rowIndex = component.dataRes.dimensions.length;
                }

                if (memIndexArray.length === 0) {
                    for (var i = 0; i < rowIndex; i++) {
                        if (!component.dataRes.dimensions[i].containsMeasures) {
                            memIndexArray.push(i);
                        }
                    }
                }

                dimMesJson = {
                    'mesIndex': 0,
                    'dimIndexArray': memIndexArray,
                    'dimensionAxis': 'rows'
                };
            /*} else {
                if (component.bardatacustomization().length === 0) {
                    that.createSmokeScreen(component.$(), 'Please select Dimension in Data Utility');
                } else {
                    var bardataJSON = JSON.parse(component.bardatacustomization());
                    if (bardataJSON['ROWS'].length > 0) {
                        for (var i = 0; i < bardataJSON['ROWS'].length; i++) {
                            memIndexArray.push(bardataJSON['ROWS'][i].index);
                        }

                        dimMesJson = {
                            'mesIndex': measureIndex,
                            'dimIndexArray': memIndexArray,
                            'dimensionAxis': 'rows'
                        };
                    } else if (bardataJSON['COLUMNS'].length > 0) {
                        for (var i = 0; i < bardataJSON['COLUMNS'].length; i++) {
                            memIndexArray.push(bardataJSON['COLUMNS'][i].index);
                        }

                        dimMesJson = {
                            'mesIndex': measureIndex,
                            'dimIndexArray': memIndexArray,
                            'dimensionAxis': 'columns'
                        };
                    }
                }
            }
*/
            return dimMesJson;
        }

        function search(nameKey, myArray) {
            for (var i = 0; i < myArray.length; i++) {
                if (myArray[i].name === nameKey) {
                    return myArray[i];
                }
            }
        }

        function getDifference(a, b) {
            var i = 0;
            var j = 0;
            var result = '';

            while (j < b.length) {
                if (a[i] != b[j] || i == a.length) {
                    result += b[j];
                } else {
                    i++;
                }
                j++;
            }

            return result;
        }

    };

}
