//High Maps DS PropertyBank
//Description:PropertyBank File create object for all the properties. and using this file, the controls are generated dynamically in additional property sheet just with the name of the property.

var PropertyBankMaps = function() {

  //Pusing all the countries in a array.
  var mapsource_members = [];

  for (var key in map_sources) {
    mapsource_members.push({name: key.toLowerCase(), caption: map_sources[key].name, group: map_sources[key].type});
  }

  return {
    mapsource: {
      name: 'mapsource',
      title: 'Select Map Source',
      type: 'select',
      defaultVal: 'us_all',
      members: mapsource_members,
      group_field: 'type',
      groups: {
        'world': 'World',
        'continent': 'Continents & Regions',
        'custom': 'Custom',
        'country': 'Countries',
        'ca-admin2': 'Canada (Admin 2)',
        'fr-admin2': 'France (Admin 2)',
        'de-admin2': 'Germany (Admin 2)',
        'de-admin3': 'Germany (Admin 3)',
        'nl-admin2': 'Netherlands (Admin 2)',
        'no-admin2': 'Norway (Admin 2)',
        'us-admin2': 'United States (Admin 2)',
        'us-admin3': 'United States Congressional Districts (Admin 3)'
      },
      empty: 'Choose Map Data',
      category: 'general_general',
      description: 'Choose the country to be loaded.',
      section: 'general'
    },
    mapSourceUrl: {
      name: 'mapSourceUrl',
      title: 'Map Source URL',
      type: 'textbox',
      category: 'general_general',
      description: 'Base Url for all map sources.',
      section: 'general',
      defaultVal: ''
    },
    dimensionSelection: {
      name: 'dimensionSelection',
      title: 'Dimension Selection',
      type: 'select',
      category: 'dataseries_general',
      members: [{name: 'key', caption: 'Technical ID'},
      //{name:'file',caption:'File Upload'},
      {name: 'index', caption: 'Index-based'}],
      description: 'Save as Technical ID or Index',
      section: 'dataseries',
      defaultVal: 'key'
    },
    customMapJsonEnabled: {
      name: 'customMapJsonEnabled',
      title: 'Enable Custom Maps',
      type: 'checkbox',
      value: false,
      category: 'geojson_general',
      description: 'Enables Custom JSON Maps (GeoJSON or TopoJson based).',
      section: 'geojson'
    },
    customMapJsonLayerFillColor: {
      name: 'customMapJsonLayerFillColor',
      title: 'Fill Color',
      type: 'colorpicker',
      defaultVal: '#6bbcde',
      category: 'geojson_general',
      description: 'Fill Color for the series marked in the geojson layer.',
      section: 'geojson'
    },
    customMapJsonFormat: {
      name: 'customMapJsonFormat',
      title: 'Format',
      type: 'select',
      category: 'geojson_general',
      members: [{name: 'geojson',caption: 'GeoJSON'},{name: 'topojson',caption: 'TopoJSON'}],
      description: 'Map JSON format',
      section: 'geojson',
      defaultVal: 'geojson'
    },
    customMapJsonSource: {
      name: 'customMapJsonSource',
      title: 'Source',
      type: 'select',
      category: 'geojson_general',
      members: [{name: 'url',caption: 'URL'},
      //{name:'file',caption:'File Upload'},
      {name: 'text',caption: 'Text'}],
      description: 'Map JSON format',
      section: 'geojson',
      empty: 'Choose Source'
    },
    customMapJsonLayerName: {
      name: 'customMapJsonLayerName',
      title: 'Layer Name',
      type: 'textbox',
      category: 'geojson_general',
      description: 'Name the custom json map layer name',
      section: 'geojson',
      defaultVal: ''
    },
    customMapJsonUrl: {
      name: 'customMapJsonUrl',
      title: 'URL',
      type: 'textbox',
      category: 'geojson_general',
      description: 'Url with custom json',
      section: 'geojson',
      defaultVal: ''
    },
    customMapJsonFileName: {
      name: 'customMapJsonFileName',
      title: 'File Upload',
      type: 'textbox',
      category: 'geojson_general',
      description: 'Filename with custom json',
      section: 'geojson',
      defaultVal: ''
    },
    customMapJsonText: {
      name: 'customMapJsonText',
      title: 'Text',
      type: 'textarea',
      category: 'geojson_general',
      description: 'Filename with custom json',
      section: 'geojson',
      defaultVal: ''
    },
    customMapJsonLoadButton: {
      name: 'customMapJsonLoadButton',
      title: '',
      type: 'dynamic',
      category: 'geojson_general',
      description: '',
      section: 'geojson',
      defaultVal: ''
    },
    customMapJsonSampleLimit: {
      name: 'customMapJsonSampleLimit',
      title: 'Sample Row Count',
      type: 'number',
      defaultVal: 0,
      category: 'geojson_general',
      description: 'Number of sample rows to display.',
      section: 'geojson'
    },
    customMapJsonSampleData: {
      name: 'customMapJsonSampleData',
      title: 'Sample Data',
      type: 'dynamic',
      category: 'geojson_general',
      description: '',
      section: 'geojson',
      defaultVal: ''
    },
    customMapJsonAttributesMapping: {
      name: 'customMapJsonAttributesMapping',
      title: 'Attributes Mapping',
      type: 'dynamic',
      category: 'geojson_general',
      description: 'Attributes to Dimensions/Measures mapping',
      section: 'geojson',
      defaultVal: ''
    },
    mapData: {
      name: 'mapData',
      title: 'Map Data',
      type: 'textbox',
      category: 'general_general',
      description: 'Name of country in array index.',
      css: 'display:none',
      section: 'general'
    },
    mapVisualization: {
      name: 'mapVisualization',
      title: 'Map Type',
      type: 'select',
      defaultVal: 'map',
      members: [{name: 'map',caption: 'Heat'},{name: 'mapbubble',caption: 'Bubble'}],
      empty: 'Choose Style',
      category: 'general_general',
      description: 'Choose how you wish to visualize your data on the map.',
      section: 'general'
    },
    chartborderWidth: {
      name: 'chartborderWidth',
      title: 'Border Width',
      type: 'number',
      defaultVal: 0,
      category: 'css_map',
      description: 'The pixel width of the outer chart border.',
      section: 'css'
    },
    chartborderColor: {
      name: 'chartborderColor',
      title: 'Border Color',
      type: 'colorpicker',
      defaultVal: '',
      category: 'css_map',
      description: 'The color of the outer chart border.',
      section: 'css'
    },
    mapNavigation: {
      name: 'mapNavigation',
      title: 'Enable Navigation',
      type: 'checkbox',
      value: 'true',
      category: 'panzoom_general',
      description: 'Enables zooming by mouse wheel.',
      section: 'pan_and_zoom'
    },
    mapNavigationAlign: {
      name: 'mapNavigationAlign',
      title: 'Horizontal Alignment',
      type: 'select',
      members: [{name: 'left',caption: 'Left'},{name: 'right',caption: 'Right'}],
      defaultVal: 'left',
      empty: 'Choose Alignment',
      category: 'panzoom_general',
      description: 'The alignment of the navigation buttons. Defaults to left.',
      section: 'pan_and_zoom'
    },
    mapNavigationVerticalAlign: {
      name: 'mapNavigationVerticalAlign',
      title: 'Vertical Alignment',
      type: 'select',
      members: [{name: 'top',caption: 'Top'},{name: 'bottom',caption: 'Bottom'}],
      defaultVal: 'top',
      empty: 'Choose Alignment',
      category: 'panzoom_general',
      description: 'The vertical alignment of the buttons. Individual alignment can be adjusted by each button\'s y offset. Defaults to top.',
      section: 'pan_and_zoom'
    },
    setMinMaxValues: {
      name: 'setMinMaxValues',
      title: 'Set Min Max Values?',
      type: 'checkbox',
      value: 'bool',
      category: 'css_general',
      description: 'Enables to set Minimum and Maximum values for legend',
      section: 'legend'
    },
    mapLegendColorType: {
      name: 'mapLegendColorType',
      title: 'Type',
      type: 'select',
      members: [{name: 'scalar',caption: 'Scalar'},{name: 'range',caption: 'Range Based'}],
      defaultVal: 'scalar',
      category: 'legend_general',
      section: 'legend',
      description: 'Set type of legend - scalar (or continuos), range based'
    },
    mapLegendColorRanges: {
      name: 'mapLegendColorRanges',
      title: 'Color Ranges',
      type: 'dynamic',
      members: '',
      defaultVal: '',
      value: '',
      category: 'legend_general',
      section: 'legend',
      description: 'Set color ranges for the legend'
    },
    bubbleColorRangeMaximum: {
      name: 'bubbleColorRangeMaximum',
      title: 'Maximum',
      type: 'select',
      members: [{name: 'static',caption: 'Static'},
      //{name:'data_cell',caption:'Data Cell'},
      {name: 'max_result',caption: 'Result (Max)'}],
      defaultVal: 'static',
      category: 'plotoptions_bubblecolor_ranges',
      section: 'plot_options',
      description: 'Set type of range for the bubble color ranges.'
    },
    bubbleColorRangeStaticMaximum: {
      name: 'bubbleColorRangeStaticMaximum',
      title: 'Static Maximum',
      type: 'number',
      category: 'plotoptions_bubblecolor_ranges',
      description: 'Absolute value to be used as Maximum for the ranges.',
      section: 'plot_options',
      defaultVal: 0
    },
    bubbleColorRangeType: {
      name: 'bubbleColorRangeType',
      title: 'Range Type',
      type: 'select',
      members: [{name: 'absolute',caption: 'Absolute'},{name: 'percentage',caption: 'Percentage'}],
      defaultVal: 'absolute',
      category: 'plotoptions_bubblecolor_ranges',
      section: 'plot_options',
      description: 'Set type of range for the bubble color ranges.'
    },
    bubbleColorRangesEnabled: {
      name: 'bubbleColorRangesEnabled',
      title: 'Enable Bubble Color Ranges',
      type: 'checkbox',
      value: 'true',
      category: 'plotoptions_bubblecolor_ranges',
      description: 'Enable setting the color ranges for the bubble color measure.',
      section: 'plot_options'
    },
    bubbleColorRanges: {
      name: 'bubbleColorRanges',
      title: 'Color Ranges',
      type: 'dynamic',
      members: '',
      defaultVal: '',
      value: '',
      category: 'plotoptions_bubblecolor_ranges',
      section: 'plot_options',
      description: 'Set color ranges for the bubble size'
    },
    colorAxisMin: {
      name: 'colorAxisMin',
      title: 'Color Axis Min',
      type: 'number',
      defaultVal: 1,
      category: 'css_general',
      description: 'The minimum value of the axis in terms of map point values. If null, the min value is automatically calculated. If the startOnTick option is true, the min value might be rounded down.',
      section: 'legend'
    },
    colorAxisMax: {
      name: 'colorAxisMax',
      title: 'Color Axis Max',
      type: 'number',
      defaultVal: 1,
      category: 'css_general',
      description: 'The maximum value of the axis in terms of map point values. If null, the max value is automatically calculated. If the endOnTick option is true, the max value might be rounded up.',
      section: 'legend'
    },
    colorAxisType: {
      name: 'colorAxisType',
      title: 'Axis Type',
      type: 'select',
      members: [{name: 'linear',caption: 'Linear'},{name: 'logarithmic',caption: 'Logarithmic'}],
      defaultVal: 'Logarithmic',
      empty: 'Choose Axis',
      category: 'dataseries_general',
      description: 'The type of interpolation to use for the color axis. Can be linear or logarithmic. Defaults to linear.',
      section: 'dataseries'
    },
    result: {
      name: 'result',
      title: 'Result',
      type: 'textbox',
      category: 'dataseries_general',
      section: 'dataseries'
    },
    xaxisBinding: {
      name: 'xaxisBinding',
      title: 'X-Axis Binding',
      type: 'select',
      members: [{name: 'state', caption: 'State'}, {name: 'latlon', caption: 'Latitude-Longitude'}],
      defaultVal: '',
      empty: 'Choose Binding',
      category: 'dataseries_general',
      description: 'Choose the binding type for the x-axis',
      section: 'dataseries'
    },
    latitudeDimension: {
      name: 'latitudeDimension',
      title: 'Latitude',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Dimension',
      category: 'dataseries_latlong',
      description: 'Choose the dimension corresponding to latitude',
      section: 'dataseries'
    },
    longitudeDimension: {
      name: 'longitudeDimension',
      title: 'Longitude',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Dimension',
      category: 'dataseries_latlong',
      description: 'Choose the dimension corresponding to longtiude',
      section: 'dataseries'
    },
    mapDataMeasure: {
      name: 'mapDataMeasure',
      title: 'Primary Measure',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Measure',
      category: 'dataseries_general',
      description: 'Choose the measure to be loaded in map',
      section: 'dataseries'
    },
    bubbleColorMeasure: {
      name: 'bubbleColorMeasure',
      title: 'Bubble Color Measure',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Measure',
      category: 'dataseries_general',
      description: 'Choose the measure to be loaded for the bubble color series',
      section: 'dataseries'
    },
    levelOneDataSource: {
      name: 'levelOneDataSource',
      title: 'Address Type',
      type: 'select',
      members: [
			           {
  'name': 'dimension',
  'caption': 'Dimension'
			           },
			           {
  'name': 'latlon',
  'caption': 'Latitude & Longitude'
			           }
			         ],
      defaultVal: 'key',
      empty: 'Choose Address Type',
      category: 'dataseries_level_one',
      description: 'Choose the address type to use',
      section: 'dataseries'
    },
    levelOneLat: {
      name: 'levelOneLat',
      title: 'Select Latitude',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Dimension',
      category: 'dataseries_level_one',
      description: 'Choose the Latitude for Level 1 datasource',
      section: 'dataseries'
    },
    levelOneLon: {
      name: 'levelOneLon',
      title: 'Select Longitude',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Dimension',
      category: 'dataseries_level_one',
      description: 'Choose the Longitude for Level 2 datasource',
      section: 'dataseries'
    },
    levelOneDisplay: {
      name: 'levelOneDisplay',
      title: 'Select Display Member',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Dimension',
      category: 'dataseries_level_one',
      description: 'Choose the Display Member for the map point',
      section: 'dataseries'
    },
    levelOneDimension: {
      name: 'levelOneDimension',
      title: 'Select Dimension',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Dimension',
      category: 'dataseries_level_one',
      description: 'Choose the dimension to be loaded in map for level 1.',
      section: 'dataseries'
    },
    levelOneDataFormat: {
      name: 'levelOneDataFormat',
      title: 'Data Format',
      type: 'select',
      members: [
			         {
  'name': 'hc-a2',
  'caption': 'Postal Code (e.g. MA)'
			           },
			           {
  'name': 'hasc',
  'caption': 'Hierarchical Administrative Subdivision Code (e.g. US.MA)'
			           },
			           {
  'name': 'woe-id',
  'caption': 'GeoPlanet WOEID (e.g. 2347580)'
			           },
			           {
  'name': 'fips',
  'caption': 'FIPS Code (e.g. US25)'
			           },
			           {
  'name': 'name',
  'caption': 'Full Name (e.g. Massachusetts)'
			           },
			           {
  'name': 'region',
  'caption': 'Region (e.g. Northeast)'
			           }
			         ],
      empty: 'Choose Format',
      category: 'dataseries_level_one',
      description: 'Choose the data format loaded in datasource',
      section: 'dataseries'
    },
    levelOneDataSwitch: {
      name: 'levelOneDataSwitch',
      title: 'Key / Text',
      type: 'select',
      members: [
			           {
  'name': 'key',
  'caption': 'Key'
			           },
			           {
  'name': 'text',
  'caption': 'Text'
			           }
			         ],
      defaultVal: 'key',
      empty: 'Choose Display Member',
      category: 'dataseries_level_one',
      description: 'Choose the display member type to be loaded in datasource',
      section: 'dataseries'
    },
    levelTwoDataSource: {
      name: 'levelTwoDataSource',
      title: 'Address Type',
      type: 'select',
      members: [
			           {
  'name': 'dimension',
  'caption': 'Dimension'
			           },
			           {
  'name': 'latlon',
  'caption': 'Latitude & Longitude'
			           }
			         ],
      defaultVal: 'key',
      empty: 'Choose Address Type',
      category: 'dataseries_level_two',
      description: 'Choose the address type to use',
      section: 'dataseries'
    },
    levelTwoLat: {
      name: 'levelTwoLat',
      title: 'Select Latitude',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Dimension',
      category: 'dataseries_level_two',
      description: 'Choose the Latitude for Level 2 datasource',
      section: 'dataseries'
    },
    levelTwoLon: {
      name: 'levelTwoLon',
      title: 'Select Longitude',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Dimension',
      category: 'dataseries_level_two',
      description: 'Choose the Longitude for Level 2 datasource',
      section: 'dataseries'
    },
    levelTwoDisplay: {
      name: 'levelTwoDisplay',
      title: 'Select Display Member',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Dimension',
      category: 'dataseries_level_two',
      description: 'Choose the Display Member for the map point',
      section: 'dataseries'
    },
    levelTwoDimension: {
      name: 'levelTwoDimension',
      title: 'Select Dimension',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Dimension',
      category: 'dataseries_level_two',
      description: 'Choose the dimension to be loaded in map for level 1.',
      section: 'dataseries'
    },
    levelTwoDataFormat: {
      name: 'levelTwoDataFormat',
      title: 'Data Format',
      type: 'select',
      members: [
			         {
  'name': 'hc-a2',
  'caption': 'Postal Code (e.g. MA)'
			           },
			           {
  'name': 'hasc',
  'caption': 'Hierarchical Administrative Subdivision Code (e.g. US.MA)'
			           },
			           {
  'name': 'woe-id',
  'caption': 'GeoPlanet WOEID (e.g. 2347580)'
			           },
			           {
  'name': 'fips',
  'caption': 'FIPS Code (e.g. US25)'
			           },
			           {
  'name': 'name',
  'caption': 'Full Name (e.g. Massachusetts)'
			           },
			           {
  'name': 'region',
  'caption': 'Region (e.g. Northeast)'
			           }
			         ],
      empty: 'Choose Format',
      category: 'dataseries_level_two',
      description: 'Choose the data format loaded in datasource',
      section: 'dataseries'
    },
    levelTwoDataSwitch: {
      name: 'levelTwoDataSwitch',
      title: 'Key / Text',
      type: 'select',
      members: [
			           {
  'name': 'key',
  'caption': 'Key'
			           },
			           {
  'name': 'text',
  'caption': 'Text'
			           }
			         ],
      defaultVal: 'key',
      empty: 'Choose Display Member',
      category: 'dataseries_level_two',
      description: 'Choose the display member type to be loaded in datasource',
      section: 'dataseries'
    },
    levelThreeDataSource: {
      name: 'levelThreeDataSource',
      title: 'Address Type',
      type: 'select',
      members: [
			           {
  'name': 'dimension',
  'caption': 'Dimension'
			           },
			           {
  'name': 'latlon',
  'caption': 'Latitude & Longitude'
			           }
			         ],
      defaultVal: 'key',
      empty: 'Choose Address Type',
      category: 'dataseries_level_three',
      description: 'Choose the address type to use',
      section: 'dataseries'
    },
    levelThreeLat: {
      name: 'levelThreeLat',
      title: 'Select Latitude',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Dimension',
      category: 'dataseries_level_three',
      description: 'Choose the Latitude for Level 3 datasource',
      section: 'dataseries'
    },
    levelThreeLon: {
      name: 'levelThreeLon',
      title: 'Select Longitude',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Dimension',
      category: 'dataseries_level_three',
      description: 'Choose the Longitude for Level 3 datasource',
      section: 'dataseries'
    },
    levelThreeDisplay: {
      name: 'levelThreeDisplay',
      title: 'Select Display Member',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Dimension',
      category: 'dataseries_level_three',
      description: 'Choose the Display Member for the map point',
      section: 'dataseries'
    },
    levelThreeDimension: {
      name: 'levelThreeDimension',
      title: 'Select Dimension',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Dimension',
      category: 'dataseries_level_three',
      description: 'Choose the dimension to be loaded in map for level 3.',
      section: 'dataseries'
    },
    levelThreeDataFormat: {
      name: 'levelThreeDataFormat',
      title: 'Data Format',
      type: 'select',
      members: [
			         {
  'name': 'hc-a2',
  'caption': 'Postal Code (e.g. MA)'
			           },
			           {
  'name': 'hasc',
  'caption': 'Hierarchical Administrative Subdivision Code (e.g. US.MA)'
			           },
			           {
  'name': 'woe-id',
  'caption': 'GeoPlanet WOEID (e.g. 2347580)'
			           },
			           {
  'name': 'fips',
  'caption': 'FIPS Code (e.g. US25)'
			           },
			           {
  'name': 'name',
  'caption': 'Full Name (e.g. Massachusetts)'
			           },
			           {
  'name': 'region',
  'caption': 'Region (e.g. Northeast)'
			           }
			         ],
      empty: 'Choose Format',
      category: 'dataseries_level_three',
      description: 'Choose the data format loaded in datasource',
      section: 'dataseries'
    },
    levelThreeDataSwitch: {
      name: 'levelThreeDataSwitch',
      title: 'Key / Text',
      type: 'select',
      members: [
			           {
  'name': 'key',
  'caption': 'Key'
			           },
			           {
  'name': 'text',
  'caption': 'Text'
			           }
			         ],
      defaultVal: 'key',
      empty: 'Choose Display Member',
      category: 'dataseries_level_three',
      description: 'Choose the display member type to be loaded in datasource',
      section: 'dataseries'
    },
    zAxisChartDimension: {
      name: 'zAxisChartDimension',
      title: 'X-Axis (Dimension)',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Dimension',
      category: 'general_zaxis',
      description: 'Choose the dimension to be loaded in the Z-axis chart',
      section: 'dataseries'
    },
    zAxisChartDataSwitch: {
      name: 'zAxisChartDataSwitch',
      title: 'Key / Text',
      type: 'select',
      members: [
                 {
                   'name': 'key',
                   'caption': 'Key'
                 },
                 {
                   'name': 'text',
                   'caption': 'Text'
                 }
               ],
      defaultVal: 'key',
      empty: 'Choose Display Member',
      category: 'general_zaxis',
      description: 'Choose the display member type to be loaded in the z-axis',
      section: 'dataseries'
    },
    zAxisChartMeasure: {
      name: 'zAxisChartMeasure',
      title: 'Y-Axis (Measure)',
      type: 'select',
      members: [],
      defaultVal: '',
      empty: 'Choose Measure',
      category: 'general_zaxis',
      description: 'Choose the measure to be loaded in the Z-axis chart',
      section: 'dataseries'
    },
    zAxisChartTitle: {
      name: 'zAxisChartTitle',
      title: 'Chart Title',
      type: 'textbox',
      category: 'general_zaxis',
      description: 'Title for the Z-axis chart.',
      section: 'dataseries'
    },
    zAxisChartVisualization: {
      name: 'zAxisChartVisualization',
      title: 'Chart Type',
      type: 'select',
      members: [{name: 'line', caption: 'Line Chart'},
      {name: 'area', caption: 'Area Chart'},
      {name: 'column', caption: 'Column Chart'},
      {name: 'bar', caption: 'Bar Chart'}],
      defaultVal: 'line',
      empty: 'Choose Visualization',
      category: 'general_zaxis',
      description: 'Choose the visualization for the Z-axis chart',
      section: 'dataseries'
    },
    zAxisChartEnabled: {
      name: 'zAxisChartEnabled',
      title: 'Enable Z-Axis Chart?',
      type: 'checkbox',
      value: 'true',
      category: 'general_zaxis',
      description: 'Enable Z-axis chart on click. Press Shift+Click to select multiple.',
      section: 'dataseries'
    },
    zAxisChartSubtitleEnabled: {
      name: 'zAxisSubtitleEnabled',
      title: 'Enable Subtitle on Chart?',
      type: 'checkbox',
      value: 'true',
      defaultVal: true,
      category: 'general_zaxis',
      description: 'Enable subtitle on the Z-axis Chart.',
      section: 'dataseries'
    },
    zAxisChartSubTitle: {
      name: 'zAxisChartSubTitle',
      title: 'Chart Subtitle',
      type: 'textbox',
      category: 'general_zaxis',
      description: 'Sub-Title for the Z-axis Chart.',
      section: 'dataseries'
    },
    stopColorStart: {
      name: 'stopColorStart',
      title: 'Range Minimum Color',
      type: 'colorpicker',
      defaultVal: '#FFFF80',
      category: 'css_heatmap',
      description: 'Color stops for the gradient of a scalar color axis. Use this in cases where a linear gradient between a minColor and maxColor is not sufficient. The stops is an array of tuples, where the first item is a float between 0 and 1 assigning the relative position in the gradient, and the second item is the color.',
      section: 'css'
    },
    stopColorMiddle: {
      name: 'stopColorMiddle',
      title: 'Legend Color Between',
      type: 'colorpicker',
      defaultVal: '#C4CE00',
      category: 'css_general',
      description: 'Color stops for the gradient of a scalar color axis. Use this in cases where a linear gradient between a minColor and maxColor is not sufficient. The stops is an array of tuples, where the first item is a float between 0 and 1 assigning the relative position in the gradient, and the second item is the color.',
      section: 'css'
    },
    stopColorEnd: {
      name: 'stopColorEnd',
      title: 'Range Maximum Color',
      type: 'colorpicker',
      defaultVal: '#5F6101',
      category: 'css_heatmap',
      description: 'Color stops for the gradient of a scalar color axis. Use this in cases where a linear gradient between a minColor and maxColor is not sufficient. The stops is an array of tuples, where the first item is a float between 0 and 1 assigning the relative position in the gradient, and the second item is the color.',
      section: 'css'
    },
    bubbleColor: {
      name: 'bubbleColor',
      title: 'Bubble Color',
      type: 'colorpicker',
      defaultVal: '#009D00',
      category: 'css_bubblemap',
      description: 'Bubble Color for Bubble Map',
      section: 'css'
    },
    bubbleMinSize: {
      name: 'bubbleMinSize',
      title: 'Bubble Min Size',
      type: 'textbox',
      defaultVal: '16',
      category: 'css_bubblemap',
      description: 'Increase or decrease the minimum bubble size. You can give absolute or percentage values, where percentage is relative to chart dimensions.',
      section: 'css'
    },
    bubbleMaxSize: {
      name: 'bubbleMaxSize',
      title: 'Bubble Max Size',
      type: 'textbox',
      defaultVal: '30%',
      category: 'css_bubblemap',
      description: 'Increase or decrease the maximum bubble size. You can give absolute or percentage values, where percentage is relative to chart dimensions.',
      section: 'css'
    },
    fontWeight: {
      name: 'fontWeight',
      title: 'Font Weight',
      type: 'select',
      members: [
      {name: '100', caption: 'Light'},
      {name: 'normal', caption: 'Normal'},
      {name: 'bold', caption: 'Semibold'},
      {name: 'bolder', caption: 'Bold'}
      ],
      defaultVal: '',
      empty: 'Choose Weight',
      category: 'css_font',
      section: 'css'
    },
    chartBackgroundColor: {
      name: 'chartBackgroundColor',
      title: 'Background Color',
      type: 'colorpicker',
      defaultVal: '#FFFFFF',
      category: 'css_map',
      description: 'The background color or gradient for the outer chart area. Defaults to #FFFFFF.',
      section: 'css'
    },
    colorOnClick: {
      name: 'colorOnClick',
      title: 'Bubble Color On Click',
      type: 'colorpicker',
      defaultVal: '#BDBDBD',
      category: 'css_bubblemap',
      description: 'The fill color of the point bubble.',
      section: 'css'
    },
    zAxisChartLeftPosition: {
      name: 'zAxisChartLeftPosition',
      title: 'Z-Axis Left Position',
      type: 'number',
      defaultVal: 0,
      category: 'general_zaxis',
      description: 'Set left position for Z-axis chart',
      section: 'dataseries'
    },
    zAxisChartTopPosition: {
      name: 'zAxisChartTopPosition',
      title: 'Z-Axis Chart Top Position',
      type: 'number',
      defaultVal: 0,
      category: 'general_zaxis',
      description: 'Set Top position for Z-axis chart',
      section: 'dataseries'
    },
    globalfont: {
      name: 'globalfont',
      title: 'Enable Google Font',
      type: 'checkbox',
      members: '',
      defaultVal: '',
      value: '',
      category: 'general_globalfontoverride',
      section: 'general',
      description: 'Select the option to override the font styles of all the labels'
    },
    fontfamily: {
      name: 'fontfamily',
      title: 'Font',
      type: 'select',
      members: (PropertyBank !== undefined) ? PropertyBank().fontfamily.members : [],
      defaultVal: '',
      value: '',
      empty: '',
      category: 'general_globalfontoverride',
      section: 'general',
      description: 'Select the global font type'
    },
    zAxisChartSubTitleFontFamily: {
      name: 'zAxisChartSubTitleFontFamily',
      title: 'Subtitle Font Family',
      type: 'select',
      members: [{name: 'Lucida Grande', caption: 'Lucida Grande'}, {name: 'sans-serif', caption: 'Sans-Serif'}, {name: 'Courier New', caption: 'Courier New'}, {name: 'Verdana', caption: 'Verdana'}, {name: 'Trebuchet MS', caption: 'Trebuchet MS'}],
      defaultVal: 'Trebuchet MS',
      value: '',
      category: 'css_zaxischart',
      section: 'css',
      description: 'Set the font family'
    },
    zAxisChartTitleFontFamily: {
      name: 'zAxisChartTitleFontFamily',
      title: 'Title Font Family',
      type: 'select',
      members: [{name: 'Lucida Grande', caption: 'Lucida Grande'}, {name: 'sans-serif', caption: 'Sans-Serif'}, {name: 'Courier New', caption: 'Courier New'}, {name: 'Verdana', caption: 'Verdana'}, {name: 'Trebuchet MS', caption: 'Trebuchet MS'}],
      defaultVal: 'Trebuchet MS',
      value: '',
      category: 'css_zaxischart',
      section: 'css',
      description: 'Set the font family'
    },
    onTapEvent: {
      name: 'onTapEvent',
      title: 'On Tap Event (iPad/iPhone)',
      type: 'select',
      members: [
      {name: 'tooltip', caption: 'Tooltip'},
      {name: 'zaxis', caption: 'Z-Axis'},
      {name: 'drilldown', caption: 'Drilldown'},
      {name: 'select', caption: 'Select'}
      ],
      defaultVal: 'tooltip',
      category: 'general_general',
      section: 'general'
    },
    onClick: {
      name: 'onClick',
      title: 'On Click',
      type: 'scripttext',
      members: '',
      defaultVal: '',
      value: '',
      category: 'scripting_general',
      section: 'scripting',
      description: 'This script will be triggered when a region is a clicked.'
    },
    mapDataAggregation: {
      name: 'mapDataAggregation',
      title: 'Aggregate Function',
      type: 'select',
      members: [
			           {
  'name': 'sum',
  'caption': 'SUM'
			           },
			           {
  'name': 'avg',
  'caption': 'AVG'
			           },
			           {
  'name': 'max',
  'caption': 'MAX'
			           },
			           {
  'name': 'min',
  'caption': 'MIN'
			           },
			           {
  'name': 'variance',
  'caption': 'VARIANCE'
			           },
			           {
  'name': 'stddev',
  'caption': 'STD DEVIATION'
			           }
			         ],
      category: 'dataseries_general',
      description: 'Choose the aggregation function for the dataset',
      section: 'dataseries'
    },
    bubbleColorAggregation: {
      name: 'bubbleColorAggregation',
      title: 'Aggregate Function',
      type: 'select',
      members: [
			           {
  'name': 'sum',
  'caption': 'SUM'
			           },
			           {
  'name': 'avg',
  'caption': 'AVG'
			           },
			           {
  'name': 'max',
  'caption': 'MAX'
			           },
			           {
  'name': 'min',
  'caption': 'MIN'
			           },
			           {
  'name': 'variance',
  'caption': 'VARIANCE'
			           },
			           {
  'name': 'stddev',
  'caption': 'STD DEVIATION'
			           }
			         ],
      category: 'dataseries_general',
      description: 'Choose the aggregation function for the bubble color measure',
      section: 'dataseries'
    },
    zAxisAggregation: {
      name: 'zAxisAggregation',
      title: 'Aggregate Function',
      type: 'select',
      members: [
			           {
  'name': 'sum',
  'caption': 'SUM'
			           },
			           {
  'name': 'avg',
  'caption': 'AVG'
			           },
			           {
  'name': 'max',
  'caption': 'MAX'
			           },
			           {
  'name': 'min',
  'caption': 'MIN'
			           },
			           {
  'name': 'variance',
  'caption': 'VARIANCE'
			           },
			           {
  'name': 'stddev',
  'caption': 'STD DEVIATION'
			           }
			         ],
      category: 'general_zaxis',
      description: 'Choose the aggregation function for the z-axis chart',
      section: 'dataseries'
    },
    plotMapAreaBorderWidth: {
      name: 'plotMapAreaBorderWidth',
      title: 'Border Width',
      type: 'number',
      defaultVal: 1,
      category: 'plotoptions_mapareas',
      description: 'The pixel width of the map areas.',
      section: 'plot_options'
    },
    plotMapAreaBorderColor: {
      name: 'plotMapAreaBorderColor',
      title: 'Border Color',
      type: 'colorpicker',
      defaultVal: '#C0C0C0',
      category: 'plotoptions_mapareas',
      description: 'The border color of the map area.',
      section: 'plot_options'
    }
  };
};
