var map_sources = {
	"af-all": {
		name: "AFGHANISTAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. af-kt)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. KT)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. AF.KT)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 24550741)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. AF37)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Khost)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/af/af-all",
		type: "country",
		source: "af-all"
	},
	"al-all": {
		name: "ALBANIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. al-vr)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. VR)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. AL.VR)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 29389565)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. AL51)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Vlor\u00eb)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/al/al-all",
		type: "country",
		source: "al-all"
	},
	"dz-all": {
		name: "ALGERIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. dz-ml)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. ML)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. DZ.ML)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2344618)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. AG48)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Mila)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/dz/dz-all",
		type: "country",
		source: "dz-all"
	},
	"as-all": {
		name: "AMERICAN SAMOA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. as-6516)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. AS.MA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 24549644)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 60020)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Manu's)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/as/as-all",
		type: "country",
		source: "as-all"
	},
	"ad-all": {
		name: "ANDORRA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ad-3689)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AL)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. AD.AN)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070553)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. AN07)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Andorra la Vella)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ad/ad-all",
		type: "country",
		source: "ad-all"
	},
	"ao-all": {
		name: "ANGOLA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ao-na)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. AO.NA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2344667)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. AO13)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Namibe)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ao/ao-all",
		type: "country",
		source: "ao-all"
	},
	"ag-all": {
		name: "ANTIGUA AND BARBUDA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ag-6313)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. AG.BB)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2344541)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. AC01)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Barbuda)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ag/ag-all",
		type: "country",
		source: "ag-all"
	},
	"ar-all": {
		name: "ARGENTINA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ar-tf)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. TF)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. AR.TF)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2344697)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. AR23)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Tierra del Fuego)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ar/ar-all",
		type: "country",
		source: "ar-all"
	},
	"am-all": {
		name: "ARMENIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. am-gr)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GR)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. AM.GR)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070204)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. AM04)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Gegharkunik)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/am/am-all",
		type: "country",
		source: "am-all"
	},
	"au-all": {
		name: "AUSTRALIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. au-nt)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NT)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. AU.NT)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2344701)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. AS03)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Northern Territory)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/au/au-all",
		type: "country",
		source: "au-all"
	},
	"at-all": {
		name: "AUSTRIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. at-wi)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. WI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. AT.WI)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2344716)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. AU09)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Wien)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/at/at-all",
		type: "country",
		source: "at-all"
	},
	"az-all": {
		name: "AZERBAIJAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. az-cf)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CF)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. AZ.CF)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 24550721)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. AJ35)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Culfa)"
		}, {
			name: "region",
			caption: "Region (e.g. Nax\u00e7?van Autonomous Republic)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/az/az-all",
		type: "country",
		source: "az-all"
	},
	"bs-all": {
		name: "BAHAMAS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. bs-rc)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. RC)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. BS.RC)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 24551252)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. BF49)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Rum Cay)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/bs/bs-all",
		type: "country",
		source: "bs-all"
	},
	"bh-all": {
		name: "BAHRAIN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. bh-3683)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AJ)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. BH.SO)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 56051602)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Al Jan?b?yah)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/bh/bh-all",
		type: "country",
		source: "bh-all"
	},
	"bd-all": {
		name: "BANGLADESH",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. bd-da)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. BD.DA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2344791)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. BG81)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Dhaka)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/bd/bd-all",
		type: "country",
		source: "bd-all"
	},
	"bb-all": {
		name: "BARBADOS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. bb-mi)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. BB.MI)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2344737)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. BB08)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Saint Michael)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/bb/bb-all",
		type: "country",
		source: "bb-all"
	},
	"by-all": {
		name: "BELARUS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. by-hm)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HM)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. BY.HM)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20069996)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. BO06)"
		}, {
			name: "name",
			caption: "Full Name (e.g. City of Minsk)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/by/by-all",
		type: "country",
		source: "by-all"
	},
	"be-all": {
		name: "BELGIUM",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. be-3530)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BR)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. BE.BU)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 55965974)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. BE11)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Brussels)"
		}, {
			name: "region",
			caption: "Region (e.g. Capital Region)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/be/be-all",
		type: "country",
		source: "be-all"
	},
	"bz-all": {
		name: "BELIZE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. bz-5784)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/bz/bz-all",
		type: "country",
		source: "bz-all"
	},
	"bj-all": {
		name: "BENIN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. bj-do)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DO)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. BJ.DO)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 55967671)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. BN13)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Donga)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/bj/bj-all",
		type: "country",
		source: "bj-all"
	},
	"bt-all": {
		name: "BHUTAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. bt-ty)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. TY)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. BT.TY)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 55967863)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. BT00)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Tashi Yangtse)"
		}, {
			name: "region",
			caption: "Region (e.g. Eastern)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/bt/bt-all",
		type: "country",
		source: "bt-all"
	},
	"bo-all": {
		name: "BOLIVIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. bo-lp)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LP)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. BO.LP)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2344804)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. BL04)"
		}, {
			name: "name",
			caption: "Full Name (e.g. La Paz)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/bo/bo-all",
		type: "country",
		source: "bo-all"
	},
	"ba-all": {
		name: "BOSNIA AND HERZEGOWINA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ba-3177)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. TU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. BA.BF)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 24551278)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Federation of Bosnia and Herzegovina)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. BK00)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Tuzla)"
		}, {
			name: "region",
			caption: "Region (e.g. Federacija Bosna i Hercegovina)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ba/ba-all",
		type: "country",
		source: "ba-all"
	},
	"bw-all": {
		name: "BOTSWANA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. bw-6964)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LO)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. BW.)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -2344749)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. South-East)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. BC)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Lobatse)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/bw/bw-all",
		type: "country",
		source: "bw-all"
	},
	"br-all": {
		name: "BRAZIL",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. br-pa)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. PA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. BR.PA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2344857)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. BR16)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Par\u00e1)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/br/br-all",
		type: "country",
		source: "br-all"
	},
	"bn-all": {
		name: "BRUNEI DARUSSALAM",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. bn-te)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. TE)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. BN.TE)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20069847)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. BX03)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Temburong)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/bn/bn-all",
		type: "country",
		source: "bn-all"
	},
	"bg-all": {
		name: "BULGARIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. bg-vt)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. VT)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. BG.VT)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070063)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. BU46)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Veliko Tarnovo)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/bg/bg-all",
		type: "country",
		source: "bg-all"
	},
	"bf-all": {
		name: "BURKINA FASO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. bf-ka)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. KA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. BF.KA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347619)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. UV53)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Kadiogo)"
		}, {
			name: "region",
			caption: "Region (e.g. Centre)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/bf/bf-all",
		type: "country",
		source: "bf-all"
	},
	"bi-all": {
		name: "BURUNDI",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. bi-br)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BR)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. BI.BR)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2344903)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. BY10)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Bururi)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/bi/bi-all",
		type: "country",
		source: "bi-all"
	},
	"kh-all": {
		name: "CAMBODIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. kh-kk)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. KK)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. KH.KK)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2344934)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. CB08)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Ka\u00f4h Kong)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/kh/kh-all",
		type: "country",
		source: "kh-all"
	},
	"cm-all": {
		name: "CAMEROON",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. cm-es)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. ES)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. CM.ES)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345033)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. CM04)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Est)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/cm/cm-all",
		type: "country",
		source: "cm-all"
	},
	"ca-all": {
		name: "CANADA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ca-5682)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "countries/ca/ca-all",
		type: "country",
		source: "ca-all"
	},
	"cv-all": {
		name: "CAPE VERDE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. cv-br)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BR)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. CV.BR)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345122)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. CV02)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Brava)"
		}, {
			name: "region",
			caption: "Region (e.g. Ilhas de Sotavento)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/cv/cv-all",
		type: "country",
		source: "cv-all"
	},
	"cf-all": {
		name: "CENTRAL AFRICAN REPUBLIC",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. cf-vk)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. VK)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. CF.VK)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345101)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. CT14)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Vakaga)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/cf/cf-all",
		type: "country",
		source: "cf-all"
	},
	"td-all": {
		name: "CHAD",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. td-ma)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. TD.MA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 56013482)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. CD11)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Mandoul)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/td/td-all",
		type: "country",
		source: "td-all"
	},
	"cl-all": {
		name: "CHILE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. cl-2730)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. CL.AR)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345021)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. CI04)"
		}, {
			name: "name",
			caption: "Full Name (e.g. La Araucan\u00eda)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/cl/cl-all",
		type: "country",
		source: "cl-all"
	},
	"cn-all": {
		name: "CHINA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. cn-3664)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. PI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. CN)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12497556)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Paracel Islands)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/cn/cn-all",
		type: "country",
		source: "cn-all"
	},
	"co-all": {
		name: "COLOMBIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. co-sa)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. CO.SA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345070)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. CO17)"
		}, {
			name: "name",
			caption: "Full Name (e.g. San Andr\u00e9s y Providencia)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/co/co-all",
		type: "country",
		source: "co-all"
	},
	"km-all": {
		name: "COMOROS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. km-3651)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MO)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. KM.AN)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345045)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. CN03)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Mo\u00fbh\u00eel\u00ee)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/km/km-all",
		type: "country",
		source: "km-all"
	},
	"cg-all": {
		name: "CONGO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. cg-ni)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. CG.NI)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2344972)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. CF07)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Niari)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/cg/cg-all",
		type: "country",
		source: "cg-all"
	},
	"cd-all": {
		name: "CONGO, THE DRC",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. cd-kv)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. KV)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. CD.KV)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20069829)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. CG12)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Sud-Kivu)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/cd/cd-all",
		type: "country",
		source: "cd-all"
	},
	"ck-all": {
		name: "COOK ISLANDS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nz-6471)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AT)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. CK.)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 24549674)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Atiu)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ck/ck-all",
		type: "country",
		source: "ck-all"
	},
	"cr-all": {
		name: "COSTA RICA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. cr-pu)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. PU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. CR.PU)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345087)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. CS07)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Puntarenas)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/cr/cr-all",
		type: "country",
		source: "cr-all"
	},
	"ci-all": {
		name: "COTE D'IVOIRE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ci-sc)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SC)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. CI.SC)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 55967004)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. IV63)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Sud-Como\u00e9)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ci/ci-all",
		type: "country",
		source: "ci-all"
	},
	"hr-all": {
		name: "CROATIA (local name: Hrvatska)",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. hr-kz)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. KZ)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. HR.KZ)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12577977)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. SI92)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Krapinsko-Zagorska)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/hr/hr-all",
		type: "country",
		source: "hr-all"
	},
	"cu-all": {
		name: "CUBA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. cu-ho)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HO)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. CU.HO)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345116)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. CU12)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Holgu\u00edn)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/cu/cu-all",
		type: "country",
		source: "cu-all"
	},
	"cy-all": {
		name: "CYPRUS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. cy-la)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. CY.LA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12577964)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. CY03)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Larnaca)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/cy/cy-all",
		type: "country",
		source: "cy-all"
	},
	"cz-all": {
		name: "CZECH REPUBLIC",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. cz-2293)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. PR)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. CZ.SK)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070472)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. EZ11)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Prague)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/cz/cz-all",
		type: "country",
		source: "cz-all"
	},
	"dk-all": {
		name: "DENMARK",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. dk-6326)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. DK.)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 28362580)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Midtjylland)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/dk/dk-all",
		type: "country",
		source: "dk-all"
	},
	"dj-all": {
		name: "DJIBOUTI",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. dj-5766)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/dj/dj-all",
		type: "country",
		source: "dj-all"
	},
	"dm-all": {
		name: "DOMINICA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. dm-lu)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. DM.LU)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345166)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. DO07)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Saint Luke)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/dm/dm-all",
		type: "country",
		source: "dm-all"
	},
	"do-all": {
		name: "DOMINICAN REPUBLIC",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. do-pn)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. PN)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. DO.PN)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345185)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. DR16)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Pedernales)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/do/do-all",
		type: "country",
		source: "do-all"
	},
	"tl-all": {
		name: "EAST TIMOR",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. tl-dl)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DL)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. TP.DL)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 24549898)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. TT00)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Dili)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/tl/tl-all",
		type: "country",
		source: "tl-all"
	},
	"ec-all": {
		name: "ECUADOR",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ec-gu)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. EC.GU)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345211)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. EC10)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Guayas)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ec/ec-all",
		type: "country",
		source: "ec-all"
	},
	"eg-all": {
		name: "EGYPT",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. eg-5847)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/eg/eg-all",
		type: "country",
		source: "eg-all"
	},
	"sv-all": {
		name: "EL SALVADOR",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. sv-un)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. UN)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. SV.UN)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345298)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. ES07)"
		}, {
			name: "name",
			caption: "Full Name (e.g. La Uni\u00f3n)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/sv/sv-all",
		type: "country",
		source: "sv-all"
	},
	"gq-all": {
		name: "EQUATORIAL GUINEA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. gq-li)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. GQ.LI)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20069853)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. EK08)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Litoral)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/gq/gq-all",
		type: "country",
		source: "gq-all"
	},
	"er-all": {
		name: "ERITREA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. er-5773)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/er/er-all",
		type: "country",
		source: "er-all"
	},
	"ee-all": {
		name: "ESTONIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ee-6019)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ee/ee-all",
		type: "country",
		source: "ee-all"
	},
	"et-all": {
		name: "ETHIOPIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. et-be)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BE)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. ET.BE)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 56013538)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. ET47)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Benshangul-Gumaz)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/et/et-all",
		type: "country",
		source: "et-all"
	},
	"fo-all": {
		name: "FAROE ISLANDS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fo-os)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. OS)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FO.OS)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424816)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FO00)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Eysturoyar)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fo/fo-all",
		type: "country",
		source: "fo-all"
	},
	"fj-all": {
		name: "FIJI",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fj-5722)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fj/fj-all",
		type: "country",
		source: "fj-all"
	},
	"fi-all": {
		name: "FINLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fi-3280)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. OS)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FI.)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 29389259)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Ostrobothnia)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fi/fi-all",
		type: "country",
		source: "fi-all"
	},
	"fr-all": {
		name: "FRANCE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-t)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. PC)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Poitou-Charentes)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "countries/fr/fr-all",
		type: "country",
		source: "fr-all"
	},
	"tf-all": {
		name: "FRENCH SOUTHERN TERRITORIES",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-3642)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AD)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. TF)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 28289406)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Archipel des Kerguelen)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/tf/tf-all",
		type: "country",
		source: "tf-all"
	},
	"ga-all": {
		name: "GABON",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ga-om)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. OM)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. GA.OM)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345456)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. GB08)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Ogoou\u00e9-Maritime)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ga/ga-all",
		type: "country",
		source: "ga-all"
	},
	"gm-all": {
		name: "GAMBIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. gm-mc)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MC)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. GM.MC)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345445)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. GA03)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Central River)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/gm/gm-all",
		type: "country",
		source: "gm-all"
	},
	"ge-all": {
		name: "GEORGIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ge-ab)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AB)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. GE.AB)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070401)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. GG02)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Abkhazia)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ge/ge-all",
		type: "country",
		source: "ge-all"
	},
	"de-all": {
		name: "GERMANY",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-ni)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. DE.NI)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345486)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. GM06)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Niedersachsen)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "countries/de/de-all",
		type: "country",
		source: "de-all"
	},
	"de-all-all": {
		name: "GERMANY, ADMIN2",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-sh-01054000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NO)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Nordfriesland)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "countries/de/de-all-all",
		type: "country",
		source: "countries/de/de-all-all",
		category: "Countries",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"gh-all": {
		name: "GHANA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. gh-ah)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AH)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. GH.AH)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345463)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. GH02)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Ashanti)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/gh/gh-all",
		type: "country",
		source: "gh-all"
	},
	"gr-all": {
		name: "GREECE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. gr-as)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AS)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. GR.AS)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12577886)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. GR47)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Notio Aigaio)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/gr/gr-all",
		type: "country",
		source: "gr-all"
	},
	"gl-all": {
		name: "GREENLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. gl-3278)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. KS)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. GL.VG)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Kommuneqarfik Sermersooq)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/gl/gl-all",
		type: "country",
		source: "gl-all"
	},
	"gd-all": {
		name: "GRENADA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. gd-6584)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. GD.CA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -2345478)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Carriacou and Petite Martinique)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/gd/gd-all",
		type: "country",
		source: "gd-all"
	},
	"gu-all": {
		name: "GUAM",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. gu-3605)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. GU)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424832)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Guam)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/gu/gu-all",
		type: "country",
		source: "gu-all"
	},
	"gt-all": {
		name: "GUATEMALA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. gt-qc)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. QC)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. GT.QC)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345565)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. GT14)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Quich\u00e9)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/gt/gt-all",
		type: "country",
		source: "gt-all"
	},
	"gn-all": {
		name: "GUINEA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. gn-7097)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. FO)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. GN.FO)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -56059377)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. GV10)"
		}, {
			name: "name",
			caption: "Full Name (e.g. For\u00e9cariah)"
		}, {
			name: "region",
			caption: "Region (e.g. Kindia)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/gn/gn-all",
		type: "country",
		source: "gn-all"
	},
	"gw-all": {
		name: "GUINEA-BISSAU",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. gw-bm)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BM)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. GW.BM)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346611)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. PU05)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Biombo)"
		}, {
			name: "region",
			caption: "Region (e.g. Norte)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/gw/gw-all",
		type: "country",
		source: "gw-all"
	},
	"gy-all": {
		name: "GUYANA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. gy-de)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DE)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. GY.DE)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345607)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. GY14)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Demerara-Mahaica)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/gy/gy-all",
		type: "country",
		source: "gy-all"
	},
	"ht-all": {
		name: "HAITI",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ht-ou)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. OU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. HT.OU)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345620)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. HA11)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Ouest)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ht/ht-all",
		type: "country",
		source: "ht-all"
	},
	"hn-all": {
		name: "HONDURAS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. hn-ib)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. IB)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. HN.IB)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345633)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. HO01)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Islas de la Bah\u00eda)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/hn/hn-all",
		type: "country",
		source: "hn-all"
	},
	"hu-all": {
		name: "HUNGARY",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. hu-no)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NO)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. HU.NO)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12577922)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. N\u00f3gr\u00e1d)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. HU14)"
		}, {
			name: "name",
			caption: "Full Name (e.g. N\u00f3gr\u00e1d)"
		}, {
			name: "region",
			caption: "Region (e.g. Northern Hungary)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/hu/hu-all",
		type: "country",
		source: "hu-all"
	},
	"is-all": {
		name: "ICELAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. is-ne)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NE)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. IS.NE)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Nor\u00f0urland eystra)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. IC32)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Nor\u00f0urland eystra)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/is/is-all",
		type: "country",
		source: "is-all"
	},
	"in-all": {
		name: "INDIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. in-py)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. PY)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. IN.PY)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070459)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. IN22)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Puducherry)"
		}, {
			name: "region",
			caption: "Region (e.g. South)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/in/in-all",
		type: "country",
		source: "in-all"
	},
	"id-all": {
		name: "INDONESIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. id-3700)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/id/id-all",
		type: "country",
		source: "id-all"
	},
	"ir-all": {
		name: "IRAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ir-5428)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ir/ir-all",
		type: "country",
		source: "ir-all"
	},
	"iq-all": {
		name: "IRAQ",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. iq-na)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. IQ.NA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345849)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. IZ17)"
		}, {
			name: "name",
			caption: "Full Name (e.g. An-Najaf)"
		}, {
			name: "region",
			caption: "Region (e.g. Iraq)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/iq/iq-all",
		type: "country",
		source: "iq-all"
	},
	"ie-all": {
		name: "IRELAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ie-5551)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ie/ie-all",
		type: "country",
		source: "ie-all"
	},
	"il-all": {
		name: "ISRAEL",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. il-hd)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HD)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. IL.HD)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345791)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. IS01)"
		}, {
			name: "name",
			caption: "Full Name (e.g. HaDarom)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/il/il-all",
		type: "country",
		source: "il-all"
	},
	"it-all": {
		name: "ITALY",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. it-na)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. IT.NA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12591829)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. IT04)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Napoli)"
		}, {
			name: "region",
			caption: "Region (e.g. Campania)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/it/it-all",
		type: "country",
		source: "it-all"
	},
	"jm-all": {
		name: "JAMAICA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. jm-ha)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. JM.HA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345913)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. JM02)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Hanover)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/jm/jm-all",
		type: "country",
		source: "jm-all"
	},
	"jp-all": {
		name: "JAPAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. jp-hs)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HS)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. JP.HS)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345861)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. JA11)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Hiroshima)"
		}, {
			name: "region",
			caption: "Region (e.g. Chugoku)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/jp/jp-all",
		type: "country",
		source: "jp-all"
	},
	"jo-all": {
		name: "JORDAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. jo-ma)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. JO.MA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345930)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. JO15)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Mafraq)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/jo/jo-all",
		type: "country",
		source: "jo-all"
	},
	"kz-all": {
		name: "KAZAKHSTAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. kz-5085)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/kz/kz-all",
		type: "country",
		source: "kz-all"
	},
	"ke-all": {
		name: "KENYA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ke-co)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CO)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. KE.CO)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2345938)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. KE02)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Coast)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ke/ke-all",
		type: "country",
		source: "ke-all"
	},
	"kp-all": {
		name: "KOREA, D.P.R.O.",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. kp-5044)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/kp/kp-all",
		type: "country",
		source: "kp-all"
	},
	"kr-all": {
		name: "KOREA, REPUBLIC OF",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. kr-4194)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/kr/kr-all",
		type: "country",
		source: "kr-all"
	},
	"kw-all": {
		name: "KUWAIT",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. kw-ja)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. JA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. KW.JA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070165)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. KU05)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Al Jahrah)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/kw/kw-all",
		type: "country",
		source: "kw-all"
	},
	"kg-all": {
		name: "KYRGYZSTAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. kg-gb)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GB)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. KG.GB)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070194)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. KG01)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Bishkek)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/kg/kg-all",
		type: "country",
		source: "kg-all"
	},
	"la-all": {
		name: "LAOS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. la-ou)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. OU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. LA.OU)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346005)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. LA07)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Oud\u00f4mxai)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/la/la-all",
		type: "country",
		source: "la-all"
	},
	"lv-all": {
		name: "LATVIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. lv-an)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AN)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. LV.AN)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -2346026)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Zemgale)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. LG)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Aknistes)"
		}, {
			name: "region",
			caption: "Region (e.g. Zemgale)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/lv/lv-all",
		type: "country",
		source: "lv-all"
	},
	"lb-all": {
		name: "LEBANON",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. lb-bi)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. LB.BI)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346013)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. LE11)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Beqaa)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/lb/lb-all",
		type: "country",
		source: "lb-all"
	},
	"ls-all": {
		name: "LESOTHO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ls-be)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BE)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. LS.BE)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20069865)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. LT10)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Berea)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ls/ls-all",
		type: "country",
		source: "ls-all"
	},
	"lr-all": {
		name: "LIBERIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. lr-gp)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GP)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. LR.GP)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -2346101)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. LI21)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Gbapolu)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/lr/lr-all",
		type: "country",
		source: "lr-all"
	},
	"ly-all": {
		name: "LIBYAN ARAB JAMAHIRIYA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ly-gd)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GD)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. LY.GD)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346139)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. LY56)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Ghadamis)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ly/ly-all",
		type: "country",
		source: "ly-all"
	},
	"li-all": {
		name: "LIECHTENSTEIN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. li-6425)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. LI.MA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070538)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. LS04)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Mauren)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/li/li-all",
		type: "country",
		source: "li-all"
	},
	"lt-all": {
		name: "LITHUANIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. lt-kp)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. KP)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. LT.KP)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 55848085)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. LH58)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Klaipedos)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/lt/lt-all",
		type: "country",
		source: "lt-all"
	},
	"lu-all": {
		name: "LUXEMBOURG",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. lu-di)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. LU.DI)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070542)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. LU01)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Diekirch)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/lu/lu-all",
		type: "country",
		source: "lu-all"
	},
	"mk-all": {
		name: "MACEDONIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. mk-vv)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. VV)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. MK.VV)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 24550867)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. MK99)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Vev?ani)"
		}, {
			name: "region",
			caption: "Region (e.g. Southwestern)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/mk/mk-all",
		type: "country",
		source: "mk-all"
	},
	"mg-all": {
		name: "MADAGASCAR",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. mg-987)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AN)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. MG.)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346149)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Toamasina)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. MA04)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Analanjirofo)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/mg/mg-all",
		type: "country",
		source: "mg-all"
	},
	"mw-all": {
		name: "MALAWI",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. mw-6970)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. MW.NA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070147)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. MI17)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Likoma)"
		}, {
			name: "region",
			caption: "Region (e.g. Northern)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/mw/mw-all",
		type: "country",
		source: "mw-all"
	},
	"my-all": {
		name: "MALAYSIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. my-sa)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. MY.SA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346310)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. MY16)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Sabah)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/my/my-all",
		type: "country",
		source: "my-all"
	},
	"ml-all": {
		name: "MALI",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ml-6392)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. ML.KK)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346180)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. ML01)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Bamako)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ml/ml-all",
		type: "country",
		source: "ml-all"
	},
	"mt-all": {
		name: "MALTA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. mt-7358)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SJ)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. MT)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -56043491)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Northern Harbour)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. MT49)"
		}, {
			name: "name",
			caption: "Full Name (e.g. St. Julian's)"
		}, {
			name: "region",
			caption: "Region (e.g. Malta Majjistral)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/mt/mt-all",
		type: "country",
		source: "mt-all"
	},
	"mr-all": {
		name: "MAURITANIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. mr-4965)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/mr/mr-all",
		type: "country",
		source: "mr-all"
	},
	"mu-all": {
		name: "MAURITIUS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. mu-6684)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GP)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. MU.)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346230)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Grand Port)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Grand Port)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/mu/mu-all",
		type: "country",
		source: "mu-all"
	},
	"mx-all": {
		name: "MEXICO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. mx-3622)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/mx/mx-all",
		type: "country",
		source: "mx-all"
	},
	"md-all": {
		name: "MOLDOVA, REPUBLIC OF",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. md-rz)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. RZ)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. MD.RZ)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -55948201)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. MD83)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Rezina)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/md/md-all",
		type: "country",
		source: "md-all"
	},
	"mc-all": {
		name: "MONACO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. mc-3633)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MO)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. MC)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424892)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Monaco)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/mc/mc-all",
		type: "country",
		source: "mc-all"
	},
	"mn-all": {
		name: "MONGOLIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. mn-da)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. MN.DA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070014)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. MG05)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Darhan-Uul)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/mn/mn-all",
		type: "country",
		source: "mn-all"
	},
	"me-all": {
		name: "MONTENEGRO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. me-an)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AN)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. ME.AN)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 29389233)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. MJ00)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Andrijevica)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/me/me-all",
		type: "country",
		source: "me-all"
	},
	"ma-all": {
		name: "MOROCCO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ma-rz)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. RZ)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. MA.RZ)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -56120059)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. MO49)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Rabat - Sal\u00e9 - Zemmour - Zaer)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ma/ma-all",
		type: "country",
		source: "ma-all"
	},
	"mz-all": {
		name: "MOZAMBIQUE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. mz-nm)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NM)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. MZ.NM)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346316)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. MZ06)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Nampula)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/mz/mz-all",
		type: "country",
		source: "mz-all"
	},
	"mm-all": {
		name: "MYANMAR (Burma)",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. mm-tn)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. TN)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. MM.TN)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2344821)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. BM12)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Tanintharyi)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/mm/mm-all",
		type: "country",
		source: "mm-all"
	},
	"na-all": {
		name: "NAMIBIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. na-os)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. OS)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. NA.OS)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20069842)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. WA05)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Omusati)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/na/na-all",
		type: "country",
		source: "na-all"
	},
	"nr-all": {
		name: "NAURU",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nr-6494)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AN)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. NR.AT)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070311)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. NR03)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Anetan)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/nr/nr-all",
		type: "country",
		source: "nr-all"
	},
	"np-all": {
		name: "NEPAL",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. np-750)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. NP.SP)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23706807)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Sudur Pashchimanchal)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. NP09)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Mahakali)"
		}, {
			name: "region",
			caption: "Region (e.g. Far-Western)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/np/np-all",
		type: "country",
		source: "np-all"
	},
	"nl-all": {
		name: "NETHERLANDS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nl-fr)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. FR)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. NL.FR)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346374)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. NL02)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Friesland)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "countries/nl/nl-all",
		type: "country",
		source: "nl-all"
	},
	"nl-all-all": {
		name: "THE NETHERLANDS, ADMIN2",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nl-fr-gm0088)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SC)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Schiermonnikoog)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "countries/nl/nl-all-all",
		type: "country",
		source: "countries/nl/nl-all-all",
		category: "Countries"
	},
	"nc-all": {
		name: "NEW CALEDONIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-il)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. IL)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. NC.IL)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 24549805)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. NC01)"
		}, {
			name: "name",
			caption: "Full Name (e.g. \u00celes Loyaut\u00e9)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/nc/nc-all",
		type: "country",
		source: "nc-all"
	},
	"nz-all": {
		name: "NEW ZEALAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nz-au)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. NZ.AU)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 15021756)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. NZE7)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Auckland)"
		}, {
			name: "region",
			caption: "Region (e.g. North Island)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/nz/nz-all",
		type: "country",
		source: "nz-all"
	},
	"ni-all": {
		name: "NICARAGUA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ni-as)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AS)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. NI.AS)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20069832)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. NU18)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Atl\u00e1ntico Sur)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ni/ni-all",
		type: "country",
		source: "ni-all"
	},
	"ne-all": {
		name: "NIGER",
		formats: [{
			name: "hc-a2",
			caption: "Postal Code (e.g. NI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. NE.NI)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20069994)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. NG09)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Niamey)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ne/ne-all",
		type: "country",
		source: "ne-all"
	},
	"ng-all": {
		name: "NIGERIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ng-ri)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. RI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. NG.RI)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346344)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. NI50)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Rivers)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ng/ng-all",
		type: "country",
		source: "ng-all"
	},
	"mp-all": {
		name: "NORTHERN MARIANA ISLANDS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. mp-ro)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. RO)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. MP.RO)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 29389660)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 100)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Rota)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/mp/mp-all",
		type: "country",
		source: "mp-all"
	},
	"no-all": {
		name: "NORWAY",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-mr)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MR)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. NO.MR)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346391)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. NO08)"
		}, {
			name: "name",
			caption: "Full Name (e.g. M\u00f8re og Romsdal)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "countries/no/no-all",
		type: "country",
		source: "no-all",
		has_credits: !0,
		credits: "Kartverket"
	},
	"no-all-all": {
		name: "NORWAY, ADMIN2",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-tr-1943)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. KV)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Kv\u00e6nangen)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "countries/no/no-all-all",
		type: "country",
		source: "countries/no/no-all-all",
		category: "Countries"
	},
	"om-all": {
		name: "OMAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. om-ss)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SS)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. OM.SS)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346256)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. MU04)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Ash Sharqiyah South)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/om/om-all",
		type: "country",
		source: "om-all"
	},
	"pk-all": {
		name: "PAKISTAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. pk-sd)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SD)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. PK.SD)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346499)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. PK05)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Sind)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/pk/pk-all",
		type: "country",
		source: "pk-all"
	},
	"pw-all": {
		name: "PALAU",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. pw-6740)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AN)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. PW.AN)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 24549824)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Angaur)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/pw/pw-all",
		type: "country",
		source: "pw-all"
	},
	"pa-all": {
		name: "PANAMA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. pa-ch)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CH)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. PA.CH)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346552)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. PM02)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Chiriqu\u00ed)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/pa/pa-all",
		type: "country",
		source: "pa-all"
	},
	"pg-all": {
		name: "PAPUA NEW GUINEA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. pg-4773)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/pg/pg-all",
		type: "country",
		source: "pg-all"
	},
	"py-all": {
		name: "PARAGUAY",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. py-ag)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AG)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. PY.AG)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346463)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. PA03)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Alto Paraguay)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/py/py-all",
		type: "country",
		source: "py-all"
	},
	"pe-all": {
		name: "PERU",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. pe-ic)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. IC)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. PE.IC)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346478)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. PE11)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Ica)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/pe/pe-all",
		type: "country",
		source: "pe-all"
	},
	"ph-all": {
		name: "PHILIPPINES",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ph-mn)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MN)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. PH.MN)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346698)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Misamis Oriental)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. RP43)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Misamis Oriental)"
		}, {
			name: "region",
			caption: "Region (e.g. Northern Mindanao (Region X))"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ph/ph-all",
		type: "country",
		source: "ph-all"
	},
	"pl-all": {
		name: "POLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. pl-ld)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LD)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. PL.LD)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12577937)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. PL51)"
		}, {
			name: "name",
			caption: "Full Name (e.g. ?\u00f3d?)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/pl/pl-all",
		type: "country",
		source: "pl-all"
	},
	"pt-all": {
		name: "PORTUGAL",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. pt-fa)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. FA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. PT.FA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346569)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. PO09)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Faro)"
		}, {
			name: "region",
			caption: "Region (e.g. Algarve)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/pt/pt-all",
		type: "country",
		source: "pt-all"
	},
	"pr-all": {
		name: "PUERTO RICO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. pr-3614-115)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. QU)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 72115)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Quebradillas)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/pr/pr-all-all",
		type: "country",
		source: "pr-all-all"
	},
	"qa-all": {
		name: "QATAR",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. qa-ms)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MS)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. QA.MS)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070005)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. QA07)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Madinat ach Shamal)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/qa/qa-all",
		type: "country",
		source: "qa-all"
	},
	"ro-all": {
		name: "ROMANIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ro-bi)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. RO.BI)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346624)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. RO10)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Bucharest)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ro/ro-all",
		type: "country",
		source: "ro-all"
	},
	"ru-all": {
		name: "RUSSIAN FEDERATION",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ru-3637)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. West Siberian)"
		}, {
			name: "region",
			caption: "Region (e.g. Urals)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ru/ru-all",
		type: "country",
		source: "ru-all"
	},
	"rw-all": {
		name: "RWANDA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. rw-s)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SO)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. RW.)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 55864752)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Southern)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/rw/rw-all",
		type: "country",
		source: "rw-all"
	},
	"kn-all": {
		name: "SAINT KITTS AND NEVIS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. kn-tp)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. TP)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. KN.TP)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346977)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. SC14)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Trinity Palmetto Point)"
		}, {
			name: "region",
			caption: "Region (e.g. Saint Kitts)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/kn/kn-all",
		type: "country",
		source: "kn-all"
	},
	"lc-all": {
		name: "SAINT LUCIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. lc-6591)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CH)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. LC.CS)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347026)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. ST04)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Choiseul)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/lc/lc-all",
		type: "country",
		source: "lc-all"
	},
	"vc-all": {
		name: "SAINT VINCENT AND THE GRENADINES",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. vc-gt)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GT)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. VC.GT)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347676)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. VC06)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Grenadines)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/vc/vc-all",
		type: "country",
		source: "vc-all"
	},
	"ws-all": {
		name: "SAMOA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ws-3586)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. TU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. WS.TU)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070339)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. WS10)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Tuamasaga)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ws/ws-all",
		type: "country",
		source: "ws-all"
	},
	"sm-all": {
		name: "SAN MARINO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. sm-6415)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MO)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. SM.MG)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070550)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. SM08)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Montegiardino)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/sm/sm-all",
		type: "country",
		source: "sm-all"
	},
	"st-all": {
		name: "SAO TOME AND PRINCIPE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. st-3593)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. ST)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. ST.ST)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347234)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. TP02)"
		}, {
			name: "name",
			caption: "Full Name (e.g. S\u00e3o Tom\u00e9)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/st/st-all",
		type: "country",
		source: "st-all"
	},
	"sa-all": {
		name: "SAUDI ARABIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. sa-4293)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/sa/sa-all",
		type: "country",
		source: "sa-all"
	},
	"sn-all": {
		name: "SENEGAL",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. sn-sl)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SL)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. SN.SL)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346990)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. SG14)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Matam)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/sn/sn-all",
		type: "country",
		source: "sn-all"
	},
	"rs-all": {
		name: "SERBIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. rs-jc)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. JC)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. RS.JC)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 29389212)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. RB02)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Ju?no-Backi)"
		}, {
			name: "region",
			caption: "Region (e.g. Ju?no-Ba?ki)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/rs/rs-all",
		type: "country",
		source: "rs-all"
	},
	"sc-all": {
		name: "SEYCHELLES",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. sc-6700)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BS)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. SC.)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 24549888)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Baie Sainte Anne)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/sc/sc-all",
		type: "country",
		source: "sc-all"
	},
	"sl-all": {
		name: "SIERRA LEONE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. sl-so)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SO)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. SL.SO)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347002)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. SL03)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Southern)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/sl/sl-all",
		type: "country",
		source: "sl-all"
	},
	"sg-all": {
		name: "SINGAPORE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. sg-3595)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CS)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. SG.CS)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 24703044)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Central Singapore)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/sg/sg-all",
		type: "country",
		source: "sg-all"
	},
	"sk-all": {
		name: "SLOVAKIA (Slovak Republic)",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. sk-bl)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BL)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. SK.BL)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070505)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Bratislavsk\u00fd)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. LO02)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Bratislavsk\u00fd)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/sk/sk-all",
		type: "country",
		source: "sk-all"
	},
	"si-all": {
		name: "SLOVENIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. si-1439)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. VE)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. SI.SA.VE)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 55848395)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. SID7)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Velenje)"
		}, {
			name: "region",
			caption: "Region (e.g. Savinjska)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/si/si-all",
		type: "country",
		source: "si-all"
	},
	"sb-all": {
		name: "SOLOMON ISLANDS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. sb-4191)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/sb/sb-all",
		type: "country",
		source: "sb-all"
	},
	"so-all": {
		name: "SOMALIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. so-br)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BR)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. SO.BR)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347008)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. SO03)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Bari)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/so/so-all",
		type: "country",
		source: "so-all"
	},
	"za-all": {
		name: "SOUTH AFRICA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. za-ec)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. EC)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. ZA.EC)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346979)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. SF01)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Eastern Cape)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/za/za-all",
		type: "country",
		source: "za-all"
	},
	"ss-all": {
		name: "SOUTH SUDAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ss-we)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. WE)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. SD.WE)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20069900)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. SU45)"
		}, {
			name: "name",
			caption: "Full Name (e.g. West Equatoria)"
		}, {
			name: "region",
			caption: "Region (e.g. Equatoria)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ss/ss-all",
		type: "country",
		source: "ss-all"
	},
	"es-all": {
		name: "SPAIN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. es-pm)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. PM)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. ES.PM)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12602088)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. SP07)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Baleares)"
		}, {
			name: "region",
			caption: "Region (e.g. Islas Baleares)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/es/es-all",
		type: "country",
		source: "es-all"
	},
	"lk-all": {
		name: "SRI LANKA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. lk-bc)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BC)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. LK.BC)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23706508)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. CE04)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Ma?akalapuva)"
		}, {
			name: "region",
			caption: "Region (e.g. N\u00e6?g?nahira pa??ta)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/lk/lk-all",
		type: "country",
		source: "lk-all"
	},
	"sd-all": {
		name: "SUDAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. sd-rs)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. RS)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. SD.RS)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20069904)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Ash Sharq?| Ash Sharq?yah| Eastern)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. EG02)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Red Sea)"
		}, {
			name: "region",
			caption: "Region (e.g. Kassala)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/sd/sd-all",
		type: "country",
		source: "sd-all"
	},
	"sr-all": {
		name: "SURINAME",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. sr-ni)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. SR.NI)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346410)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. NS14)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Nickerie)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/sr/sr-all",
		type: "country",
		source: "sr-all"
	},
	"sz-all": {
		name: "SWAZILAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. sz-lu)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. SZ.LU)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20069891)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. WZ02)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Lubombo)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/sz/sz-all",
		type: "country",
		source: "sz-all"
	},
	"se-all": {
		name: "SWEDEN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. se-4461)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/se/se-all",
		type: "country",
		source: "se-all"
	},
	"ch-all": {
		name: "SWITZERLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ch-fr)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. FR)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. CH.FR)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347088)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. SZ06)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Fribourg)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ch/ch-all",
		type: "country",
		source: "ch-all"
	},
	"sy-all": {
		name: "SYRIAN ARAB REPUBLIC",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. sy-di)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. SY.DI)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347081)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. SY13)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Damascus)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/sy/sy-all",
		type: "country",
		source: "sy-all"
	},
	"tw-all": {
		name: "TAIWAN, PROVINCE OF CHINA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. tw-pt)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. PT)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. TW.TW.PT)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347340)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Pingtung)"
		}, {
			name: "region",
			caption: "Region (e.g. Taiwan Province)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/tw/tw-all",
		type: "country",
		source: "tw-all"
	},
	"tj-all": {
		name: "TAJIKISTAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. tj-le)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LE)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. TJ.LE)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070294)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. TI04)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Leninabad)"
		}, {
			name: "region",
			caption: "Region (e.g. Khudzhand)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/tj/tj-all",
		type: "country",
		source: "tj-all"
	},
	"tz-all": {
		name: "TANZANIA, UNITED REPUBLIC OF",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. tz-mw)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MW)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. TZ.MW)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347363)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. TZ12)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Mwanza)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/tz/tz-all",
		type: "country",
		source: "tz-all"
	},
	"th-all": {
		name: "THAILAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. th-pr)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. PR)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. TH.PR)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347134)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. TH07)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Phrae)"
		}, {
			name: "region",
			caption: "Region (e.g. Northern)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/th/th-all",
		type: "country",
		source: "th-all"
	},
	"tg-all": {
		name: "TOGO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. tg-ma)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. TG.MA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 56048437)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. TO24)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Maritime)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/tg/tg-all",
		type: "country",
		source: "tg-all"
	},
	"tt-all": {
		name: "TRINIDAD AND TOBAGO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. tt-180)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AR)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. TT.TP)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347116)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. TD01)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Arima)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/tt/tt-all",
		type: "country",
		source: "tt-all"
	},
	"tn-all": {
		name: "TUNISIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. tn-4431)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/tn/tn-all",
		type: "country",
		source: "tn-all"
	},
	"tr-all": {
		name: "TURKEY",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. tr-ga)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. TR.GA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347284)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. TU83)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Gaziantep)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/tr/tr-all",
		type: "country",
		source: "tr-all"
	},
	"tm-all": {
		name: "TURKMENISTAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. tm-ba)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. TM.BA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347349)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. TX02)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Balkan)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/tm/tm-all",
		type: "country",
		source: "tm-all"
	},
	"ug-all": {
		name: "UGANDA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ug-2595)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. KA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. UG.KN)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20070420)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. UG36)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Kalangala)"
		}, {
			name: "region",
			caption: "Region (e.g. Central)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ug/ug-all",
		type: "country",
		source: "ug-all"
	},
	"ua-all": {
		name: "UKRAINE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ua-my)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MY)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. UA.MY)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347549)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. UP15)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Odessa)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ua/ua-all",
		type: "country",
		source: "ua-all"
	},
	"ae-all": {
		name: "UNITED ARAB EMIRATES",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ae-az)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AZ)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. AE.AZ)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347109)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. AE01)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Abu Dhabi)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ae/ae-all",
		type: "country",
		source: "ae-all"
	},
	"gb-all": {
		name: "UNITED KINGDOM",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. gb-ay)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AY)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. GB.AY)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12602211)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. North Wales)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. UK93)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Anglesey)"
		}, {
			name: "region",
			caption: "Region (e.g. East Wales)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/gb/gb-all",
		type: "country",
		source: "gb-all"
	},
	"us-all": {
		name: "UNITED STATES OF AMERICA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ma)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. US.MA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347580)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. US25)"
		}, {
			name: "state-fips",
			caption: "State FIPS Code (e.g. 25)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Massachusetts)"
		}, {
			name: "region",
			caption: "Region (e.g. Northeast)"
		}],
		offline: !0,
		drilldown: 2,
		obj: "countries/us/us-all",
		type: "country",
		source: "us-all"
	},
	"us-113-congress": {
		name: "UNITED STATES OF AMERICA, (113TH)",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ca-24)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 0624)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 24)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "countries/us/custom/us-113-congress",
		type: "country",
		source: "countries/us/custom/us-113-congress",
		category: "Countries"
	},
	"us-all-all-highres": {
		name: "UNITED STATES OF AMERICA, ADMIN2, HIGHRES",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ca-083)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SB)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 06083)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Santa Barbara)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "countries/us/us-all-all-highres",
		type: "country",
		source: "countries/us/us-all-all-highres",
		category: "Countries"
	},
	"us/us-all-all": {
		name: "UNITED STATES OF AMERICA, ADMIN2",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ca-083)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SB)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 06083)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Santa Barbara)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "countries/us/us-all-all",
		type: "country",
		source: "countries/us/us-all-all",
		category: "Countries"
	},
	"us-all-mainland": {
		name: "UNITED STATES OF AMERICA, MAINLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ma)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. US.MA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347580)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. US25)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Massachusetts)"
		}, {
			name: "region",
			caption: "Region (e.g. Northeast)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "countries/us/custom/us-all-mainland",
		type: "country",
		source: "countries/us/custom/us-all-mainland",
		category: "Countries"
	},
	"us-all-territories": {
		name: "UNITED STATES OF AMERICA WITH TERRITORIES",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ma)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. US.MA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347580)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. US25)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Massachusetts)"
		}, {
			name: "region",
			caption: "Region (e.g. Northeast)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "countries/us/custom/us-all-territories",
		type: "country",
		source: "countries/us/custom/us-all-territories",
		category: "Countries"
	},
	"us-small": {
		name: "UNITED STATES OF AMERICA, SMALL",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ma)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. US.MA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347580)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. US25)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Massachusetts)"
		}, {
			name: "region",
			caption: "Region (e.g. Northeast)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "countries/us/custom/us-small",
		type: "country",
		source: "countries/us/custom/us-small",
		category: "Countries"
	},
	"uy-all": {
		name: "URUGUAY",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. uy-sa)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. UY.SA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347654)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. UY15)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Salto)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/uy/uy-all",
		type: "country",
		source: "uy-all"
	},
	"uz-all": {
		name: "UZBEKISTAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. uz-fa)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. FA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. UZ.FA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347662)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. UZ03)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Ferghana)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/uz/uz-all",
		type: "country",
		source: "uz-all"
	},
	"vu-all": {
		name: "VANUATU",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. vu-tr)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. TR)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. VU.TR)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 20069883)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. NH07)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Torba)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/vu/vu-all",
		type: "country",
		source: "vu-all"
	},
	"ve-all": {
		name: "VENEZUELA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ve-3609)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ve/ve-all",
		type: "country",
		source: "ve-all"
	},
	"vn-all": {
		name: "VIETNAM",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. vn-yb)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. YB)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. VN.YB)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347753)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. VM70)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Y\u00ean B\u00e1i)"
		}, {
			name: "region",
			caption: "Region (e.g. ?\u00f4ng B?c)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/vn/vn-all",
		type: "country",
		source: "vn-all"
	},
	"vi-all": {
		name: "VIRGIN ISLANDS (U.S.)",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. vi-3617)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. ST)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. VI.ST)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 24549909)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 010)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Saint Thomas)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/vi/vi-all",
		type: "country",
		source: "vi-all"
	},
	"wf-all": {
		name: "WALLIS AND FUTUNA ISLANDS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-6510)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. `U)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. WF.UV)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 24549911)"
		}, {
			name: "name",
			caption: "Full Name (e.g. `Uvea)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/wf/wf-all",
		type: "country",
		source: "wf-all"
	},
	"eh-all": {
		name: "WESTERN SAHARA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. eh-3625)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. WS)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. EH)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424990)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Western Sahara)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/eh/eh-all",
		type: "country",
		source: "eh-all"
	},
	"ye-all": {
		name: "YEMEN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ye-3662)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NU)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. -99)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. -99)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ye/ye-all",
		type: "country",
		source: "ye-all"
	},
	"zm-all": {
		name: "ZAMBIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. zm-lp)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LP)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. ZM.LP)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347808)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. ZA04)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Luapula)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/zm/zm-all",
		type: "country",
		source: "zm-all"
	},
	"zw-all": {
		name: "ZIMBABWE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. zw-ma)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. ZW.MA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347810)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. ZI01)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Manicaland)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/zw/zw-all",
		type: "country",
		source: "zw-all"
	},
	africa: {
		name: "AFRICA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ug)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. UG)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424974)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Eastern Africa)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Uganda)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. UGA)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. UG)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "custom/africa",
		type: "continent",
		source: "africa"
	},
	antarctica: {
		name: "ANTARCTICA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. aq-3638)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AN)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. AQ)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 28289409)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Antarctica)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "custom/antarctica",
		type: "continent",
		source: "antarctica"
	},
	asia: {
		name: "ASIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ir)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. IR)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424851)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Southern Asia)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Iran)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. IRN)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. IR)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "custom/asia",
		type: "continent",
		source: "asia"
	},
	"central-america": {
		name: "CENTRAL AMERICA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. hn)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HN)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424841)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Central America)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Honduras)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. HND)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. HN)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "custom/central-america",
		type: "continent",
		source: "central-america"
	},
	europe: {
		name: "EUROPE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. dk)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DK)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424796)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Northern Europe)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Denmark)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. DNK)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. DK)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "custom/europe",
		type: "continent",
		source: "europe"
	},
	"middle-east": {
		name: "MIDDLE EAST",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. sa)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424938)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Western Asia)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Saudi Arabia)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. SAU)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. SA)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "custom/middle-east",
		type: "continent",
		source: "middle-east"
	},
	"nordic-countries": {
		name: "NORDIC COUNTRIES",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. dk)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DK)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424796)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Northern Europe)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Denmark)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. DNK)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. DK)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "custom/nordic-countries",
		type: "continent",
		source: "nordic-countries"
	},
	"north-america": {
		name: "NORTH AMERICA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. gl)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GL)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424828)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Northern America)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Greenland)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. GRL)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. GL)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "custom/north-america",
		type: "continent",
		source: "north-america"
	},
	scandinavia: {
		name: "SCANDINAVIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. dk)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DK)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424796)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Northern Europe)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Denmark)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. DNK)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. DK)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "custom/scandinavia",
		type: "continent",
		source: "scandinavia"
	},
	"south-america": {
		name: "SOUTH AMERICA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. br)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BR)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424768)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. South America)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Brazil)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. BRA)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. BR)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "custom/south-america",
		type: "continent",
		source: "south-america"
	},
	"usa-and-canada": {
		name: "USA & CANADA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ca)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CA)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. US.CA)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2347563)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Pacific)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. US06)"
		}, {
			name: "name",
			caption: "Full Name (e.g. California)"
		}, {
			name: "region",
			caption: "Region (e.g. West)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "custom/usa-and-canada",
		type: "continent",
		source: "usa-and-canada"
	},
	world: {
		name: "WORLD MAP",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. dz)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DZ)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424740)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Northern Africa)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Algeria)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. DZA)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. DZ)"
		}],
		offline: !0,
		drilldown: 3,
		obj: "custom/world",
		type: "world",
		source: "world"
	},
	"world-highres": {
		name: "WORLD MAP (HIGH RES)",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. dz)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DZ)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424740)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Northern Africa)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Algeria)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. DZA)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. DZ)"
		}],
		offline: !1,
		drilldown: 3,
		obj: "custom/world-highres",
		type: "world",
		source: "world-highres"
	},
	benelux: {
		name: "BENELUX",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nl-nh)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NH)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. NL.NH)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 2346379)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. NL07)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Noord-Holland)"
		}],
		offline: !1,
		drilldown: 3,
		obj: "custom/benelux",
		type: "custom",
		source: "custom/benelux",
		category: "Custom"
	},
	"european-union": {
		name: "EUROPEAN UNION",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. dk)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DK)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424796)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Northern Europe)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Denmark)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. DNK)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. DK)"
		}],
		offline: !1,
		drilldown: 3,
		obj: "custom/european-union",
		type: "custom",
		source: "custom/european-union",
		category: "Custom"
	},
	"gb-all-ireland": {
		name: "IRELAND AND UNITED KINGDOM",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. gb-ay)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AY)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. GB.AY)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12602211)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. North Wales)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. UK93)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Anglesey)"
		}, {
			name: "region",
			caption: "Region (e.g. East Wales)"
		}],
		offline: !1,
		drilldown: 3,
		obj: "custom/gb-all-ireland",
		type: "custom",
		source: "custom/gb-all-ireland",
		category: "Custom"
	},
	nato: {
		name: "NORTH ATLANTIC TREATY ORGANIZATION",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. dk)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DK)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424796)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Northern Europe)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Denmark)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. DNK)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. DK)"
		}],
		offline: !1,
		drilldown: 3,
		obj: "custom/nato",
		type: "custom",
		source: "custom/nato",
		category: "Custom"
	},
	"nordic-countries-core": {
		name: "NORDIC COUNTRIES WITHOUT GREENLAND, SVALBARD, AND JAN MAYEN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. dk)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DK)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424796)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Northern Europe)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Denmark)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. DNK)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. DK)"
		}],
		offline: !1,
		drilldown: 3,
		obj: "custom/nordic-countries-core",
		type: "custom",
		source: "custom/nordic-countries-core",
		category: "Custom"
	},
	"north-america-no-central": {
		name: "NORTH AMERICA WITHOUT CENTRAL",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. gl)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GL)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424828)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Northern America)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Greenland)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. GRL)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. GL)"
		}],
		offline: !1,
		drilldown: 3,
		obj: "custom/north-america-no-central",
		type: "custom",
		source: "custom/north-america-no-central",
		category: "Custom"
	},
	oceania: {
		name: "OCEANIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. as)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AS)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424746)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Polynesia)"
		}, {
			name: "name",
			caption: "Full Name (e.g. American Samoa)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. ASM)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. AS)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "custom/oceania",
		type: "custom",
		source: "custom/oceania",
		category: "Custom"
	},
	"world-continents": {
		name: "WORLD CONTINENTS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. eu)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. EU)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Europe)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. EU)"
		}],
		offline: !1,
		drilldown: 2,
		obj: "custom/world-continents",
		type: "custom",
		source: "custom/world-continents",
		category: "Custom"
	},
	"world-eckert3-highres": {
		name: "WORLD, ECKERT III PROJECTION, HIGHRES",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. dk)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DK)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424796)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Northern Europe)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Denmark)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. DNK)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. DK)"
		}],
		offline: !1,
		drilldown: 3,
		obj: "custom/world-eckert3-highres",
		type: "custom",
		source: "custom/world-eckert3-highres",
		category: "Custom"
	},
	"world-eckert3": {
		name: "WORLD, ECKERT III PROJECTION",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. dk)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DK)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424796)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Northern Europe)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Denmark)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. DNK)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. DK)"
		}],
		offline: !1,
		drilldown: 3,
		obj: "custom/world-eckert3",
		type: "custom",
		source: "custom/world-eckert3",
		category: "Custom"
	},
	"world-robinson": {
		name: "WORLD MAP (ROBINSON)",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. dk)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DK)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424796)"
		}, {
			name: "subregion",
			caption: "Subregion (e.g. Northern Europe)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Denmark)"
		}, {
			name: "iso-a3",
			caption: "ISO Alpha-3 Code (e.g. DNK)"
		}, {
			name: "iso-a2",
			caption: "ISO Alpha-2 Code (e.g. DK)"
		}],
		offline: !1,
		drilldown: 3,
		obj: "custom/world-robinson",
		type: "custom",
		source: "world-robinson"
	},
	"ca-ab-all": {
		name: "ALBERTA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ca-ab-4813)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DN)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Division No. 13)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ca/ca-ab-all",
		type: "ca-admin2",
		source: "countries/ca/ca-ab-all",
		category: "Canada (Admin 2)"
	},
	"ca-bc-all": {
		name: "BRITISH COLUMBIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ca-bc-5917)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CA)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Capital)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ca/ca-bc-all",
		type: "ca-admin2",
		source: "countries/ca/ca-bc-all",
		category: "Canada (Admin 2)"
	},
	"ca-mb-all": {
		name: "MANITOBA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ca-mb-4620)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DN)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Division No. 20)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ca/ca-mb-all",
		type: "ca-admin2",
		source: "countries/ca/ca-mb-all",
		category: "Canada (Admin 2)"
	},
	"ca-nb-all": {
		name: "NEW BRUNSWICK",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ca-nb-1315)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GL)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Gloucester)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ca/ca-nb-all",
		type: "ca-admin2",
		source: "countries/ca/ca-nb-all",
		category: "Canada (Admin 2)"
	},
	"ca-nf-all": {
		name: "NEWFOUNDLAND AND LABRADOR",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ca-nl-1009)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DN)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Division No.  9)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ca/ca-nf-all",
		type: "ca-admin2",
		source: "countries/ca/ca-nf-all",
		category: "Canada (Admin 2)"
	},
	"ca-ns-all": {
		name: "NOVA SCOTIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ca-ns-1217)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CB)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Cape Breton)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ca/ca-ns-all",
		type: "ca-admin2",
		source: "countries/ca/ca-ns-all",
		category: "Canada (Admin 2)"
	},
	"ca-nt-all": {
		name: "NORTHWEST TERRITORIES",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ca-nt-6103)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. R3)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Region 3)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ca/ca-nt-all",
		type: "ca-admin2",
		source: "countries/ca/ca-nt-all",
		category: "Canada (Admin 2)"
	},
	"ca-nu-all": {
		name: "NUNAVUT",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ca-nu-6204)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BA)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Baffin)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ca/ca-nu-all",
		type: "ca-admin2",
		source: "countries/ca/ca-nu-all",
		category: "Canada (Admin 2)"
	},
	"ca-on-all": {
		name: "ONTARIO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ca-on-3559)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. RR)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Rainy River)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ca/ca-on-all",
		type: "ca-admin2",
		source: "countries/ca/ca-on-all",
		category: "Canada (Admin 2)"
	},
	"ca-pe-all": {
		name: "PRINCE EDWARD ISLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ca-pe-1103)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. PR)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Prince)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ca/ca-pe-all",
		type: "ca-admin2",
		source: "countries/ca/ca-pe-all",
		category: "Canada (Admin 2)"
	},
	"ca-qc-all": {
		name: "QUEBEC",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ca-qc-2487)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AO)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Abitibi-Ouest)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ca/ca-qc-all",
		type: "ca-admin2",
		source: "countries/ca/ca-qc-all",
		category: "Canada (Admin 2)"
	},
	"ca-sk-all": {
		name: "SASKATCHEWAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ca-sk-4711)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DN)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Division No. 11)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ca/ca-sk-all",
		type: "ca-admin2",
		source: "countries/ca/ca-sk-all",
		category: "Canada (Admin 2)"
	},
	"ca-yt-all": {
		name: "YUKON",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. ca-yt-6001)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. YU)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Yukon)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/ca/ca-yt-all",
		type: "ca-admin2",
		source: "countries/ca/ca-yt-all",
		category: "Canada (Admin 2)"
	},
	"fr-a-all": {
		name: "ALSACE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-a-br)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BR)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.BR)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597135)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FR96)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Bas-Rhin)"
		}, {
			name: "region",
			caption: "Region (e.g. Alsace)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-a-all",
		type: "fr-admin2",
		source: "countries/fr/fr-a-all",
		category: "France (Admin 2)"
	},
	"fr-b-all": {
		name: "AQUITAINE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-b-lg)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LG)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.LG)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597143)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FR97)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Lot-et-Garonne)"
		}, {
			name: "region",
			caption: "Region (e.g. Aquitaine)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-b-all",
		type: "fr-admin2",
		source: "countries/fr/fr-b-all",
		category: "France (Admin 2)"
	},
	"fr-c-all": {
		name: "AUVERGNE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-c-cl)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CL)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.CL)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597148)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FR98)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Cantal)"
		}, {
			name: "region",
			caption: "Region (e.g. Auvergne)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-c-all",
		type: "fr-admin2",
		source: "countries/fr/fr-c-all",
		category: "France (Admin 2)"
	},
	"fr-d-all": {
		name: "BOURGOGNE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-d-sl)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SL)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.SL)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597153)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRA1)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Sa\u00f4ne-et-Loire)"
		}, {
			name: "region",
			caption: "Region (e.g. Bourgogne)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-d-all",
		type: "fr-admin2",
		source: "countries/fr/fr-d-all",
		category: "France (Admin 2)"
	},
	"fr-e-all": {
		name: "BRETAGNE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-e-fi)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. FI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.FI)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12591797)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRA2)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Finist\u00e8re)"
		}, {
			name: "region",
			caption: "Region (e.g. Bretagne)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-e-all",
		type: "fr-admin2",
		source: "countries/fr/fr-e-all",
		category: "France (Admin 2)"
	},
	"fr-f-all": {
		name: "CENTRE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-f-in)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. IN)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.IN)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597125)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRA3)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Indre)"
		}, {
			name: "region",
			caption: "Region (e.g. Centre)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-f-all",
		type: "fr-admin2",
		source: "countries/fr/fr-f-all",
		category: "France (Admin 2)"
	},
	"fr-g-all": {
		name: "CHAMPAGNE-ARDENNE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-g-an)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AN)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.AN)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597142)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRA4)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Ardennes)"
		}, {
			name: "region",
			caption: "Region (e.g. Champagne-Ardenne)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-g-all",
		type: "fr-admin2",
		source: "countries/fr/fr-g-all",
		category: "France (Admin 2)"
	},
	"fr-gf-all": {
		name: "GUYANE FRAN\u00c3\u00a7AISE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-gf-gf)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GF)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.GF)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424811)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FG01)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Guyane fran\u00e7aise)"
		}, {
			name: "region",
			caption: "Region (e.g. Guyane fran\u00e7aise)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-gf-all",
		type: "fr-admin2",
		source: "countries/fr/fr-gf-all",
		category: "France (Admin 2)"
	},
	"fr-gp-all": {
		name: "GUADELOUPE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-gp-gp)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GP)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.GP)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424831)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Guadeloupe)"
		}, {
			name: "region",
			caption: "Region (e.g. Guadeloupe)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-gp-all",
		type: "fr-admin2",
		source: "countries/fr/fr-gp-all",
		category: "France (Admin 2)"
	},
	"fr-h-all": {
		name: "CORSE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-h-cs)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CS)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.CS)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597134)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FR14)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Corse-du-Sud)"
		}, {
			name: "region",
			caption: "Region (e.g. Corse)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-h-all",
		type: "fr-admin2",
		source: "countries/fr/fr-h-all",
		category: "France (Admin 2)"
	},
	"fr-i-all": {
		name: "FRANCHE-COMT\u00c3\u00a9",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-i-hn)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HN)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.HN)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597119)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRA6)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Haute-Sa\u00f4ne)"
		}, {
			name: "region",
			caption: "Region (e.g. Franche-Comt\u00e9)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-i-all",
		type: "fr-admin2",
		source: "countries/fr/fr-i-all",
		category: "France (Admin 2)"
	},
	"fr-j-all": {
		name: "\u00c3\u017dLE-DE-FRANCE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-j-se)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SE)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.SE)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597137)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRA8)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Seine-et-Marne)"
		}, {
			name: "region",
			caption: "Region (e.g. \u00cele-de-France)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-j-all",
		type: "fr-admin2",
		source: "countries/fr/fr-j-all",
		category: "France (Admin 2)"
	},
	"fr-k-all": {
		name: "LANGUEDOC-ROUSSILLON",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-k-lz)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LZ)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.LZ)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597162)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRA9)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Loz\u00e8re)"
		}, {
			name: "region",
			caption: "Region (e.g. Languedoc-Roussillon)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-k-all",
		type: "fr-admin2",
		source: "countries/fr/fr-k-all",
		category: "France (Admin 2)"
	},
	"fr-l-all": {
		name: "LIMOUSIN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-l-cr)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CR)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.CR)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597164)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRB1)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Creuse)"
		}, {
			name: "region",
			caption: "Region (e.g. Limousin)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-l-all",
		type: "fr-admin2",
		source: "countries/fr/fr-l-all",
		category: "France (Admin 2)"
	},
	"fr-m-all": {
		name: "LORRAINE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-m-mm)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MM)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.MM)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597176)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRB2)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Meurthe-et-Moselle)"
		}, {
			name: "region",
			caption: "Region (e.g. Lorraine)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-m-all",
		type: "fr-admin2",
		source: "countries/fr/fr-m-all",
		category: "France (Admin 2)"
	},
	"fr-mq-all": {
		name: "MARTINIQUE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-mq-mq)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MQ)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.MQ)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424884)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Martinique)"
		}, {
			name: "region",
			caption: "Region (e.g. Martinique)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-mq-all",
		type: "fr-admin2",
		source: "countries/fr/fr-mq-all",
		category: "France (Admin 2)"
	},
	"fr-n-all": {
		name: "MIDI-PYR\u00c3\u00a9N\u00c3\u00a9ES",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-n-hp)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HP)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.HP)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597169)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRB3)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Hautes-Pyr\u00e9n\u00e9es)"
		}, {
			name: "region",
			caption: "Region (e.g. Midi-Pyr\u00e9n\u00e9es)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-n-all",
		type: "fr-admin2",
		source: "countries/fr/fr-n-all",
		category: "France (Admin 2)"
	},
	"fr-o-all": {
		name: "NORD-PAS-DE-CALAIS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-o-no)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NO)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.NO)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597168)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRB4)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Nord)"
		}, {
			name: "region",
			caption: "Region (e.g. Nord-Pas-de-Calais)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-o-all",
		type: "fr-admin2",
		source: "countries/fr/fr-o-all",
		category: "France (Admin 2)"
	},
	"fr-p-all": {
		name: "BASSE-NORMANDIE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-p-cv)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CV)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.CV)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597127)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FR99)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Calvados)"
		}, {
			name: "region",
			caption: "Region (e.g. Basse-Normandie)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-p-all",
		type: "fr-admin2",
		source: "countries/fr/fr-p-all",
		category: "France (Admin 2)"
	},
	"fr-q-all": {
		name: "HAUTE-NORMANDIE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-q-sm)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SM)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.SM)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597115)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRA7)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Seine-Maritime)"
		}, {
			name: "region",
			caption: "Region (e.g. Haute-Normandie)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-q-all",
		type: "fr-admin2",
		source: "countries/fr/fr-q-all",
		category: "France (Admin 2)"
	},
	"fr-r-all": {
		name: "PAYS DE LA LOIRE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-r-vd)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. VD)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.VD)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597200)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRA5)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Vend\u00e9e)"
		}, {
			name: "region",
			caption: "Region (e.g. Pays de la Loire)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-r-all",
		type: "fr-admin2",
		source: "countries/fr/fr-r-all",
		category: "France (Admin 2)"
	},
	"fr-re-all": {
		name: "R\u00c3\u00a9UNION",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-re-re)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. RE)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.RE)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424931)"
		}, {
			name: "name",
			caption: "Full Name (e.g. La R\u00e9union)"
		}, {
			name: "region",
			caption: "Region (e.g. R\u00e9union)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-re-all",
		type: "fr-admin2",
		source: "countries/fr/fr-re-all",
		category: "France (Admin 2)"
	},
	"fr-s-all": {
		name: "PICARDIE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-s-as)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AS)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.AS)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597170)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRB6)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Aisne)"
		}, {
			name: "region",
			caption: "Region (e.g. Picardie)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-s-all",
		type: "fr-admin2",
		source: "countries/fr/fr-s-all",
		category: "France (Admin 2)"
	},
	"fr-t-all": {
		name: "POITOU-CHARENTES",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-t-cm)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CM)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.CM)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597189)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRB7)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Charente-Maritime)"
		}, {
			name: "region",
			caption: "Region (e.g. Poitou-Charentes)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-t-all",
		type: "fr-admin2",
		source: "countries/fr/fr-t-all",
		category: "France (Admin 2)"
	},
	"fr-u-all": {
		name: "PROVENCE-ALPES-C\u00c3\u00b4TE-D'AZUR",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-u-am)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AM)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.AM)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12591800)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRB8)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Alpes-Maritimes)"
		}, {
			name: "region",
			caption: "Region (e.g. Provence-Alpes-C\u00f4te-d'Azur)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-u-all",
		type: "fr-admin2",
		source: "countries/fr/fr-u-all",
		category: "France (Admin 2)"
	},
	"fr-v-all": {
		name: "RH\u00c3\u00b4NE-ALPES",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-v-ai)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AI)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.AI)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 12597195)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. FRB9)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Ain)"
		}, {
			name: "region",
			caption: "Region (e.g. Rh\u00f4ne-Alpes)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-v-all",
		type: "fr-admin2",
		source: "countries/fr/fr-v-all",
		category: "France (Admin 2)"
	},
	"fr-yt-all": {
		name: "MAYOTTE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. fr-yt-yt)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. YT)"
		}, {
			name: "hasc",
			caption: "Hierarchical Administrative Subdivision Code (e.g. FR.YT)"
		}, {
			name: "woe-id",
			caption: "GeoPlanet WOEID (e.g. 23424886)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Mayotte)"
		}, {
			name: "region",
			caption: "Region (e.g. Mayotte)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/fr/fr-yt-all",
		type: "fr-admin2",
		source: "countries/fr/fr-yt-all",
		category: "France (Admin 2)"
	},
	"de-bb-all": {
		name: "BRANDENBURG",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-bb-12052000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CO)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Cottbus)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-bb-all",
		type: "de-admin2",
		source: "countries/de/de-bb-all",
		category: "Germany (Admin 2)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-be-all": {
		name: "BERLIN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-be-11000000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BE)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Berlin)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-be-all",
		type: "de-admin2",
		source: "countries/de/de-be-all",
		category: "Germany (Admin 2)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-bw-all": {
		name: "BADEN-W\u00c3\u00bcRTTEMBERG",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-bw-08136000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. OS)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Ostalbkreis)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-bw-all",
		type: "de-admin2",
		source: "countries/de/de-bw-all",
		category: "Germany (Admin 2)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-by-all": {
		name: "BAYERN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-by-09673000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. RG)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Rh\u00f6n-Grabfeld)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-by-all",
		type: "de-admin2",
		source: "countries/de/de-by-all",
		category: "Germany (Admin 2)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-hb-all": {
		name: "BREMEN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-hb-04012000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BR)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Bremerhaven)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-hb-all",
		type: "de-admin2",
		source: "countries/de/de-hb-all",
		category: "Germany (Admin 2)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-he-all": {
		name: "HESSEN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-he-06633000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. KA)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Kassel)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-he-all",
		type: "de-admin2",
		source: "countries/de/de-he-all",
		category: "Germany (Admin 2)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-hh-all": {
		name: "HAMBURG",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-hh-02000000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HA)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Hamburg)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-hh-all",
		type: "de-admin2",
		source: "countries/de/de-hh-all",
		category: "Germany (Admin 2)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-mv-all": {
		name: "MECKLENBURG-VORPOMMERN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-mv-13075000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. VG)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Vorpommern-Greifswald)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-mv-all",
		type: "de-admin2",
		source: "countries/de/de-mv-all",
		category: "Germany (Admin 2)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-ni-all": {
		name: "NIEDERSACHSEN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-ni-03452000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AU)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Aurich)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-ni-all",
		type: "de-admin2",
		source: "countries/de/de-ni-all",
		category: "Germany (Admin 2)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-nw-all": {
		name: "NORDRHEIN-WESTFALEN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-nw-05914000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HA)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Hagen)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-nw-all",
		type: "de-admin2",
		source: "countries/de/de-nw-all",
		category: "Germany (Admin 2)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-rp-all": {
		name: "RHEINLAND-PFALZ",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-rp-07138000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NE)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Neuwied)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-rp-all",
		type: "de-admin2",
		source: "countries/de/de-rp-all",
		category: "Germany (Admin 2)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-sh-all": {
		name: "SCHLESWIG-HOLSTEIN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-sh-01054000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NO)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Nordfriesland)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-sh-all",
		type: "de-admin2",
		source: "countries/de/de-sh-all",
		category: "Germany (Admin 2)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-sl-all": {
		name: "SAARLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-sl-10042000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MW)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Merzig-Wadern)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-sl-all",
		type: "de-admin2",
		source: "countries/de/de-sl-all",
		category: "Germany (Admin 2)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-sn-all": {
		name: "SACHSEN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-sn-14522000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MI)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Mittelsachsen)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-sn-all",
		type: "de-admin2",
		source: "countries/de/de-sn-all",
		category: "Germany (Admin 2)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-st-all": {
		name: "SACHSEN-ANHALT",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-st-15002000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. H()"
		}, {
			name: "name",
			caption: "Full Name (e.g. Halle (Saale))"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-st-all",
		type: "de-admin2",
		source: "countries/de/de-st-all",
		category: "Germany (Admin 2)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-th-all": {
		name: "TH\u00c3\u00bcRINGEN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-th-16062000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NO)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Nordhausen)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-th-all",
		type: "de-admin2",
		source: "countries/de/de-th-all",
		category: "Germany (Admin 2)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-bb-all-all": {
		name: "BRANDENBURG",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-bb-12060000-12060020)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BB)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Bernau bei Berlin)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-bb-all-all",
		type: "de-admin3",
		source: "countries/de/de-bb-all-all",
		category: "Germany (Admin 3)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-be-all-all": {
		name: "BERLIN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-be-11000000-11000000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BE)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Berlin)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-be-all-all",
		type: "de-admin3",
		source: "countries/de/de-be-all-all",
		category: "Germany (Admin 3)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-bw-all-all": {
		name: "BADEN-W\u00c3\u00bcRTTEMBERG",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-bw-08215000-08215102)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. EL)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Eggenstein-Leopoldshafen)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-bw-all-all",
		type: "de-admin3",
		source: "countries/de/de-bw-all-all",
		category: "Germany (Admin 3)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-by-all-all": {
		name: "BAYERN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-by-09189000-09189152)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. TI)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Tittmoning)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-by-all-all",
		type: "de-admin3",
		source: "countries/de/de-by-all-all",
		category: "Germany (Admin 3)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-hb-all-all": {
		name: "BREMEN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-hb-04012000-04012000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BR)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Bremerhaven)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-hb-all-all",
		type: "de-admin3",
		source: "countries/de/de-hb-all-all",
		category: "Germany (Admin 3)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-hh-all-all": {
		name: "HAMBURG",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-hh-02000000-02000000)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HA)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Hamburg)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-hh-all-all",
		type: "de-admin3",
		source: "countries/de/de-hh-all-all",
		category: "Germany (Admin 3)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-he-all-all": {
		name: "HESSEN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-he-06633000-06633004)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BR)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Breuna)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-he-all-all",
		type: "de-admin3",
		source: "countries/de/de-he-all-all",
		category: "Germany (Admin 3)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-mv-all-all": {
		name: "MECKLENBURG-VORPOMMERN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-mv-13074000-13074007)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BL)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Blowatz)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-mv-all-all",
		type: "de-admin3",
		source: "countries/de/de-mv-all-all",
		category: "Germany (Admin 3)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-ni-all-all": {
		name: "NIEDERSACHSEN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-ni-03452000-03452501)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NM)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Nordseeinsel Memmert)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-ni-all-all",
		type: "de-admin3",
		source: "countries/de/de-ni-all-all",
		category: "Germany (Admin 3)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-nw-all-all": {
		name: "NORDRHEIN-WESTFALEN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-nw-05554000-05554052)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SC)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Sch\u00f6ppingen)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-nw-all-all",
		type: "de-admin3",
		source: "countries/de/de-nw-all-all",
		category: "Germany (Admin 3)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-rp-all-all": {
		name: "RHEINLAND-PFALZ",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-rp-07138000-07138077)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. WI)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Windhagen)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-rp-all-all",
		type: "de-admin3",
		source: "countries/de/de-rp-all-all",
		category: "Germany (Admin 3)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-sh-all-all": {
		name: "SCHLESWIG-HOLSTEIN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-sh-01056000-01056025)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HE)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Helgoland)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-sh-all-all",
		type: "de-admin3",
		source: "countries/de/de-sh-all-all",
		category: "Germany (Admin 3)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-sl-all-all": {
		name: "SAARLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-sl-10041000-10041100)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SA)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Saarbr\u00fccken)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-sl-all-all",
		type: "de-admin3",
		source: "countries/de/de-sl-all-all",
		category: "Germany (Admin 3)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-sn-all-all": {
		name: "SACHSEN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-sn-14627000-14627090)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. KE)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Ketzerbachtal)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-sn-all-all",
		type: "de-admin3",
		source: "countries/de/de-sn-all-all",
		category: "Germany (Admin 3)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-st-all-all": {
		name: "SACHSEN-ANHALT",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-st-14730000-14730190)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MO)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Mockrehna)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-st-all-all",
		type: "de-admin3",
		source: "countries/de/de-st-all-all",
		category: "Germany (Admin 3)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"de-th-all-all": {
		name: "TH\u00c3\u00bcRINGEN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. de-th-16065000-16065054)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. OL)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Oldisleben)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/de/de-th-all-all",
		type: "de-admin3",
		source: "countries/de/de-th-all-all",
		category: "Germany (Admin 3)",
		credits: "GeoBasis-DE / BKG 2014",
		has_credits: !0
	},
	"nl-dr-all": {
		name: "DRENTHE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nl-dr-gm1680)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AE)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Aa en Hunze)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/nl/nl-dr-all",
		type: "nl-admin2",
		source: "countries/nl/nl-dr-all",
		category: "Netherlands (Admin 2)",
		credits: "Kadaster/CBS 2014",
		has_credits: !0
	},
	"nl-fl-all": {
		name: "FLEVOLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nl-fl-gm0050)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. ZE)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Zeewolde)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/nl/nl-fl-all",
		type: "nl-admin2",
		source: "countries/nl/nl-fl-all",
		category: "Netherlands (Admin 2)",
		credits: "Kadaster/CBS 2014",
		has_credits: !0
	},
	"nl-fr-all": {
		name: "FRIESLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nl-fr-gm0058)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DO)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Dongeradeel)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/nl/nl-fr-all",
		type: "nl-admin2",
		source: "countries/nl/nl-fr-all",
		category: "Netherlands (Admin 2)",
		credits: "Kadaster/CBS 2014",
		has_credits: !0
	},
	"nl-ge-all": {
		name: "GELDERLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nl-ge-gm0200)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AP)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Apeldoorn)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/nl/nl-ge-all",
		type: "nl-admin2",
		source: "countries/nl/nl-ge-all",
		category: "Netherlands (Admin 2)",
		credits: "Kadaster/CBS 2014",
		has_credits: !0
	},
	"nl-gr-all": {
		name: "GRONINGEN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nl-gr-gm1651)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. EE)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Eemsmond)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/nl/nl-gr-all",
		type: "nl-admin2",
		source: "countries/nl/nl-gr-all",
		category: "Netherlands (Admin 2)",
		credits: "Kadaster/CBS 2014",
		has_credits: !0
	},
	"nl-li-all": {
		name: "LIMBURG",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nl-li-gm0889)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BE)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Beesel)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/nl/nl-li-all",
		type: "nl-admin2",
		source: "countries/nl/nl-li-all",
		category: "Netherlands (Admin 2)",
		credits: "Kadaster/CBS 2014",
		has_credits: !0
	},
	"nl-nb-all": {
		name: "NOORD-BRABANT",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nl-3558-gm1655)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HA)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Halderberge)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/nl/nl-nb-all",
		type: "nl-admin2",
		source: "countries/nl/nl-nb-all",
		category: "Netherlands (Admin 2)",
		credits: "Kadaster/CBS 2014",
		has_credits: !0
	},
	"nl-nh-all": {
		name: "NOORD-HOLLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nl-3557-gm0381)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BU)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Bussum)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/nl/nl-nh-all",
		type: "nl-admin2",
		source: "countries/nl/nl-nh-all",
		category: "Netherlands (Admin 2)",
		credits: "Kadaster/CBS 2014",
		has_credits: !0
	},
	"nl-ov-all": {
		name: "OVERIJSSEL",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nl-ov-gm0166)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. KA)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Kampen)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/nl/nl-ov-all",
		type: "nl-admin2",
		source: "countries/nl/nl-ov-all",
		category: "Netherlands (Admin 2)",
		credits: "Kadaster/CBS 2014",
		has_credits: !0
	},
	"nl-ut-all": {
		name: "UTRECHT",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nl-3559-gm0351)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. WO)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Woudenberg)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/nl/nl-ut-all",
		type: "nl-admin2",
		source: "countries/nl/nl-ut-all",
		category: "Netherlands (Admin 2)",
		credits: "Kadaster/CBS 2014",
		has_credits: !0
	},
	"nl-ze-all": {
		name: "ZEELAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nl-ze-gm0716)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. TH)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Tholen)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/nl/nl-ze-all",
		type: "nl-admin2",
		source: "countries/nl/nl-ze-all",
		category: "Netherlands (Admin 2)",
		credits: "Kadaster/CBS 2014",
		has_credits: !0
	},
	"nl-zh-all": {
		name: "ZUID-HOLLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. nl-3560-gm0627)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. WA)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Waddinxveen)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/nl/nl-zh-all",
		type: "nl-admin2",
		source: "countries/nl/nl-zh-all",
		category: "Netherlands (Admin 2)",
		credits: "Kadaster/CBS 2014",
		has_credits: !0
	},
	"no-aa-all": {
		name: "AUST-AGDER",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-aa-928)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BI)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Birkenes)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-aa-all",
		type: "no-admin2",
		source: "countries/no/no-aa-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-ak-all": {
		name: "AKERSHUS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-ak-216)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NE)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Nesodden)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-ak-all",
		type: "no-admin2",
		source: "countries/no/no-ak-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-bu-all": {
		name: "BUSKERUD",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-bu-620)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HO)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Hol)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-bu-all",
		type: "no-admin2",
		source: "countries/no/no-bu-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-fi-all": {
		name: "FINNMARK",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-fi-2002)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. VA)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Vard\u00f8)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-fi-all",
		type: "no-admin2",
		source: "countries/no/no-fi-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-he-all": {
		name: "HEDMARK",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-he-441)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. OS)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Os)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-he-all",
		type: "no-admin2",
		source: "countries/no/no-he-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-ho-all": {
		name: "HORDALAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-ho-1253)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. OS)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Oster\u00f8y)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-ho-all",
		type: "no-admin2",
		source: "countries/no/no-ho-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-mr-all": {
		name: "M\u00c3\u00b8RE OG ROMSDAL",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-mr-1566)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SU)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Surnadal)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-mr-all",
		type: "no-admin2",
		source: "countries/no/no-mr-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-no-all": {
		name: "NORDLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-no-1856)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. R\u00d8)"
		}, {
			name: "name",
			caption: "Full Name (e.g. R\u00f8st)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-no-all",
		type: "no-admin2",
		source: "countries/no/no-no-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-nt-all": {
		name: "NORD-TR\u00c3\u00b8NDELAG",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-nt-1749)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. FL)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Flatanger)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-nt-all",
		type: "no-admin2",
		source: "countries/no/no-nt-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-of-all": {
		name: "\u00c3\u02dcSTFOLD",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-of-101)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HA)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Halden)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-of-all",
		type: "no-admin2",
		source: "countries/no/no-of-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-op-all": {
		name: "OPPLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-op-522)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GA)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Gausdal)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-op-all",
		type: "no-admin2",
		source: "countries/no/no-op-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-os-all": {
		name: "OSLO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-os-301)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. OS)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Oslo)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-os-all",
		type: "no-admin2",
		source: "countries/no/no-os-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-ro-all": {
		name: "ROGALAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-ro-1160)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. VI)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Vindafjord)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-ro-all",
		type: "no-admin2",
		source: "countries/no/no-ro-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-sf-all": {
		name: "SOGN OG FJORDANE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-sf-1428)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AS)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Askvoll)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-sf-all",
		type: "no-admin2",
		source: "countries/no/no-sf-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-st-all": {
		name: "S\u00c3\u00b8R-TR\u00c3\u00b8NDELAG",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-st-1621)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. \u00d8R)"
		}, {
			name: "name",
			caption: "Full Name (e.g. \u00d8rland)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-st-all",
		type: "no-admin2",
		source: "countries/no/no-st-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-te-all": {
		name: "TELEMARK",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-te-830)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NI)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Nissedal)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-te-all",
		type: "no-admin2",
		source: "countries/no/no-te-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-tr-all": {
		name: "TROMS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-tr-1943)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. KV)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Kv\u00e6nangen)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-tr-all",
		type: "no-admin2",
		source: "countries/no/no-tr-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-va-all": {
		name: "VEST-AGDER",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-va-1004)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. FL)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Flekkefjord)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-va-all",
		type: "no-admin2",
		source: "countries/no/no-va-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"no-vf-all": {
		name: "VESTFOLD",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. no-vf-701)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HO)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Horten)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/no/no-vf-all",
		type: "no-admin2",
		source: "countries/no/no-vf-all",
		category: "Netherlands (Admin 2)",
		credits: "Kartverket",
		has_credits: !0
	},
	"us-ak-all": {
		name: "ALASKA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ak-261)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. VC)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 02261)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Valdez-Cordova)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-ak-all",
		type: "us-admin2",
		source: "countries/us/us-ak-all",
		category: "United States (Admin 2)"
	},
	"us-al-all": {
		name: "ALABAMA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-al-007)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BI)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 01007)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Bibb)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-al-all",
		type: "us-admin2",
		source: "countries/us/us-al-all",
		category: "United States (Admin 2)"
	},
	"us-ar-all": {
		name: "ARKANSAS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ar-073)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LA)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 05073)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Lafayette)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-ar-all",
		type: "us-admin2",
		source: "countries/us/us-ar-all",
		category: "United States (Admin 2)"
	},
	"us-az-all": {
		name: "ARIZONA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-az-011)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GR)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 04011)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Greenlee)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-az-all",
		type: "us-admin2",
		source: "countries/us/us-az-all",
		category: "United States (Admin 2)"
	},
	"us-ca-all": {
		name: "CALIFORNIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ca-083)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SB)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 06083)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Santa Barbara)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-ca-all",
		type: "us-admin2",
		source: "countries/us/us-ca-all",
		category: "United States (Admin 2)"
	},
	"us-co-all": {
		name: "COLORADO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-co-069)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LA)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 08069)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Larimer)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-co-all",
		type: "us-admin2",
		source: "countries/us/us-co-all",
		category: "United States (Admin 2)"
	},
	"us-ct-all": {
		name: "CONNECTICUT",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ct-003)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HA)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 09003)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Hartford)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-ct-all",
		type: "us-admin2",
		source: "countries/us/us-ct-all",
		category: "United States (Admin 2)"
	},
	"us-dc-all": {
		name: "DISTRICT OF COLUMBIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-dc-001)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DO)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 11001)"
		}, {
			name: "name",
			caption: "Full Name (e.g. District of Columbia)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-dc-all",
		type: "us-admin2",
		source: "countries/us/us-dc-all",
		category: "United States (Admin 2)"
	},
	"us-de-all": {
		name: "DELAWARE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-de-003)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. NC)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 10003)"
		}, {
			name: "name",
			caption: "Full Name (e.g. New Castle)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-de-all",
		type: "us-admin2",
		source: "countries/us/us-de-all",
		category: "United States (Admin 2)"
	},
	"us-fl-all": {
		name: "FLORIDA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-fl-131)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. WA)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 12131)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Walton)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-fl-all",
		type: "us-admin2",
		source: "countries/us/us-fl-all",
		category: "United States (Admin 2)"
	},
	"us-ga-all": {
		name: "GEORGIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ga-295)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. WA)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 13295)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Walker)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-ga-all",
		type: "us-admin2",
		source: "countries/us/us-ga-all",
		category: "United States (Admin 2)"
	},
	"us-hi-all": {
		name: "HAWAII",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-hi-003)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HO)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 15003)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Honolulu)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-hi-all",
		type: "us-admin2",
		source: "countries/us/us-hi-all",
		category: "United States (Admin 2)"
	},
	"us-ia-all": {
		name: "IOWA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ia-125)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MA)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 19125)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Marion)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-ia-all",
		type: "us-admin2",
		source: "countries/us/us-ia-all",
		category: "United States (Admin 2)"
	},
	"us-id-all": {
		name: "IDAHO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-id-073)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. OW)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 16073)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Owyhee)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-id-all",
		type: "us-admin2",
		source: "countries/us/us-id-all",
		category: "United States (Admin 2)"
	},
	"us-il-all": {
		name: "ILLINOIS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-il-003)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AL)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 17003)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Alexander)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-il-all",
		type: "us-admin2",
		source: "countries/us/us-il-all",
		category: "United States (Admin 2)"
	},
	"us-in-all": {
		name: "INDIANA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-in-139)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. RU)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 18139)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Rush)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-in-all",
		type: "us-admin2",
		source: "countries/us/us-in-all",
		category: "United States (Admin 2)"
	},
	"us-ks-all": {
		name: "KANSAS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ks-091)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. JO)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 20091)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Johnson)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-ks-all",
		type: "us-admin2",
		source: "countries/us/us-ks-all",
		category: "United States (Admin 2)"
	},
	"us-ky-all": {
		name: "KENTUCKY",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ky-091)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HA)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 21091)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Hancock)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-ky-all",
		type: "us-admin2",
		source: "countries/us/us-ky-all",
		category: "United States (Admin 2)"
	},
	"us-la-all": {
		name: "LOUISIANA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-la-087)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SB)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 22087)"
		}, {
			name: "name",
			caption: "Full Name (e.g. St. Bernard)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-la-all",
		type: "us-admin2",
		source: "countries/us/us-la-all",
		category: "United States (Admin 2)"
	},
	"us-ma-all": {
		name: "MASSACHUSETTS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ma-007)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DU)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 25007)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Dukes)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-ma-all",
		type: "us-admin2",
		source: "countries/us/us-ma-all",
		category: "United States (Admin 2)"
	},
	"us-md-all": {
		name: "MARYLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-md-047)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. WO)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 24047)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Worcester)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-md-all",
		type: "us-admin2",
		source: "countries/us/us-md-all",
		category: "United States (Admin 2)"
	},
	"us-me-all": {
		name: "MAINE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-me-009)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HA)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 23009)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Hancock)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-me-all",
		type: "us-admin2",
		source: "countries/us/us-me-all",
		category: "United States (Admin 2)"
	},
	"us-mi-all": {
		name: "MICHIGAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-mi-089)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LE)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 26089)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Leelanau)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-mi-all",
		type: "us-admin2",
		source: "countries/us/us-mi-all",
		category: "United States (Admin 2)"
	},
	"us-mn-all": {
		name: "MINNESOTA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-mn-051)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GR)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 27051)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Grant)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-mn-all",
		type: "us-admin2",
		source: "countries/us/us-mn-all",
		category: "United States (Admin 2)"
	},
	"us-mo-all": {
		name: "MISSOURI",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-mo-223)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. WA)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 29223)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Wayne)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-mo-all",
		type: "us-admin2",
		source: "countries/us/us-mo-all",
		category: "United States (Admin 2)"
	},
	"us-ms-all": {
		name: "MISSISSIPPI",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ms-005)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AM)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 28005)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Amite)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-ms-all",
		type: "us-admin2",
		source: "countries/us/us-ms-all",
		category: "United States (Admin 2)"
	},
	"us-mt-all": {
		name: "MONTANA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-mt-005)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BL)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 30005)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Blaine)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-mt-all",
		type: "us-admin2",
		source: "countries/us/us-mt-all",
		category: "United States (Admin 2)"
	},
	"us-nc-all": {
		name: "NORTH CAROLINA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-nc-031)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CA)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 37031)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Carteret)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-nc-all",
		type: "us-admin2",
		source: "countries/us/us-nc-all",
		category: "United States (Admin 2)"
	},
	"us-nd-all": {
		name: "NORTH DAKOTA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-nd-087)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SL)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 38087)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Slope)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-nd-all",
		type: "us-admin2",
		source: "countries/us/us-nd-all",
		category: "United States (Admin 2)"
	},
	"us-ne-all": {
		name: "NEBRASKA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ne-085)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. HA)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 31085)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Hayes)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-ne-all",
		type: "us-admin2",
		source: "countries/us/us-ne-all",
		category: "United States (Admin 2)"
	},
	"us-nh-all": {
		name: "NEW HAMPSHIRE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-nh-015)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. RO)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 33015)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Rockingham)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-nh-all",
		type: "us-admin2",
		source: "countries/us/us-nh-all",
		category: "United States (Admin 2)"
	},
	"us-nj-all": {
		name: "NEW JERSEY",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-nj-029)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. OC)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 34029)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Ocean)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-nj-all",
		type: "us-admin2",
		source: "countries/us/us-nj-all",
		category: "United States (Admin 2)"
	},
	"us-nm-all": {
		name: "NEW MEXICO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-nm-031)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. MC)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 35031)"
		}, {
			name: "name",
			caption: "Full Name (e.g. McKinley)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-nm-all",
		type: "us-admin2",
		source: "countries/us/us-nm-all",
		category: "United States (Admin 2)"
	},
	"us-nv-all": {
		name: "NEVADA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-nv-005)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DO)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 32005)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Douglas)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-nv-all",
		type: "us-admin2",
		source: "countries/us/us-nv-all",
		category: "United States (Admin 2)"
	},
	"us-ny-all": {
		name: "NEW YORK",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ny-009)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CA)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 36009)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Cattaraugus)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-ny-all",
		type: "us-admin2",
		source: "countries/us/us-ny-all",
		category: "United States (Admin 2)"
	},
	"us-oh-all": {
		name: "OHIO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-oh-085)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LA)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 39085)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Lake)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-oh-all",
		type: "us-admin2",
		source: "countries/us/us-oh-all",
		category: "United States (Admin 2)"
	},
	"us-ok-all": {
		name: "OKLAHOMA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ok-037)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CR)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 40037)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Creek)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-ok-all",
		type: "us-admin2",
		source: "countries/us/us-ok-all",
		category: "United States (Admin 2)"
	},
	"us-or-all": {
		name: "OREGON",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-or-057)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. TI)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 41057)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Tillamook)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-or-all",
		type: "us-admin2",
		source: "countries/us/us-or-all",
		category: "United States (Admin 2)"
	},
	"us-pa-all": {
		name: "PENNSYLVANIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-pa-015)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BR)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 42015)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Bradford)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-pa-all",
		type: "us-admin2",
		source: "countries/us/us-pa-all",
		category: "United States (Admin 2)"
	},
	"us-ri-all": {
		name: "RHODE ISLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ri-009)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. WA)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 44009)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Washington)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-ri-all",
		type: "us-admin2",
		source: "countries/us/us-ri-all",
		category: "United States (Admin 2)"
	},
	"us-sc-all": {
		name: "SOUTH CAROLINA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-sc-063)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. LE)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 45063)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Lexington)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-sc-all",
		type: "us-admin2",
		source: "countries/us/us-sc-all",
		category: "United States (Admin 2)"
	},
	"us-sd-all": {
		name: "SOUTH DAKOTA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-sd-129)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. WA)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 46129)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Walworth)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-sd-all",
		type: "us-admin2",
		source: "countries/us/us-sd-all",
		category: "United States (Admin 2)"
	},
	"us-tn-all": {
		name: "TENNESSEE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-tn-023)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CH)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 47023)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Chester)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-tn-all",
		type: "us-admin2",
		source: "countries/us/us-tn-all",
		category: "United States (Admin 2)"
	},
	"us-tx-all": {
		name: "TEXAS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-tx-179)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GR)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 48179)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Gray)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-tx-all",
		type: "us-admin2",
		source: "countries/us/us-tx-all",
		category: "United States (Admin 2)"
	},
	"us-ut-all": {
		name: "UTAH",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ut-003)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. BE)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 49003)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Box Elder)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-ut-all",
		type: "us-admin2",
		source: "countries/us/us-ut-all",
		category: "United States (Admin 2)"
	},
	"us-va-all": {
		name: "VIRGINIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-va-510)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. AL)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 51510)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Alexandria)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-va-all",
		type: "us-admin2",
		source: "countries/us/us-va-all",
		category: "United States (Admin 2)"
	},
	"us-vt-all": {
		name: "VERMONT",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-vt-013)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. GI)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 50013)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Grand Isle)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-vt-all",
		type: "us-admin2",
		source: "countries/us/us-vt-all",
		category: "United States (Admin 2)"
	},
	"us-wa-all": {
		name: "WASHINGTON",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-wa-075)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. WH)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 53075)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Whitman)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-wa-all",
		type: "us-admin2",
		source: "countries/us/us-wa-all",
		category: "United States (Admin 2)"
	},
	"us-wi-all": {
		name: "WISCONSIN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-wi-111)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. SA)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 55111)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Sauk)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-wi-all",
		type: "us-admin2",
		source: "countries/us/us-wi-all",
		category: "United States (Admin 2)"
	},
	"us-wv-all": {
		name: "WEST VIRGINIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-wv-103)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. WE)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 54103)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Wetzel)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-wv-all",
		type: "us-admin2",
		source: "countries/us/us-wv-all",
		category: "United States (Admin 2)"
	},
	"us-wy-all": {
		name: "WYOMING",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-wy-011)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CR)"
		}, {
			name: "fips",
			caption: "FIPS Code (e.g. 56011)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Crook)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/us-wy-all",
		type: "us-admin2",
		source: "countries/us/us-wy-all",
		category: "United States (Admin 2)"
	},
	"us-ak-congress-113": {
		name: "ALASKA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ak-00)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 0200)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District (at Large))"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-ak-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-ak-congress-113",
		category: "United States (Admin 3)"
	},
	"us-al-congress-113": {
		name: "ALABAMA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-al-01)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 0101)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 1)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-al-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-al-congress-113",
		category: "United States (Admin 3)"
	},
	"us-ar-congress-113": {
		name: "ARKANSAS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ar-04)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 0504)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 4)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-ar-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-ar-congress-113",
		category: "United States (Admin 3)"
	},
	"us-as-congress-113": {
		name: "AMERICAN SAMOA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. as-6514-98)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 6098)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Delegate District (at Large))"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-as-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-as-congress-113",
		category: "United States (Admin 3)"
	},
	"us-az-congress-113": {
		name: "ARIZONA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-az-03)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 0403)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 3)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-az-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-az-congress-113",
		category: "United States (Admin 3)"
	},
	"us-ca-congress-113": {
		name: "CALIFORNIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ca-26)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 0626)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 26)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-ca-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-ca-congress-113",
		category: "United States (Admin 3)"
	},
	"us-co-congress-113": {
		name: "COLORADO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-co-01)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 0801)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 1)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-co-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-co-congress-113",
		category: "United States (Admin 3)"
	},
	"us-ct-congress-113": {
		name: "CONNECTICUT",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ct-05)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 0905)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 5)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-ct-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-ct-congress-113",
		category: "United States (Admin 3)"
	},
	"us-dc-congress-113": {
		name: "DISTRICT OF COLUMBIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-dc-98)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 1198)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Delegate District (at Large))"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-dc-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-dc-congress-113",
		category: "United States (Admin 3)"
	},
	"us-de-congress-113": {
		name: "DELAWARE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-de-00)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 1000)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District (at Large))"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-de-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-de-congress-113",
		category: "United States (Admin 3)"
	},
	"us-fl-congress-113": {
		name: "FLORIDA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-fl-16)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 1216)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 16)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-fl-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-fl-congress-113",
		category: "United States (Admin 3)"
	},
	"us-ga-congress-113": {
		name: "GEORGIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ga-01)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 1301)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 1)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-ga-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-ga-congress-113",
		category: "United States (Admin 3)"
	},
	"us-gu-congress-113": {
		name: "GUAM",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. gu-3605-98)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 6698)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Delegate District (at Large))"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-gu-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-gu-congress-113",
		category: "United States (Admin 3)"
	},
	"us-hi-congress-113": {
		name: "HAWAII",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-hi-02)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 1502)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 2)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-hi-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-hi-congress-113",
		category: "United States (Admin 3)"
	},
	"us-ia-congress-113": {
		name: "IOWA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ia-03)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 1903)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 3)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-ia-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-ia-congress-113",
		category: "United States (Admin 3)"
	},
	"us-id-congress-113": {
		name: "IDAHO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-id-02)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 1602)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 2)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-id-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-id-congress-113",
		category: "United States (Admin 3)"
	},
	"us-il-congress-113": {
		name: "ILLINOIS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-il-12)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 1712)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 12)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-il-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-il-congress-113",
		category: "United States (Admin 3)"
	},
	"us-in-congress-113": {
		name: "INDIANA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-in-08)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 1808)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 8)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-in-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-in-congress-113",
		category: "United States (Admin 3)"
	},
	"us-ks-congress-113": {
		name: "KANSAS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ks-02)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 2002)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 2)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-ks-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-ks-congress-113",
		category: "United States (Admin 3)"
	},
	"us-ky-congress-113": {
		name: "KENTUCKY",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ky-01)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 2101)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 1)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-ky-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-ky-congress-113",
		category: "United States (Admin 3)"
	},
	"us-la-congress-113": {
		name: "LOUISIANA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-la-01)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 2201)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 1)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-la-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-la-congress-113",
		category: "United States (Admin 3)"
	},
	"us-ma-congress-113": {
		name: "MASSACHUSETTS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ma-09)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 2509)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 9)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-ma-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-ma-congress-113",
		category: "United States (Admin 3)"
	},
	"us-md-congress-113": {
		name: "MARYLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-md-01)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 2401)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 1)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-md-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-md-congress-113",
		category: "United States (Admin 3)"
	},
	"us-me-congress-113": {
		name: "MAINE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-me-02)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 2302)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 2)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-me-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-me-congress-113",
		category: "United States (Admin 3)"
	},
	"us-mi-congress-113": {
		name: "MICHIGAN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-mi-01)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 2601)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 1)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-mi-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-mi-congress-113",
		category: "United States (Admin 3)"
	},
	"us-mn-congress-113": {
		name: "MINNESOTA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-mn-02)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 2702)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 2)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-mn-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-mn-congress-113",
		category: "United States (Admin 3)"
	},
	"us-mo-congress-113": {
		name: "MISSOURI",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-mo-01)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 2901)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 1)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-mo-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-mo-congress-113",
		category: "United States (Admin 3)"
	},
	"us-mp-congress-113": {
		name: "NORTHERN MARIANA ISLANDS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. mp-ni-98)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. DD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 6998)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Delegate District (at Large))"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-mp-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-mp-congress-113",
		category: "United States (Admin 3)"
	},
	"us-ms-congress-113": {
		name: "MISSISSIPPI",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ms-04)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 2804)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 4)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-ms-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-ms-congress-113",
		category: "United States (Admin 3)"
	},
	"us-mt-congress-113": {
		name: "MONTANA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-mt-00)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 3000)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District (at Large))"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-mt-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-mt-congress-113",
		category: "United States (Admin 3)"
	},
	"us-nc-congress-113": {
		name: "NORTH CAROLINA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-nc-03)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 3703)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 3)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-nc-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-nc-congress-113",
		category: "United States (Admin 3)"
	},
	"us-nd-congress-113": {
		name: "NORTH DAKOTA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-nd-00)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 3800)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District (at Large))"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-nd-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-nd-congress-113",
		category: "United States (Admin 3)"
	},
	"us-ne-congress-113": {
		name: "NEBRASKA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ne-02)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 3102)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 2)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-ne-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-ne-congress-113",
		category: "United States (Admin 3)"
	},
	"us-nh-congress-113": {
		name: "NEW HAMPSHIRE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-nh-01)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 3301)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 1)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-nh-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-nh-congress-113",
		category: "United States (Admin 3)"
	},
	"us-nj-congress-113": {
		name: "NEW JERSEY",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-nj-02)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 3402)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 2)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-nj-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-nj-congress-113",
		category: "United States (Admin 3)"
	},
	"us-nm-congress-113": {
		name: "NEW MEXICO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-nm-03)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 3503)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 3)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-nm-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-nm-congress-113",
		category: "United States (Admin 3)"
	},
	"us-nv-congress-113": {
		name: "NEVADA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-nv-03)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 3203)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 3)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-nv-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-nv-congress-113",
		category: "United States (Admin 3)"
	},
	"us-ny-congress-113": {
		name: "NEW YORK",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ny-11)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 3611)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 11)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-ny-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-ny-congress-113",
		category: "United States (Admin 3)"
	},
	"us-oh-congress-113": {
		name: "OHIO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-oh-13)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 3913)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 13)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-oh-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-oh-congress-113",
		category: "United States (Admin 3)"
	},
	"us-ok-congress-113": {
		name: "OKLAHOMA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ok-03)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 4003)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 3)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-ok-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-ok-congress-113",
		category: "United States (Admin 3)"
	},
	"us-or-congress-113": {
		name: "OREGON",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-or-04)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 4104)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 4)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-or-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-or-congress-113",
		category: "United States (Admin 3)"
	},
	"us-pa-congress-113": {
		name: "PENNSYLVANIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-pa-18)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 4218)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 18)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-pa-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-pa-congress-113",
		category: "United States (Admin 3)"
	},
	"us-pr-congress-113": {
		name: "PUERTO RICO",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. pr-3614-98)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. RC)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 7298)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Resident Commissioner District (at Large))"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-pr-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-pr-congress-113",
		category: "United States (Admin 3)"
	},
	"us-ri-congress-113": {
		name: "RHODE ISLAND",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ri-02)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 4402)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 2)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-ri-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-ri-congress-113",
		category: "United States (Admin 3)"
	},
	"us-sc-congress-113": {
		name: "SOUTH CAROLINA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-sc-01)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 4501)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 1)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-sc-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-sc-congress-113",
		category: "United States (Admin 3)"
	},
	"us-sd-congress-113": {
		name: "SOUTH DAKOTA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-sd-00)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 4600)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District (at Large))"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-sd-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-sd-congress-113",
		category: "United States (Admin 3)"
	},
	"us-tn-congress-113": {
		name: "TENNESSEE",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-tn-02)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 4702)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 2)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-tn-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-tn-congress-113",
		category: "United States (Admin 3)"
	},
	"us-tx-congress-113": {
		name: "TEXAS",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-tx-34)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 4834)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 34)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-tx-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-tx-congress-113",
		category: "United States (Admin 3)"
	},
	"us-ut-congress-113": {
		name: "UTAH",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-ut-04)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 4904)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 4)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-ut-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-ut-congress-113",
		category: "United States (Admin 3)"
	},
	"us-va-congress-113": {
		name: "VIRGINIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-va-02)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 5102)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 2)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-va-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-va-congress-113",
		category: "United States (Admin 3)"
	},
	"us-vt-congress-113": {
		name: "VERMONT",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-vt-00)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 5000)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District (at Large))"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-vt-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-vt-congress-113",
		category: "United States (Admin 3)"
	},
	"us-wa-congress-113": {
		name: "WASHINGTON",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-wa-07)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 5307)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 7)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-wa-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-wa-congress-113",
		category: "United States (Admin 3)"
	},
	"us-wi-congress-113": {
		name: "WISCONSIN",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-wi-08)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 5508)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 8)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-wi-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-wi-congress-113",
		category: "United States (Admin 3)"
	},
	"us-wv-congress-113": {
		name: "WEST VIRGINIA",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-wv-01)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 5401)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District 1)"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-wv-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-wv-congress-113",
		category: "United States (Admin 3)"
	},
	"us-wy-congress-113": {
		name: "WYOMING",
		formats: [{
			name: "hc-key",
			caption: "Geo Key (e.g. us-wy-00)"
		}, {
			name: "hc-a2",
			caption: "Postal Code (e.g. CD)"
		}, {
			name: "geoid",
			caption: "GeoID (e.g. 5600)"
		}, {
			name: "name",
			caption: "Full Name (e.g. Congressional District (at Large))"
		}],
		offline: !1,
		drilldown: 1,
		obj: "countries/us/custom/us-wy-congress-113",
		type: "us-admin3",
		source: "countries/us/custom/us-wy-congress-113",
		category: "United States (Admin 3)"
	}
};